//Copyright (c) 2005, Steven Michaud, All Rights Reserved
//
//Permission is hereby granted, free of charge, to any person obtaining
//a copy of this software and associated documentation files (the
//"Software"), to deal in the Software without restriction, including
//without limitation the rights to use, copy, modify, merge, publish,
//distribute, sublicense, and/or sell copies of the Software, and to
//permit persons to whom the Software is furnished to do so, subject to
//the following conditions:
//
//The above copyright notice and this permission notice shall be
//included in all copies or substantial portions of the Software.
//
//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
//MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
//IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
//CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
//TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
//SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

package jep;

import java.io.*;
import java.net.*;
import netscape.javascript.JSObject;
import sun.plugin.viewer.context.DefaultPluginAppletContext;

public class AppletFrameContext extends DefaultPluginAppletContext {
	protected static boolean showDebugInfo = false;
	protected AppletFrame frame = null;

	public AppletFrameContext(AppletFrame appletFrame) {
		if (showDebugInfo) {
			System.err.println("Calling AppletFrameContext(): " +
				"appletFrame (" + ((appletFrame == null) ? "null" : appletFrame.toString()) + ")");
		}
		frame = appletFrame;
	}

	private native void showDocument(long cocoaParentView, String url,
		String windowName);

	public void showDocument(URL url, String windowName) {
		if (frame.destroying)
			return;
		long cocoaParentView = frame.getCocoaParentViewLong();
		showDocument(cocoaParentView, url.toString(), windowName);
	}

	public void showDocument(URL url) {
		showDocument(url, null);
	}

	private native void showStatus(long cocoaParentView, String statusMessage);

	public void showStatus(String statusMessage) {
		if (frame.destroying)
			return;
		long cocoaParentView = frame.getCocoaParentViewLong();
		showStatus(cocoaParentView, statusMessage);
	}

	public void setAppletContextHandle(int handle) {
	}

	public void setAppletContextHandle(long handle) {
	}

	public JSObject getJSObject() {
		return nativeGetJSObject(frame.getPluginInstance());
	}

	private native JSObject nativeGetJSObject(int pluginInstance);

	public String toString() {
		return getClass().getName() + " (jep)";
	}

	static {
		if ("true".equalsIgnoreCase(System.getProperty("jep.debuginfo", "false"))) {
			showDebugInfo = true;
		}
	}

}

