//Copyright (c) 2005, Steven Michaud, All Rights Reserved
//
//Permission is hereby granted, free of charge, to any person obtaining
//a copy of this software and associated documentation files (the
//"Software"), to deal in the Software without restriction, including
//without limitation the rights to use, copy, modify, merge, publish,
//distribute, sublicense, and/or sell copies of the Software, and to
//permit persons to whom the Software is furnished to do so, subject to
//the following conditions:
//
//The above copyright notice and this permission notice shall be
//included in all copies or substantial portions of the Software.
//
//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
//MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
//IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
//CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
//TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
//SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

package apple.awt;

import jep.*;
import java.awt.*;
import sun.java2d.pipe.*;
import sun.java2d.SunGraphics2D;
import sun.java2d.SurfaceData;

public class GraphicsClipper142 extends GraphicsClipper {

	public static GraphicsClipper createNew(SunGraphics2D graphics,
		 AppletFrame ancestor, ComponentModel peer)
	{
		return new GraphicsClipper142(graphics, ancestor, peer);
	}

	public GraphicsClipper142(SunGraphics2D graphics, AppletFrame ancestor,
		ComponentModel peer)
	{
		super(graphics, ancestor, peer);
	}

	public Rectangle getDevClip() {
		SunGraphics2D g = (SunGraphics2D) graphics.get();
		if (g == null)
			return new Rectangle();
		return new Rectangle(g.devClip.getLoX(), g.devClip.getLoY(),
			g.devClip.getWidth(), g.devClip.getHeight());
	}

}

