//Copyright (c) 2006, Steven Michaud, All Rights Reserved
//
//Permission is hereby granted, free of charge, to any person obtaining
//a copy of this software and associated documentation files (the
//"Software"), to deal in the Software without restriction, including
//without limitation the rights to use, copy, modify, merge, publish,
//distribute, sublicense, and/or sell copies of the Software, and to
//permit persons to whom the Software is furnished to do so, subject to
//the following conditions:
//
//The above copyright notice and this permission notice shall be
//included in all copies or substantial portions of the Software.
//
//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
//MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
//IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
//CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
//TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
//SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

package sun.plugin.services;

import java.io.File;
import java.security.SecureRandom;
import java.security.Security;
import sun.plugin.net.cookie.CookieHandler;
import sun.plugin.net.cookie.JEPCookieHandler14X;
import sun.plugin.net.proxy.BrowserProxyConfig;
import sun.plugin.net.proxy.MacOSXProxyConfig;
import sun.plugin.viewer.context.PluginAppletContext;
import sun.plugin.viewer.context.PluginBeansContext;
import jep.AppletHandlerFactory;

public class JEPBrowserService142 implements BrowserService {

	public JEPBrowserService142() {
	}

	public CookieHandler getCookieHandler() {
		return new JEPCookieHandler14X();
	}

	public BrowserProxyConfig getProxyConfig() {
		//System.out.println("JEPBrowserService142.getProxyConfig()");
		return new MacOSXProxyConfig();
	}

	public PluginAppletContext getAppletContext() {
		PluginAppletContext context = null;
		if (AppletHandlerFactory.isJava142Update1()) {
			try {
				context = (PluginAppletContext) Class.
					forName("sun.plugin.viewer.context.WebKitAppletContext").
					newInstance();
			} catch (Throwable e) {
			}
		}
		//System.out.println("JEPBrowserService142.getAppletContext(): returning " +
		//	((context == null) ? "null" : context.toString()));
		return context;
	}

	public PluginBeansContext getBeansContext() {
		PluginBeansContext context = null;
		if (AppletHandlerFactory.isJava142Update1()) {
			try {
				context = new PluginBeansContext();
				PluginAppletContext appletContext = (PluginAppletContext) Class.
					forName("sun.plugin.viewer.context.WebKitAppletContext").
					newInstance();
				context.setPluginAppletContext(appletContext);
			} catch (Throwable e) {
			}
		}
		//System.out.println("JEPBrowserService142.getBeansContext(): returning " +
		//	((context == null) ? "null" : context.toString()));
		return context;
	}

	public boolean isIExplorer() {
		//System.out.println("JEPBrowserService142.isIExplorer()");
		if (AppletHandlerFactory.isJava142Update1()) {
			return false;
		} else {
			return true;
		}
	}

	public boolean isNetscape() {
		//System.out.println("JEPBrowserService142.isNetscape()");
		return false;
	}

	public float getBrowserVersion() {
		//System.out.println("JEPBrowserService142.getBrowserVersion()");
		if (AppletHandlerFactory.isJava142Update1()) {
			return 0F;
		} else {
			return 5F;
		}
	}

	public SecureRandom getSecureRandom() {
		//System.out.println("JEPBrowserService142.getSecureRandom()");
		try {
			File randomFile = new File("/dev/urandom");
			if ((randomFile != null) && randomFile.exists())
				Security.setProperty("securerandom.source", "file:/dev/urandom");
		} catch(Throwable e) {
		}
		return new SecureRandom();
	}

	public boolean isConsoleIconifiedOnClose() {
		//System.out.println("JEPBrowserService142.isConsoleIconifiedOnClose()");
		return true;
	}

	public boolean installBrowserEventListener() {
		//System.out.println("JEPBrowserService142.installBrowserEventListener()");
		return true;
	}

	public BrowserAuthenticator getBrowserAuthenticator() {
		//System.out.println("JEPBrowserService142.getBrowserAuthenticator()");
		return null;
	}
}
