//Copyright (c) 2006, Steven Michaud, All Rights Reserved
//
//Permission is hereby granted, free of charge, to any person obtaining
//a copy of this software and associated documentation files (the
//"Software"), to deal in the Software without restriction, including
//without limitation the rights to use, copy, modify, merge, publish,
//distribute, sublicense, and/or sell copies of the Software, and to
//permit persons to whom the Software is furnished to do so, subject to
//the following conditions:
//
//The above copyright notice and this permission notice shall be
//included in all copies or substantial portions of the Software.
//
//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
//MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
//IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
//CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
//TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
//SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

package sun.plugin.services;

import com.sun.deploy.net.cookie.CookieHandler;
import com.sun.deploy.net.cookie.JEPCookieHandler150;
import com.sun.deploy.net.proxy.ProxyHandler;
import com.sun.deploy.services.MacOSXPlatformService;
import sun.plugin.net.proxy.PluginAutoProxyHandler;
import sun.plugin.viewer.context.PluginAppletContext;
import sun.plugin.viewer.context.PluginBeansContext;
import sun.plugin.viewer.context.WebKitAppletContext;

public class JEPBrowserService150 extends MacOSXPlatformService
	implements BrowserService
{

	public JEPBrowserService150() {
	}

	public CookieHandler getCookieHandler() {
		return new JEPCookieHandler150();
	}

	public PluginAppletContext getAppletContext() {
		//System.out.println("JEPBrowserService150.getAppletContext()");
		return new WebKitAppletContext();
	}

	public PluginBeansContext getBeansContext() {
		//System.out.println("JEPBrowserService150.getBeansContext()");
		PluginBeansContext context = new PluginBeansContext();
		context.setPluginAppletContext(new WebKitAppletContext());
		return context;
	}

	public ProxyHandler getAutoProxyHandler() {
		//System.out.println("JEPBrowserService150.getAutoProxyHandler()");
		return new PluginAutoProxyHandler();
	}

	public float getBrowserVersion() {
		//System.out.println("JEPBrowserService150.getBrowserVersion()");
		return 0.0F;
	}

	public boolean isConsoleIconifiedOnClose() {
		//System.out.println("JEPBrowserService150.isConsoleIconifiedOnClose()");
		return true;
	}

	public boolean installBrowserEventListener() {
		//System.out.println("JEPBrowserService150.installBrowserEventListener()");
		return true;
	}

	public String mapBrowserElement(String rawName) {
		//System.out.println("JEPBrowserService150.mapBrowserElement()");
		return rawName;
	}
}
