//Copyright (c) 2006, Steven Michaud, All Rights Reserved
//
//Permission is hereby granted, free of charge, to any person obtaining
//a copy of this software and associated documentation files (the
//"Software"), to deal in the Software without restriction, including
//without limitation the rights to use, copy, modify, merge, publish,
//distribute, sublicense, and/or sell copies of the Software, and to
//permit persons to whom the Software is furnished to do so, subject to
//the following conditions:
//
//The above copyright notice and this permission notice shall be
//included in all copies or substantial portions of the Software.
//
//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
//MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
//IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
//CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
//TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
//SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

// Replacement for the cookie handler that normally gets used by Apple's JVM
// (which only works with WebKit-based browsers like Safari).  This class
// currently only works with Mozilla.org browsers.  In order to be able to use
// this class, we also need to replace Apple's ServiceProvider and use our own
// "browser service" classes.

package sun.plugin.net.cookie;

import sun.plugin.services.ServiceUnavailableException;
import sun.plugin.viewer.AppletPanelCache;

public class JEPCookieHandler14X implements CookieHandler {

	public JEPCookieHandler14X() {
	}

	public void setCookieInfo(String url, String value)
		throws ServiceUnavailableException
	{
		if (!cookiesSupported() || !AppletPanelCache.hasValidInstance()) {
			throw new ServiceUnavailableException("Cookie service is not available for " + url);
		} else {
			setCookie(url, value);
		}
	}

	public String getCookieInfo(String url)
		throws ServiceUnavailableException
	{
		if (!cookiesSupported() || !AppletPanelCache.hasValidInstance()) {
			throw new ServiceUnavailableException("Cookie service is not available for " + url);
		} else {
			return getCookie(url);
		}
	}

	private native boolean cookiesSupported();
	private native void setCookie(String url, String value);
	private native String getCookie(String url);

}
