//Copyright (c) 2006, Steven Michaud, All Rights Reserved
//
//Permission is hereby granted, free of charge, to any person obtaining
//a copy of this software and associated documentation files (the
//"Software"), to deal in the Software without restriction, including
//without limitation the rights to use, copy, modify, merge, publish,
//distribute, sublicense, and/or sell copies of the Software, and to
//permit persons to whom the Software is furnished to do so, subject to
//the following conditions:
//
//The above copyright notice and this permission notice shall be
//included in all copies or substantial portions of the Software.
//
//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
//MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
//IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
//CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
//TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
//SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

// See reflectScrolledClipView_AWTSV() in AppletView.m and MyCToolkit.
// setScrollPanePosition() for why this class is needed.

package apple.awt;

import jep.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;
import sun.awt.RepaintArea;
import sun.java2d.SunGraphics2D;
import sun.java2d.SurfaceData;

public class MyCScrollPane extends CScrollPane {
	protected static boolean showDebugInfo = false;
	protected AppletFrame ancestor = null;
	protected boolean skipNextScrollView = false;

	public MyCScrollPane(ScrollPane scrollpane) {
		super(scrollpane);
		if (showDebugInfo) {
			System.err.println("Called MyCScrollPane(): " +
				"ScrollPane (" + ((scrollpane == null) ? "null" : scrollpane.toString()) + ")");
		}
	}

	public void setAncestor(AppletFrame frame) {
		ancestor = frame;
	}

	public boolean readSkipNextScrollView() {
		boolean retval = skipNextScrollView;
		skipNextScrollView = false;
		return retval;
	}

	public void setSkipNextScrollView() {
		skipNextScrollView = true;
	}

	public String toString() {
		return getClass().getName() + " (jep)";
	}

	static {
		if ("true".equalsIgnoreCase(System.getProperty("jep.debuginfo", "false"))) {
			showDebugInfo = true;
		}
	}

}

