/*
 * Copyright (c) 2004, Steven Michaud, All Rights Reserved
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#import "Controller.h"

static BOOL nsAppActive = TRUE;
static tsmAEHandlerInfo parentTSMAEHandlerInfo = {0};
static AEEventHandlerUPP ourTSMAEHandlerUPP = nil;
static EventHandlerUPP appHandlerUPP = nil;
static EventHandlerRef appHandlerRef = nil;
static AEEventHandlerUPP quitAEHandlerUPP = nil;

Class cPerformerClass = nil;
Class cScrollPaneClass = nil;
Class appletWindowClass = nil;
Class carbonWindowClass = nil;
static Class carbonWindowClassPoser = nil;
static Class carbonWindowViewClass = nil;
static Class carbonWindowViewClassPoser = nil;
static Class carbonWindowFrameClass = nil;
static Class carbonWindowFrameClassPoser = nil;
static Class awtViewClass = nil;
static Class awtViewClassPoser = nil;
static Class tsmInputClass = nil;
static Class tsmInputClassPoser = nil;
static Class cTextFieldClass = nil;
static Class cTextFieldClassPoser = nil;
static Class cWindowClass = nil;
static Class cWindowClassPoser = nil;
static Class cAppletWindowClass = nil;
static Class cAppletWindowClassPoser = nil;
static Class cEmbeddedClass = nil;
static Class cEmbeddedClassPoser = nil;
static Class eventFactoryClass = nil;
static Class eventFactoryClassPoser = nil;
static Class focusManagerClass = nil;
static Class focusManagerClassPoser = nil;
static Class threadUtilitiesClass = nil;
static Class threadUtilitiesClassPoser = nil;
static Class awtModelUpdaterClass = nil;
static Class awtModelUpdaterClassPoser = nil;
static Class controlModelClass = nil;
static Class controlModelClassPoser = nil;
static Class awtButtonClass = nil;
static Class awtButtonClassPoser = nil;
static Class scrollerClass = nil;
static Class scrollerClassPoser = nil;
static Class awtScrollViewClass = nil;
static Class awtScrollViewClassPoser = nil;
static Class awtChoiceClass = nil;
static Class awtChoiceClassPoser = nil;
static Class awtTableViewClass = nil;
static Class awtTableViewClassPoser = nil;
static Class awtTextFieldClass = nil;
static Class awtTextFieldClassPoser = nil;
static Class awtTextViewClass = nil;
static Class awtTextViewClassPoser = nil;
static Class awtTextFieldFocusClass = nil;
static Class awtTextFieldFocusClassPoser = nil;
static Class awtWindowViewClass = nil;
static Class awtWindowViewClassPoser = nil;
static Class awtCombTextFieldClass = nil;
static Class awtCombTextFieldClassPoser = nil;
static Class awtCombTextFieldCellClass = nil;
static Class awtCombTextFieldCellClassPoser = nil;
static Class awtCombTextViewClass = nil;
static Class awtCombTextViewClassPoser = nil;
Class awtViewContextClass = nil;
static Class awtViewContextClassPoser = nil;
static Class awtDrawableCtxManagerClass = nil;
static Class awtDrawableCtxManagerClassPoser = nil;
static Class awtStarterClass = nil;
static Class awtStarterClassPoser = nil;
static Class startupUtilityClass = nil;
static Class startupUtilityClassPoser = nil;
static Class awtExceptionClass = nil;
static Class awtExceptionClassPoser = nil;
static Class cPopupMenuClass = nil;
static Class cPopupMenuClassPoser = nil;
static Class syntheticEventClass = nil;
static Class syntheticEventClassPoser = nil;

static pascal OSStatus HandleDispatcher(EventHandlerCallRef nextHandler,
	EventRef theEvent, void *userData);
static pascal OSStatus HandleWindow(EventHandlerCallRef nextHandler,
	EventRef theEvent, void *userData);
static pascal OSStatus HandleApp(EventHandlerCallRef nextHandler,
	EventRef theEvent, void *userData);
static pascal OSErr HandleAEQuit(const AppleEvent *theAppleEvent,
	AppleEvent *reply, SInt32 handlerRefcon);
static pascal OSStatus HandleTSM(EventHandlerCallRef nextHandler,
	EventRef theEvent, void *userData);
static pascal OSErr HandleAETSM(const AppleEvent *theAppleEvent, AppleEvent *reply,
	SInt32 handlerRefcon);

static BOOL PoseAsUndocumentedClass(char *originalClass, char *posingClass,
	Class *classRef, Class *posingClassRef, struct objc_method_list *instanceMethods,
	struct objc_method_list *classMethods);

static OSStatus handleMouseDownEvent_CW(id self, SEL sel, EventRef theEvent,
	Point point, WindowPartCode part, UInt32 modifiers);
static void handleCarbonBoundsChange_CW(id self, SEL sel);
static void close_CW(id self, SEL sel);
static void sendEvent_CW(id self, SEL sel, NSEvent *theEvent);
static void display_CW(id self, SEL sel);
static void resignKeyWindow_CW(id self, SEL sel);
static void becomeKeyWindow_CW(id self, SEL sel);
static void resignMainWindow_CW(id self, SEL sel);
static void becomeMainWindow_CW(id self, SEL sel);

static BOOL isFlipped_CWV(id self, SEL sel);
static void drawRect_CWV(id self, SEL sel, NSRect aRect);

static BOOL isFlipped_CWF(id self, SEL sel);
static id contentFill_CWF(id self, SEL sel);
static void setFrameSize_CWF(id self, SEL sel, NSSize newSize);

static void drawRect_AWT(id self, SEL sel, NSRect aRect);
static BOOL lockFocusIfCanDraw_AWT(id self, SEL sel);
static void unlockFocus_AWT(id self, SEL sel);
static BOOL canDraw_AWT(id self, SEL sel);
static void mouseMovedAWT_AWT(id self, SEL sel, id event);
static void insertText_AWT(id self, SEL sel, NSString *text);
static void viewDidEndLiveResize_AWTWV(id self, SEL sel);

static BOOL _activate_TSMIC(id self, SEL sel);

static void setText_CTF(id self, SEL sel, id text);
static void setJavaText_CTF(id self, SEL sel, id text);
static void _setNativeText_CTF(id self, SEL sel, id text);

static BOOL isModal_AWTCW(id self, SEL sel);
static BOOL isModal2_AWTCW(id self, SEL sel, JNIEnv *env);

static void cleanup_AWTCAW(id self, SEL sel);
static id initWithPeer_AWTCAW(id self, SEL sel, jobject peer,
	jobject component, id screen, NSRect aRect, int style, id parent,
	BOOL asDialog, const char *title, BOOL lock, id parentView);
static id initWithPeer2_AWTCAW(id self, SEL sel, jobject peer,
	jobject component, id screen, NSRect aRect, long style, id parent,
	BOOL asDialog, const char *title, BOOL lock, id parentView, JNIEnv *env);
static void dealloc_AWTCAW(id self, SEL sel);
static void syncFromJava_AWTCAW(id self, SEL sel, JNIEnv *env);
static void windowDidBecomeKey_AWTCAW(id self, SEL sel, id aNotification);
static void setState_AWTCAW(id self, SEL sel, BOOL state, BOOL visible);
static void setState2_AWTCAW(id self, SEL sel, BOOL state, BOOL visible, JNIEnv *env);

static void cleanup_AWTCE(id self, SEL sel);
static id initWithPeer_AWTCE(id self, SEL sel, jobject peer, id parentView,
	JNIEnv *env, jobject byteParms);
static id initWithPeer2_AWTCE(id self, SEL sel, jobject peer, id parentView,
	BOOL focusable, JNIEnv *env, jobject byteParms);
static id hostWindow_AWTCE(id self, SEL sel, id parentView);

static void forwardEvent_EF(id self, SEL sel, id anEvent, id toTarget);

static void viewBecameKey_FM(id self, SEL sel, id cWindow, JNIEnv *env);
static void viewResignedKey_FM(id self, SEL sel, id cWindow, JNIEnv *env);
static BOOL becomeFirstResponder_FM(id self, SEL sel, id aModel,
	id previousFirstResponder, BOOL superResponse, JNIEnv *env);
static BOOL becomeFirstResponder2_FM(id self, SEL sel, id aModel,
	BOOL superResponse, JNIEnv *env);
static BOOL becomeFirstResponder3_FM(id self, SEL sel, id aModel,
	BOOL superResponse);

static void registerModelForUpdate_TU(id self, SEL sel, id model);
static void updateModels_TU(id self, SEL sel, id unknown);
static void performOnMainThread_TU(id self, SEL sel, SEL aSelector, id target,
	id object, BOOL waitUntilDone, BOOL awtMode);

static void markAsDirty_CM(id self, SEL sel);
static void setDraggingDestination_CM(id self, SEL sel, id dropTarget);
static void _setNativeFrame_CM(id self, SEL sel, NSRect aRect, id forView);
static void updateFrame_CM(id self, SEL sel, JNIEnv *env);
static void updateFrame2_CM(id self, SEL sel);

static void drawRect_AWTBN(id self, SEL sel, NSRect aRect);

static void drawRect_SC(id self, SEL sel, NSRect aRect);
static BOOL isOpaque_SC(id self, SEL sel);

static void drawRect_AWTSV(id self, SEL sel, NSRect aRect);
static void reflectScrolledClipView_AWTSV(id self, SEL sel, id aClipView);

static void drawRect_AWTCH(id self, SEL sel, NSRect aRect);

static void drawRect_AWTTBV(id self, SEL sel, NSRect aRect);

static void drawRect_AWTTF(id self, SEL sel, NSRect aRect);
static BOOL isOpaque_AWTTF(id self, SEL sel);

static void drawRect_AWTTV(id self, SEL sel, NSRect aRect);

static void drawRect_AWTTFF(id self, SEL sel, NSRect aRect);

static void drawRect_AWTWV(id self, SEL sel, NSRect aRect);
static void viewDidEndLiveResize_AWTWV(id self, SEL sel);
static void viewWillStartLiveResize_AWTWV(id self, SEL sel);

static void drawRect_AWTCTF(id self, SEL sel, NSRect aRect);
static BOOL isOpaque_AWTCTF(id self, SEL sel);

static void drawRect_AWTCTFC(id self, SEL sel, NSRect aRect);

static void drawRect_AWTCTV(id self, SEL sel, NSRect aRect);
static void setAWTDelegate_AWTCTV(id self, SEL sel, id anObject);
static void setDelegate_AWTCTV(id self, SEL sel, id anObject);

static void tickFlusher_AWTCTX(id self, SEL sel);

static CGContextRef getContext_ADCM(id self, SEL sel, char *unknown,
	BOOL canDrawDuringLiveResize);

static void start_AWTST(id self, SEL sel, BOOL whatever);

static void beginApp_SU(id self, SEL sel);

static id autorelease_AWTEX(id self, SEL sel);

static void safeShowAtSpot_CPM(id self, SEL sel, id unused);
static void setComponent_CPM(id self, SEL sel, id aComponent);

static unsigned short keyCode_SE(id self, SEL sel);

Boolean EqualRectFuzzy(Rect rectA, Rect rectB, int fuzzFactor)
{
	short widthA, widthB, widthDiff;
	short heightA, heightB, heightDiff;
	short topDiff, leftDiff, bottomDiff, rightDiff;

	if ((topDiff = rectA.top - rectB.top) < 0)
		topDiff = -topDiff;
	if ((leftDiff = rectA.left - rectB.left) < 0)
		leftDiff = -leftDiff;
	if ((bottomDiff = rectA.bottom - rectB.bottom) < 0)
		bottomDiff = -bottomDiff;
	if ((rightDiff = rectA.right - rectB.right) < 0)
		rightDiff = -rightDiff;

	if ((topDiff > fuzzFactor) || (leftDiff > fuzzFactor) ||
		(bottomDiff > fuzzFactor) || (rightDiff > fuzzFactor))
		return false;

	if ((widthA = rectA.right - rectA.left) < 0)
		return false;
	if ((widthB = rectB.right - rectB.left) < 0)
		return false;
	if ((widthDiff = widthA - widthB) < 0)
		widthDiff = -widthDiff;

	if ((heightA = rectA.bottom - rectA.top) < 0)
		return false;
	if ((heightB = rectB.bottom - rectB.top) < 0)
		return false;
	if ((heightDiff = heightA - heightB) < 0)
		heightDiff = -heightDiff;

	if ((widthDiff > fuzzFactor) || (heightDiff > fuzzFactor))
		return false;

	return true;
}

/* To keep things simple we treat rectA and rectB as if they both are
 * "flipped" (have a top-left origin).  But we'll get the same results even
 * if both are "non-flipped" (have a bottom-left origin).  The comparison
 * will only be invalid if one is "flipped" and the other is "non-flipped".
 */
BOOL EqualNSRectFuzzy(NSRect rectA, NSRect rectB, int fuzzFactor)
{
	Rect rect1, rect2;
	rect1.left = rectA.origin.x;
	rect1.top = rectA.origin.y;
	rect1.right = rect1.left + rectA.size.width;
	rect1.bottom = rect1.top + rectA.size.height;
	rect2.left = rectB.origin.x;
	rect2.top = rectB.origin.y;
	rect2.right = rect2.left + rectB.size.width;
	rect2.bottom = rect2.top + rectB.size.height;
	return EqualRectFuzzy(rect1, rect2, fuzzFactor);
}

/* Does rectA contain rectB? */
Boolean ContainsRectFuzzy(Rect rectA, Rect rectB, int fuzzFactor)
{
	short widthA, widthB;
	short heightA, heightB;

	if ((widthA = rectA.right - rectA.left) < 0)
		return false;
	if ((widthB = rectB.right - rectB.left) < 0)
		return false;
	if ((heightA = rectA.bottom - rectA.top) < 0)
		return false;
	if ((heightB = rectB.bottom - rectB.top) < 0)
		return false;

	if (rectB.left + fuzzFactor < rectA.left)
		return false;
	if (rectB.left >= rectA.right + fuzzFactor)
		return false;
	if (rectB.top + fuzzFactor < rectA.top)
		return false;
	if (rectB.top >= rectA.bottom + fuzzFactor)
		return false;

	if (rectB.left + widthB > rectA.left + widthA + fuzzFactor)
		return false;
	if (rectB.top + heightB > rectA.top + heightA + fuzzFactor)
		return false;

	return true;
}

/* Does rectA contain rectB?  To keep things simple we treat rectA and rectB
 * as if they both are "flipped" (have a top-left origin).  But we'll get the
 * same results even if both are "non-flipped" (have a bottom-left origin).
 * The comparison will only be invalid if one is "flipped" and the other is
 * "non-flipped".
 */
BOOL ContainsNSRectFuzzy(NSRect rectA, NSRect rectB, int fuzzFactor)
{
	Rect rect1, rect2;
	rect1.left = rectA.origin.x;
	rect1.top = rectA.origin.y;
	rect1.right = rect1.left + rectA.size.width;
	rect1.bottom = rect1.top + rectA.size.height;
	rect2.left = rectB.origin.x;
	rect2.top = rectB.origin.y;
	rect2.right = rect2.left + rectB.size.width;
	rect2.bottom = rect2.top + rectB.size.height;
	return ContainsRectFuzzy(rect1, rect2, fuzzFactor);
}

Boolean SectRectFuzzy(Rect rectA, Rect rectB, Rect *intersection,
	int fuzzFactor)
{
	Rect intersect = {0};
	short width, height;
	if (intersection)
		*intersection = intersect;
	if (rectA.bottom - rectA.top <= 0)
		return false;
	if (rectA.right - rectA.left <= 0)
		return false;
	if (rectB.bottom - rectB.top <= 0)
		return false;
	if (rectB.right - rectB.left <= 0)
		return false;
	rectA.top -= fuzzFactor;
	rectA.bottom += fuzzFactor;
	rectA.left -= fuzzFactor;
	rectA.right += fuzzFactor;
	rectB.top -= fuzzFactor;
	rectB.bottom += fuzzFactor;
	rectB.left -= fuzzFactor;
	rectB.right += fuzzFactor;
	intersect.top = (rectA.top >= rectB.top) ? rectA.top : rectB.top;
	intersect.bottom = (rectA.bottom <= rectB.bottom) ? rectA.bottom : rectB.bottom;
	intersect.left = (rectA.left >= rectB.left) ? rectA.left : rectB.left;
	intersect.right = (rectA.right <= rectB.right) ? rectA.right : rectB.right;
	if ((width = intersect.right - intersect.left) <= 0)
		return false;
	if ((height = intersect.bottom - intersect.top) <= 0)
		return false;
	if ((width <= fuzzFactor*2) || (height <= fuzzFactor*2))
		return false;
	if (intersection)
		*intersection = intersect;
	return true;
}

/* To keep things simple we treat rectA and rectB as if they both are
 * "flipped" (have a top-left origin).  But we'll get the same results even
 * if both are "non-flipped" (have a bottom-left origin).  The operation
 * will only be invalid if one is "flipped" and the other is "non-flipped".
 */
BOOL SectNSRectFuzzy(NSRect rectA, NSRect rectB, NSRect *intersection,
	int fuzzFactor)
{
	BOOL retval;
	Rect rect1, rect2;
	Rect intersect = {0};
	if (intersection)
		*intersection = NSZeroRect;
	rect1.left = rectA.origin.x;
	rect1.top = rectA.origin.y;
	rect1.right = rect1.left + rectA.size.width;
	rect1.bottom = rect1.top + rectA.size.height;
	rect2.left = rectB.origin.x;
	rect2.top = rectB.origin.y;
	rect2.right = rect2.left + rectB.size.width;
	rect2.bottom = rect2.top + rectB.size.height;
	retval = SectRectFuzzy(rect1, rect2, &intersect, fuzzFactor);
	if (retval && intersection) {
		*intersection = NSMakeRect(intersect.left, intersect.top,
			intersect.right - intersect.left, intersect.bottom - intersect.top);
	}
	return retval;
}

/* Subtracts rectB from rectA.  "results" needs to have room for four Rects.
 * Returns "true" if results are different from rectA (though if rectB equals
 * rectA they'll be zero).
 */
Boolean DiffRect(Rect rectA, Rect rectB, unsigned *numResults, Rect *results,
	int fuzzFactor)
{
	unsigned count;
	Rect intersect = {0};
	Rect resultLeft = {0};
	Rect resultTop = {0};
	Rect resultRight = {0};
	Rect resultBottom = {0};

	if (!numResults || !results)
		return false;
	*numResults = 0;
	memset(results, 0, 4 * sizeof(Rect));

	if (!SectRectFuzzy(rectA, rectB, &intersect, fuzzFactor)) {
		*numResults = 1;
		results[0] = rectA;
		return false;
	}
	if ((rectA.left == intersect.left) && (rectA.top == intersect.top) &&
		(rectA.right == intersect.right) && (rectA.bottom == intersect.bottom))
		return true;

	if (intersect.left > rectA.left) {
		resultLeft.left = rectA.left;
		resultLeft.right = intersect.left;
		resultLeft.top = rectA.top;
		resultLeft.bottom = rectA.bottom;
	}
	if (intersect.top > rectA.top) {
		resultTop.top = rectA.top;
		resultTop.bottom = intersect.top;
		resultTop.left = (resultLeft.right ? resultLeft.right : rectA.left);
		resultTop.right = rectA.right;
	}
	if (intersect.right < rectA.right) {
		resultRight.left = intersect.right;
		resultRight.right = rectA.right;
		resultRight.top = (resultTop.bottom ? resultTop.bottom : rectA.top);
		resultRight.bottom = rectA.bottom;
	}
	if (intersect.bottom < rectA.bottom) {
		resultBottom.top = intersect.bottom;
		resultBottom.bottom = rectA.bottom;
		resultBottom.left = (resultLeft.right ? resultLeft.right : rectA.left);
		resultBottom.right = (resultRight.left ? resultRight.left : rectA.right);
	}

	count = 0;
	if (!EmptyRect(&resultLeft)) {
		results[count] = resultLeft;
		++count;
	}
	if (!EmptyRect(&resultTop)) {
		results[count] = resultTop;
		++count;
	}
	if (!EmptyRect(&resultRight)) {
		results[count] = resultRight;
		++count;
	}
	if (!EmptyRect(&resultBottom)) {
		results[count] = resultBottom;
		++count;
	}
	*numResults = count;

	return true;
}

/* To keep things simple we treat rectA and rectB as if they both are
 * "flipped" (have a top-left origin).  But we'll get the same results even
 * if both are "non-flipped" (have a bottom-left origin).  The operation
 * will only be invalid if one is "flipped" and the other is "non-flipped".
 */
BOOL DiffNSRect(NSRect rectA, NSRect rectB, unsigned *numResults,
	NSRect *results, int fuzzFactor)
{
	BOOL retval;
	unsigned i;
	Rect rect1, rect2;
	Rect resultsQD[4] = {{0}};
	unsigned numResultsQD = 0;
	if (!numResults || !results)
		return false;
	rect1.left = rectA.origin.x;
	rect1.top = rectA.origin.y;
	rect1.right = rect1.left + rectA.size.width;
	rect1.bottom = rect1.top + rectA.size.height;
	rect2.left = rectB.origin.x;
	rect2.top = rectB.origin.y;
	rect2.right = rect2.left + rectB.size.width;
	rect2.bottom = rect2.top + rectB.size.height;
	retval = DiffRect(rect1, rect2, &numResultsQD, resultsQD, fuzzFactor);
	if (numResultsQD > 4)	// Should never happen
		numResultsQD = 4;
	*numResults = numResultsQD;
	memset(results, 0, sizeof(Rect) * 4);
	for (i = 1; i <= numResultsQD; ++i) {
		results[i-1].origin.x = resultsQD[i-1].left;
		results[i-1].origin.y = resultsQD[i-1].top;
		results[i-1].size.width = resultsQD[i-1].right - resultsQD[i-1].left;
		results[i-1].size.height = resultsQD[i-1].bottom - resultsQD[i-1].top;
	}
	return retval;
}

typedef struct _RectList RectList;

struct _RectList {
	Rect rect;
	RectList *next;
	RectList *prev;
};

typedef struct {
	Rect rectToSubtract;
	int fuzzFactor;
	RectList *rectList;
	BOOL didChange;
} DiffRgnRectStruct;

static OSStatus DiffRgnRectCallback(UInt16 message, RgnHandle region,
	const Rect *aRgnRect, void *data)
{
	unsigned i;
	BOOL didChange;
	RectList *newItem;
	Rect outsideRects[4] = {{0}};
	unsigned outsideRectsNum = 0;
	DiffRgnRectStruct *info = (DiffRgnRectStruct *) data;
	if (!info || (message != kQDRegionToRectsMsgParse))
		return noErr;
	didChange = DiffRect(*aRgnRect, info->rectToSubtract, &outsideRectsNum,
		outsideRects, info->fuzzFactor);
	if (didChange)
		info->didChange = true;
	for (i = 1; i <= outsideRectsNum; ++i) {
		if ((newItem = (RectList *) calloc(1, sizeof(RectList))) != nil) {
			newItem->rect = outsideRects[i-1];
			if (info->rectList) {
				info->rectList->prev = newItem;
				newItem->next = info->rectList;
				info->rectList = newItem;
			} else {
				info->rectList = newItem;
			}
		}
	}
	return noErr;
}

/* Subtracts "rect" from "region".  "results" (if non-zero) needs to be freed
 * by the caller.  Returns "true" if "results" is different from the collection
 * of rectangles already inside "region".
 */
Boolean DiffRgnRect(RgnHandle region, Rect rect, unsigned *numResults,
	Rect **results, int fuzzFactor)
{
	unsigned i, total;
	RectList *listItem;
	Rect *resultsLocal;
	DiffRgnRectStruct info = {{0}};
	if (!region || !numResults || !results)
		return false;
	*numResults = 0;
	*results = nil;
	info.rectToSubtract = rect;
	info.fuzzFactor = fuzzFactor;
	QDRegionToRects(region, kQDParseRegionFromTopLeft,
		DiffRgnRectCallback, &info);
	if (!info.rectList)
		return info.didChange;
	total = 1;
	listItem = info.rectList;
	while (listItem->next) {
		++total;
		listItem = listItem->next;
	}
	if ((resultsLocal = (Rect *) calloc(total, sizeof(Rect))) == nil)
		return false;
	for (i = 1; i <= total; ++i) {
		resultsLocal[i-1] = listItem->rect;
		if ((listItem = listItem->prev) != nil)
			free(listItem->next);
	}
	free(info.rectList);
	*numResults = total;
	*results = resultsLocal;
	return info.didChange;
}

typedef struct {
	RectList *rectList;
} GetRgnRectsStruct;

static OSStatus GetRgnRectsCallback(UInt16 message, RgnHandle region,
	const Rect *aRgnRect, void *data)
{
	RectList *newItem;
	GetRgnRectsStruct *info = (GetRgnRectsStruct *) data;
	if (!info || (message != kQDRegionToRectsMsgParse))
		return noErr;
	if ((newItem = (RectList *) calloc(1, sizeof(RectList))) != nil) {
		newItem->rect = *aRgnRect;
		if (info->rectList) {
			info->rectList->prev = newItem;
			newItem->next = info->rectList;
			info->rectList = newItem;
		} else {
			info->rectList = newItem;
		}
	}
	return noErr;
}

/* Returns "true" if "region" is non-empty */
Boolean GetRgnRects(RgnHandle region, unsigned *numResults, Rect **results)
{
	unsigned i, total;
	RectList *listItem;
	Rect *resultsLocal;
	GetRgnRectsStruct info = {0};
	if (!region || !numResults || !results)
		return false;
	*numResults = 0;
	*results = nil;
	QDRegionToRects(region, kQDParseRegionFromTopLeft,
		GetRgnRectsCallback, &info);
	if (!info.rectList)
		return false;
	total = 1;
	listItem = info.rectList;
	while (listItem->next) {
		++total;
		listItem = listItem->next;
	}
	if ((resultsLocal = (Rect *) calloc(total, sizeof(Rect))) == nil)
		return false;
	for (i = 1; i <= total; ++i) {
		resultsLocal[i-1] = listItem->rect;
		if ((listItem = listItem->prev) != nil)
			free(listItem->next);
	}
	free(info.rectList);
	*numResults = total;
	*results = resultsLocal;
	return true;
}

/* In versions prior to 0.8.2, the JEP would (in all browsers) occasionally
 * lock up while drawing, seemingly while Java was trying to display a low
 * level error message.  I hope that this "vfprintf hook" will at least
 * reduce the frequency of these lock-ups.  Because it will normally be called
 * when the JNI is (in effect) in a critical section, this routine can't make
 * any JNI calls.
 */
jint JNICALL java_vfprintf(FILE *fp, const char *format, va_list args)
{
	jint retval = 0;
	NSString *formatCocoa = nil;
	NSString *messageCocoa = nil;
	NSAutoreleasePool *localPool = [[NSAutoreleasePool alloc] init];

	if (!localPool || !format)
		return 0;

	if ((formatCocoa = [[NSString alloc] initWithCString:format]) == nil)
		return 0;
	if ((messageCocoa =
		[[NSString alloc] initWithFormat:formatCocoa arguments:args]) == nil)
		return 0;
	NSLog(messageCocoa);
	retval = strlen([messageCocoa UTF8String]);

	[localPool release];
	return retval;
}

/* Needed to handle breakage caused by Apple's new drivers for its MightyMouse
 * and newest trackpads.  If these drivers detect that they're sending events
 * to one of these devices, they send kEventMouseScroll events and not
 * kEventMouseWheelMoved events.  Apple's keyboard and mouse handlers for its
 * Cocoa-Carbon interface used to swallow both events, so we had to reroute
 * them.  Now we no longer use Apple's handlers, but we still have to create
 * Cocoa events for both kinds of Carbon event.
 * For more info see:
 * http://developer.apple.com/qa/qa2005/qa1453.html
 * https://bugzilla.mozilla.org/show_bug.cgi?id=309344
 * https://bugzilla.mozilla.org/show_bug.cgi?id=319078
 */
enum {
	kEventParamMouseWheelSmoothVerticalDelta       = 'saxy', // typeSInt32
	kEventParamMouseWheelSmoothHorizontalDelta     = 'saxx', // typeSInt32
};
enum {
	kEventMouseScroll             = 11
};

/* As of JEP 0.9.5+h, we're finally able to stop using Apple's buggy mouse
 * and keyboard event handlers for its Cocoa-Carbon interface, and do what
 * needs to be done entirely by ourselves.  Among other things, this means
 * that we no longer need to use SendEventToEventTargetWithOptions() to
 * send mouse and keyboard events to _all_ Carbon handlers, and to clean up
 * the messes that this sometimes caused.  What we now do is very simple --
 * we use GetEventPlatformEventRecord() to extract a CGSEventRecord from a
 * Carbon event, and then use NSEvent _initWithCGSEvent:eventRef: to create
 * an equivalent Cocoa event, which we then send to the appropriate target.
 * But (as usual) Apple made this very difficult by not documenting its
 * methods, and by some peculiar design decisions.  (For example, NSEvent
 * _initWithCGSEvent:eventRef: takes a CGSEventRecord as its first parameter
 * -- not a pointer to a CGSEventRecord.  So we need to know the _exact_
 * length of a CGSEventRecord to use _initWithCGSEvent, and (of course) this
 * has changed from one OS major version to another.)
 */
NSEvent *CreateNSEvent(CGSEventRecord *eventRec, EventRef anEvent)
{
	NSEvent *retval = nil;
	CGSEventRecord_Jaguar eventRecJaguar = {0};
	CGSEventRecord_Panther eventRecPanther = {0};
	CGSEventRecord_Tiger eventRecTiger = {0};
	CGSEventRecord_Leopard eventRecLeopard = {0};
	if (!eventRec || !anEvent)
		return nil;
	if ((retval = [NSEvent alloc]) == nil)
		return nil;
	if (osxVersion < 0x1030) {
		memcpy(&eventRecJaguar, eventRec, sizeof(eventRecJaguar));
		retval = (NSEvent *) objc_msgSend(retval, @selector(_initWithCGSEvent:eventRef:),
			eventRecJaguar, anEvent);
	} else if (osxVersion < 0x1040) {
		memcpy(&eventRecPanther, eventRec, sizeof(eventRecPanther));
		retval = (NSEvent *) objc_msgSend(retval, @selector(_initWithCGSEvent:eventRef:),
			eventRecPanther, anEvent);
	} else if (osxVersion < 0x1050) {
		memcpy(&eventRecTiger, eventRec, sizeof(eventRecTiger));
		retval = (NSEvent *) objc_msgSend(retval, @selector(_initWithCGSEvent:eventRef:),
			eventRecTiger, anEvent);
	} else {
		memcpy(&eventRecLeopard, eventRec, sizeof(eventRecLeopard));
		retval = (NSEvent *) objc_msgSend(retval, @selector(_initWithCGSEvent:eventRef:),
			eventRecLeopard, anEvent);
	}
	if (retval) {
		RetainEvent(anEvent);
		[retval _setEventRef:anEvent];
	}
	return retval;
}

//#define PRINT_ALL_CARBON_EVENTS 1

#ifdef PRINT_ALL_CARBON_EVENTS

char *GetFourCharCode(UInt32 type)
{
	static char codeName[5] = {0};
	codeName[0] = ((type >> 24) & 0xFF);
	codeName[1] = ((type >> 16) & 0xFF);
	codeName[2] = ((type >> 8) & 0xFF);
	codeName[3] = (type & 0xFF);
	return codeName;
}

void (*DebugPrintEventPtr) (EventRef inEvent) = nil;

BOOL FindDebugPrintEvent(void)
{
	unsigned i, count;
	NSSymbol symbol = nil;
	const struct mach_header *image = nil;
	count = _dyld_image_count();
	if (DebugPrintEventPtr)
		return true;
	for (i = 1; i <= count; ++i) {
		image = (const struct mach_header *) _dyld_get_image_header(i - 1);
		symbol = NSLookupSymbolInImage(image, "__DebugPrintEvent",
			NSLOOKUPSYMBOLINIMAGE_OPTION_RETURN_ON_ERROR);
		if (symbol)
			DebugPrintEventPtr = (void (*) (EventRef)) NSAddressOfSymbol(symbol);
		if (DebugPrintEventPtr)
			return true;
	}
	return false;
}

void DebugPrintEvent(EventRef inEvent)
{
	unsigned i, j;
	char *priority;
	char formatUTF8[512];
	NSString *format;
	char databuf[16];
	EventParam *parms;
	EventPriv_Tiger *private;
	NSAutoreleasePool *localPool;
	if ((localPool = [[NSAutoreleasePool alloc] init]) == nil)
		return;
	if ((private = (EventPriv_Tiger *) inEvent) == nil)
		return;
	if (FindDebugPrintEvent()) {
		DebugPrintEventPtr(inEvent);
		[localPool release];
		return;
	}
	// Only roll our own if we're on Tiger or Leopard.
	if (osxVersion < 0x1040) {
		[localPool release];
		return;
	}
	// Don't do anything on Leopard -- we still don't have adequate info on
	// Leopard's internals.
	if (osxVersion >= 0x1050) {
		[localPool release];
		return;
	}
	switch (private->priority) {
		case kEventPriorityLow:
			priority = "kEventPriorityLow";
			break;
		case kEventPriorityStandard:
			priority = "kEventPriorityStandard";
			break;
		case kEventPriorityHigh:
			priority = "kEventPriorityHigh";
			break;
		default:
			priority = "undefined";
			break;
	}
	NSLog(@"Displaying event 0x%.8X ...", (unsigned) inEvent);
	NSLog(@"  Class        %s", GetFourCharCode(private->classID));
	NSLog(@"  Kind         %u", private->kind);
	//NSLog(@"  When         %f", private->time);
	NSLog(@"  When         %i", AbsoluteToDuration(*((AbsoluteTime *) &private->machTime)));
	NSLog(@"  Priority     %s", priority);
	NSLog(@"  RetainCount  %u", private->owners);
	NSLog(@"  Queued       %s", private->queue ? "Yes" : "No");
	if (!private->parameters || !private->numUsed) {
		NSLog(@"  No parameters");
		[localPool release];
		return;
	}
	NSLog(@"  Parameters (%u)", private->numUsed);
	parms = private->parameters;
	for (i = 1; i <= private->numUsed; ++i) {
		NSLog(@"    param       %s", GetFourCharCode(parms[i-1].name));
		NSLog(@"     type       %s", GetFourCharCode(parms[i-1].type));
		NSLog(@"     size       %u", parms[i-1].size);
		if (parms[i-1].size > sizeof(databuf))
			continue;
		memset(databuf, 0, sizeof(databuf));
		memcpy(databuf, parms[i-1].data, parms[i-1].size);
		if (parms[i-1].size == 2) {
			NSLog(@"     data       0x%.4X", *((unsigned short *) databuf));
		} else if (parms[i-1].size == 4) {
			NSLog(@"     data       0x%.8X", *((unsigned long *) databuf));
		//} else if (parms[i-1].size == 8) {
		//	NSLog(@"     data       0x%.16X", *((unsigned long long *) databuf));
		} else {
			strcpy(formatUTF8, "     data       0x");
			for (j = 1; j <= parms[i-1].size; ++j)
				strcat(formatUTF8, "%.2X");
			format = [NSString stringWithUTF8String:formatUTF8];
			NSLog(format, databuf[0], databuf[1], databuf[2], databuf[3],
				databuf[4], databuf[5], databuf[6], databuf[7],
				databuf[8], databuf[9], databuf[10], databuf[11],
				databuf[12], databuf[13], databuf[14], databuf[15]);
		}
	}
	[localPool release];
}

#endif // #ifdef PRINT_ALL_CARBON_EVENTS

/* This is a handler for all mouse and keyboard events possibly associated
 * with the Cocoa-Carbon interface in a particular window, plus various odds
 * and ends.  It's installed once for every NSCarbonWindow object that we
 * create, but only after having removed the handler that we installed for
 * NSCarbonWindow objects previously created in the same window -- so there's
 * one of these handlers per Carbon window, which may contain several applet
 * views.
 */
static pascal OSStatus HandleDispatcher(EventHandlerCallRef nextHandler,
	EventRef theEvent, void *userData)
{
	OSStatus retval = eventNotHandledErr;
	UInt32 modifiers = 0, kind = 0, class = 0;
	char className[10] = {0};
	WindowRef carbonWindow = nil;
	WindowRef carbonWindowInCache = nil;
	WindowActivationScope carbonWindowScope = 0;
	Point mouseLoc = {0};
	WindowPartCode part = 0;
	EventMouseButton mouseButton = 0;
	Rect frameCarbon = {0};
	JEPController *controller = (JEPController *) userData;
	NSWindow *cocoaWindow = nil;
	NSWindow *cocoaWindowOrg = nil;
	NSWindow *currentCocoaWindow = nil;
	Boolean inCocoaAppWindow = false;
	NSInvocation *message = nil;
	NSMethodSignature *sig = nil;
	EventRef resumeEvent = nil;
	Boolean boolTrue = true;
	Boolean boolFalse = false;
	Boolean alreadyRedispatched = false;
	Boolean alreadyFixedUp = false;
	Boolean mouseInApplet = false;
	Boolean appletHasFocus = false;
	Boolean cocoaWantsEvent = false;
	Boolean cocoaGrabsEvent = false;
	Boolean alreadyPosted = false;
	Boolean windowMouseActivated = false;
	UInt32 controlModifiers = 0;
	UInt32 controlMask = (0xFF00 & ~((1 << shiftKeyBit) | (1 << rightShiftKeyBit)
		| (1 << alphaLockBit) | (1 << optionKeyBit) | (1 << rightOptionKeyBit)));
	TSMDocumentID activeDoc = nil;
	Boolean isActiveDocCocoa = false;
	CGSEventRecord eventRec = {{0}};
	Boolean gotEventRec = false;
	NSEvent *cocoaEvent = nil;
	NSAutoreleasePool *localPool = [[NSAutoreleasePool alloc] init];

	if (!localPool)
		return eventNotHandledErr;

	/* The JEPController pointer in userData points to the last controller
	 * created in our (Carbon) window.  The following block of code makes
	 * sure that "controller" and "cocoaWindow" are set to the JEPController/
	 * myWindow pair corresponding to the applet that most recently had the
	 * focus (and which is currently in NSApplication's window cache).
	 */
	if (controller && controller->myWindow) {
		cocoaWindowOrg = controller->myWindow;
		cocoaWindow = [NSApp windowWithWindowNumber:
			[controller->myWindow _realWindowNumber]];
		if (cocoaWindow) {
			controller = [JEPController controllerFromNSWindow:cocoaWindow
				timeoutType:lockTimeoutNone];
		} else {
			cocoaWindow = cocoaWindowOrg;
		}
	}

	kind = GetEventKind(theEvent);
	class = GetEventClass(theEvent);
	memcpy(className, &class, 4);

	/* Check if an event that we've already "fixed up" has "reentered" this
	 * routine.  If so, pass it along without any intervention.
	 */
	if (GetEventParameter(theEvent, kEventParamJEPFixedUp,
		typeBoolean, NULL, sizeof(alreadyFixedUp), NULL,
		&alreadyFixedUp) != noErr)
		alreadyFixedUp = false;
	if (alreadyFixedUp) {
#ifdef DEBUG_EVENTS
		NSLog(@"HandleDispatcher: Passing along event (class %s, kind %u) we previously fixed up",
			className, kind);
#endif
		[localPool release];
		return eventNotHandledErr;
	}

	/* Check if an event that we've already redispatched has "reentered" this
	 * routine -- swallow it if it has.
	 */
	if (GetEventParameter(theEvent, kEventParamJEPRedispatched,
		typeBoolean, NULL, sizeof(alreadyRedispatched), NULL,
		&alreadyRedispatched) != noErr)
		alreadyRedispatched = false;
	if (alreadyRedispatched) {
#ifdef DEBUG_EVENTS
		if ((class != kEventClassMouse) || (kind != kEventMouseMoved)) {
			NSLog(@"HandleDispatcher: Swallowing event (class %s, kind %u) we previously redispatched",
				className, kind);
		}
#endif
		[localPool release];
		return noErr;
	}

	retval = eventNotHandledErr;
	switch (class) {
		case kEventClassMouse:
			if (GetEventParameter(theEvent, kEventParamMouseLocation,
				typeQDPoint, NULL, sizeof(mouseLoc), NULL, &mouseLoc) == noErr)
				part = FindWindow(mouseLoc, &carbonWindow);
			if (GetEventParameter(theEvent, kEventParamKeyModifiers,
				typeUInt32, NULL, sizeof(modifiers), NULL, &modifiers) != noErr)
				modifiers = 0;
			if (GetEventParameter(theEvent, kEventParamMouseButton,
				typeMouseButton, NULL, sizeof(EventMouseButton), NULL,
				&mouseButton) != noErr)
				mouseButton = 0;
			if (carbonWindow) {
				if (GetWindowActivationScope(carbonWindow,
					&carbonWindowScope) != noErr)
					carbonWindowScope = 0;
				currentCocoaWindow = [JEPController
					nsWindowFromCarbonWindow:carbonWindow];
				if (currentCocoaWindow && [currentCocoaWindow
					isKindOfClass:NSClassFromString(@"CocoaAppWindow")])
					inCocoaAppWindow = true;
			}
			if (cocoaWindow)
				carbonWindowInCache = [MyNSWindow existingCarbonWindowFor:cocoaWindow];
			if (!cocoaWindow || !carbonWindow ||
				(carbonWindow != carbonWindowInCache))
			{
#ifdef DEBUG_EVENTS
				if (kind != kEventMouseMoved) {
					NSLog(@"HandleDispatcher: Skipping mouse event (kind %u) not in our window (0x%.8X), currentCocoaWindow %@",
						kind, carbonWindow, currentCocoaWindow);
				}
#endif
				/* OS X Jaguar (10.2.8) and Panther (10.3.9) have a bug in
				 * their support for modal Cocoa windows (as least in Apple's
				 * JVMs) that prevents mouse clicks from working in a modal
				 * Cocoa window's child windows.  This code gets around the
				 * problem by sending mouse clicks directly to the current
				 * window if the window was created by the JVM (i.e. if it
				 * belongs to the CocoaAppWindow class).  (There's no direct
				 * way to tell that the current window is a child window.
				 * Carbon has no concept of child windows, and NSWindow's
				 * parentWindow method doesn't work here.)  (We could check
				 * whether or not we're in a modal loop ... but we have other
				 * reasons for always sending mouse events of any kind
				 * directly to their targets.)  This fix resolves
				 * http://sourceforge.net/tracker/index.php?func=detail&aid=1456457&group_id=107955&atid=649116.
				 */
				/* OS X Jaguar (10.2.8) and Panther (10.3.9) have a bug in
				 * their support for non-modal Cocoa child windows (e.g.
				 * menus) that prevents Cocoa mouse-moved events from being
				 * sent to those windows.  (At least in Apple's JVMs, and at
				 * least when we're creating Cocoa events from Carbon events
				 * ourselves.)  We get around the problem by sending mouse-
				 * moved events directly to the current window if we're not
				 * in a Cocoa-modal loop and the window was created by the JVM
				 * (i.e. if it belongs to the CocoaAppWindow class).  This
				 * change allows the menus to work in the in-page Java applet
				 * at http://www.sferyx.com/htmleditorapplet/download.htm.
				 */
				if ((osxVersion < 0x1040) && inCocoaAppWindow) {
					SetEventParameter(theEvent, kEventParamJEPRedispatched,
						typeBoolean, sizeof(Boolean), &boolTrue);
					retval = SendEventToWindow(theEvent, carbonWindow);
					[localPool release];
					return retval;
				}
				[localPool release];
				return eventNotHandledErr;
			}
			/* Give mouseLoc the content region's coordinate system.
			 */
			GetWindowBounds(carbonWindow, kWindowContentRgn, &frameCarbon);
			mouseLoc.v -= frameCarbon.top;
			mouseLoc.h -= frameCarbon.left;
			mouseInApplet = [JEPController
				appletViewInWindowHasPoint:carbonWindow point:mouseLoc
				timeoutType:lockTimeoutNone];
			if ((kind == kEventMouseDown) && controller && mouseInApplet)
				controller->skipUpdateOnce = true;
			/* Scroll-wheel events over applets need to be kept separate
			 * from other scroll-wheel events.
			 */
			if ((kind == kEventMouseWheelMoved) ||
				(kind == kEventMouseScroll))
			{
				cocoaWantsEvent = cocoaGrabsEvent = mouseInApplet;
			/* We get odd behavior if we let events in the "collapse box
			 * region" (the minimize button) be handled in the ordinary way:
			 * For example, load an applet that has a text-input field into
			 * a browser window, or multiple applets (whether or not any of
			 * them has a text-input field).  If you switch away to another
			 * app and (without changing the focus back to the browser) click
			 * on the browser window's minimize button, it will usually
			 * bounce back after having minimized.  The following seems to
			 * clear this up.  (Before JEP 0.9.6.1 we swallowed these events.
			 * But this caused the minimize button to stop working on OS X
			 * 10.4.X and higher.  Now we just stop sending Cocoa events,
			 * but allow the Carbon events through.  This change resolves
			 * bmo bug 369894.)
			 */
			} else if ((part == inCollapseBox) &&
				((kind == kEventMouseDown) || (kind == kEventMouseUp)))
			{
				cocoaWantsEvent = false;
				cocoaGrabsEvent = false;
			} else {
				cocoaWantsEvent = true;
				cocoaGrabsEvent = false;
			}
			/* Fun and games on mouse-down */
			if ((kind == kEventMouseDown) && carbonWindow && cocoaWindow) {
				/* See below under "case kEventClassApplication". */
				if (GetWindowProperty(carbonWindow, kJEPCreatorCode,
					kPropertyMouseActivated, sizeof(Boolean), nil,
					&windowMouseActivated) != noErr)
					windowMouseActivated = false;
				if (!nsAppActive && !windowMouseActivated) {
					if (CreateEvent(nil, kEventClassApplication,
						kEventAppActivated, 0, kEventAttributeNone,
						&resumeEvent) != noErr)
						resumeEvent = nil;
					if (resumeEvent) {
						if (SetEventParameter(resumeEvent,
							kEventParamWindowRef, typeWindowRef,
							sizeof(carbonWindow), &carbonWindow) != noErr)
						{
							ReleaseEvent(resumeEvent);
							resumeEvent = nil;
						}
					}
					if (resumeEvent) {
						if (SetEventParameter(resumeEvent,
							kEventParamJEPFixedUp, typeBoolean,
							sizeof(Boolean), &boolTrue) != noErr)
						{
							ReleaseEvent(resumeEvent);
							resumeEvent = nil;
						}
					}
				}
				/* The event handler that automatically gets installed when
				 * (in CreateCocoaWindow() in Controller.m) we create an
				 * NSCarbonWindow object (as distinct from the "extra"
				 * handlers installed by _installCarbonWindowEventHandlers)
				 * normally calls NSCarbonWindow's handleMouseDownEvent and
				 * handleCarbonBoundsChange methods once for every
				 * NSCarbonWindow object that's been created.  But most of our
				 * handlers assume they'll be called once per Carbon window
				 * (which may contain more than one applet view).  So we
				 * remove the automatically installed handler (in
				 * CreateCocoaWindow()) and do its job ourselves, here and
				 * below (the call to handleCarbonBoundsChange on a
				 * kEventWindowBoundsChanged event in HandleWindow()).
				 * Another reason to remove the originally installed handler
				 * is that it gets disabled when the "extra" handlers are
				 * installed (on the first NSCarbonWindow object we create in
				 * a Carbon window).
				 */
				sig = [carbonWindowClass instanceMethodSignatureForSelector:
					@selector(handleMouseDownEvent:at:inPart:withMods:)];
				if (sig)
					message = [NSInvocation invocationWithMethodSignature:sig];
				if (message) {
					[message setSelector:
						@selector(handleMouseDownEvent:at:inPart:withMods:)];
					[message setArgument:&theEvent atIndex:2];
					[message setArgument:&mouseLoc atIndex:3];
					[message setArgument:&part atIndex:4];
					[message setArgument:&modifiers atIndex:5];
					[message invokeWithTarget:cocoaWindow];
					[message getReturnValue:&retval];
				}
				/* See below under "case kEventClassApplication". */
				if (resumeEvent) {
					PostEventToQueue(GetMainEventQueue(), resumeEvent,
						kEventPriorityStandard);
					SetWindowProperty(carbonWindow, kJEPCreatorCode,
						kPropertyMouseActivated, sizeof(Boolean), &boolTrue);
				}
			}
			/* Additional Cocoa-Carbon interface problems can be fixed by
			 * activating (and highlighting) the current window
			 * (cocoaWindow/carbonWindow) if it isn't already active (and
			 * highlighted).  For example, if you open an applet in a
			 * window, then open another browser window on top of it, then
			 * click on the desktop, then click on the title bar of the
			 * first window, the two windows will (without this fix)
			 * flicker back and forth a couple of times.
			 */
			/* Only pay attention to a negative answer from IsWindowActive()
			 * or IsWindowHilited() if the window's "activation scope" is
			 * kWindowActivationScopeAll (i.e. if it is an ordinary, non-
			 * floating window).  This fixes bmo bug 341234.
			 */
			/* As of JEP 0.9.5+g we use a straightforward Carbon call to
			 * make our window active (if it isn't already) -- what we did
			 * previously didn't always work (our window was still
			 * sometimes not made active).  This change resolves bmo bug
			 * 344006.  We also need to make sure our window is
			 * highlighted.  Mozilla.org browsers expect that active
			 * windows will be "active" (in some places) or "highlighted"
			 * (in others) -- otherwise they can behave strangely (though
			 * the strangeness is ultimately caused by bugs in Apple's
			 * Cocoa-Carbon interface.  For example, do the following in
			 * Firefox 2.0b1, with JEP 0.9.5+f:
			 * 1) Open a Java applet in a browser window (single tab).
			 * 2) Open a second tab in that window.
			 * 3) Switch back to the first tab and put the keyboard focus
			 *    in the applet.
			 * 4) Click on the "close" button -- a modal dialog will be
			 *    displayed asking if you want to close the two open tabs.
			 *    But clicking on the Cancel or Close Tabs buttons will
			 *    have no effect.
			 */
			if (carbonWindow && (kind == kEventMouseDown) &&
				(part != inGoAway) && (part != inZoomIn) &&
				(part != inZoomOut) && (part != inCollapseBox))
			{
				if (carbonWindowScope == kWindowActivationScopeAll) {
					if (!IsWindowActive(carbonWindow)) {
						SelectWindow(carbonWindow);
					} else if (!IsWindowHilited(carbonWindow)) {
						BringToFront(carbonWindow);
						ShowWindow(carbonWindow);
					}
				}
			}
			/* Allow a single mouse-down in our window's content region to
			 * make our application active without doing anything else.  This
			 * is standard behavior for Carbon-based apps, and was something
			 * we didn't do quite right before JEP 0.9.5+e.
			 */
			if ((kind == kEventMouseDown) && (part == inContent)) {
				ProcessSerialNumber ourApp = {0};
				ProcessSerialNumber activeApp = {0};
				Boolean ourAppIsActive = false;
				GetCurrentProcess(&ourApp);
				GetFrontProcess(&activeApp);
				SameProcess(&ourApp, &activeApp, &ourAppIsActive);
				if (!ourAppIsActive) {
					[NSApp activateIgnoringOtherApps:true];
					[localPool release];
					return retval;
				}
			}
			break;
		case kEventClassKeyboard:
			carbonWindow = GetUserFocusWindow();
			if (!cocoaWindow || !carbonWindow ||
				(carbonWindow != [MyNSWindow existingCarbonWindowFor:cocoaWindow]))
			{
#ifdef DEBUG_EVENTS
				NSLog(@"HandleDispatcher: Skipping keyboard event (kind %u) not in our window",
					kind);
#endif
				[localPool release];
				return eventNotHandledErr;
			}
			if (GetEventParameter(theEvent, kEventParamKeyModifiers,
				typeUInt32, NULL, sizeof(controlModifiers), NULL,
				&controlModifiers) != noErr)
				controlModifiers = 0;
			controlModifiers &= controlMask;
			/* Make sure the whole keyDown + keyUp sequence is treated
			 * consistently WRT controlModifiers.
			 */
			if (controller) {
				if (kind == kEventRawKeyDown) {
					controller->lastKeyDownControlModifiers = controlModifiers;
				} else if (kind == kEventRawKeyUp) {
					controlModifiers = controller->lastKeyDownControlModifiers;
				}
			}
			/* Key-up and key-down events in applets must be kept separate
			 * other key-up and key-down events.  But both Cocoa and Carbon
			 * should get kEventRawKeyModifiersChanged events.
			 */
			if ((kind == kEventRawKeyDown) || (kind == kEventRawKeyUp)) {
				appletHasFocus = [JEPController windowHasKeyWindow:carbonWindow
					timeoutType:lockTimeoutNone];
				if (appletHasFocus &&
					(!controller || !controller->myAppletView ||
					[controller->myAppletView isCurrentClipEmpty]))
					appletHasFocus = false;
				cocoaGrabsEvent = cocoaWantsEvent = appletHasFocus;
			} else {
				cocoaWantsEvent = true;
				cocoaGrabsEvent = false;
			}
			/* But we must not swallow Command+key and Control+key conbinations.
			 */
			if (controlModifiers)
				cocoaGrabsEvent = false;
			break;
		case kEventClassApplication:
			/* The Mozilla Suite and older versions of Firefox (including
			 * 1.5.0.X and 1.0.X) use handlers on WaitNextEvent() to determine
			 * whether the browser is currently active -- which effects whether
			 * certain browser elements respond to mouse overs.  But when the
			 * Cocoa-Carbon interface is in use, the kEventAppActivated event
			 * is often sent directly to an event target, instead of being
			 * posted to the old-fashioned event queue -- in which case the
			 * event will never get to WaitNextEvent().  To get around this
			 * we post a new kEventAppActivated event to the WNE event queue
			 * on mouse-down (above, as appropriate), keep track of having
			 * done this, and if we've done it we swallow the kEventAppActivated
			 * event that comes through here.  (For some reason this causes
			 * problems on OS X 10.2.8, though -- for example, in Firefox 2.0
			 * (which doesn't use WNE) some browser elements don't respond to
			 * mouse overs if a window containing a Java applet is activated
			 * by clicking on the content region.  So we just have to live
			 * extra activation events on 10.2.8.)
			 */
			if (GetEventParameter(theEvent, kEventParamWindowRef,
				typeWindowRef, NULL, sizeof(WindowRef), NULL, &carbonWindow)
				!= noErr)
			{
				carbonWindow = nil;
			}
			if (cocoaWindow && !carbonWindow)
				carbonWindow = [MyNSWindow existingCarbonWindowFor:cocoaWindow];
			if (carbonWindow) {
				if (GetWindowProperty(carbonWindow, kJEPCreatorCode,
					kPropertyMouseActivated, sizeof(Boolean), nil,
					&windowMouseActivated) != noErr)
					windowMouseActivated = false;
			}

			//NSLog(@"HandleDispatcher() kEventClassApplication: carbonWindow 0x%.8X, windowMouseActivated %i",
			//	(unsigned) carbonWindow, windowMouseActivated);

			if (windowMouseActivated && (osxVersion >= 0x1030))
				retval = noErr;
			[localPool release];
			return retval;
		case kEventClassWindow:
			/* With these same older Mozilla.org browsers (the ones that use
			 * (WaitNextEvent()), Carbon handlers on the window target for the
			 * kEventWindowActivated and kEventWindowDeactivated events usually
			 * receive two events for each window activation or deactivation
			 * (once the Cocoa-Carbon interface is in use).  The first is sent
			 * only to the window target (never to the event dispatcher
			 * target), and (presumably) winds up on the WNE event queue if it
			 * isn't handled by the window target's handler(s).  The second is
			 * sent to the event dispatcher target, and if not handled here is
			 * also sent to the window target (I don't know if it can get
			 * passed along to the WNE event queue).  You can stop the
			 * duplication by marking events that come through here and
			 * swallowing them in HandleWindow().  (You can't just swallow
			 * them here:  If you do you sometimes get wierdness after closing
			 * a window containing at least one applet -- the next window you
			 * open won't accept keyboard input until you click on the desktop
			 * and then on the window (FF 1.5 only).)  This change and others
			 * to resignKeyWindow_CW() et al, below, resolve bmo bug 344150.
			 * The event duplication (oddly) doesn't happen (and doesn't need
			 * to be fixed) if the browser doesn't use WaitNextEvent().
			 */
			/* But I've had to disable this part of my fix for duplicate
			 * kEventWindowActivated and kEventWindowDeactivated events in
			 * browsers that use WaitNextEvent(), because of what seems to be
			 * a bug in Firefox 1.5.0.X and Seamonkey 1.0.X:  A browser window
			 * popped up using AppletContext.showDocument() will sometimes be
			 * displayed behind the current browser window (instead of in
			 * front of it, as it should be).  Here's one example of this
			 * problem:  Load the Java applet at
			 * http://www.xrce.xerox.com/competencies/content-analysis/arabic/input/keyboard_input.html,
			 * type some (Arabic) text into it, and hit enter -- the applet
			 * will use showDocument to pop up a window with applet(s)
			 * containing possible dictionary matches for what you've
			 * entered.  This problem doesn't effect Firefox 2.0 (which
			 * doesn't use WaitNextEvent()).  Oddly, it also doesn't effect
			 * Firefox 1.0.8 or Mozilla 1.7.13 (which do).  (Technically, I
			 * fix this problem by just disabling my fix for duplicated
			 * kEventWindowDeactivated events.  But doing that leads to at
			 * least one other problem (in browsers that use WaitNextEvent())
			 * -- if a Java applet opens a JVM window and gives it the
			 * keyboard focus, you won't be able to enter text in browser-
			 * window input fields unless you click first on the desktop and
			 * then on the browser window.  A good example of an applet that
			 * pops up a JVM window is http://www.lohn1.de/lobn.htm.)
			 */
			if (GetEventParameter(theEvent, kEventParamJEPAlreadyPosted,
				typeBoolean, NULL, sizeof(Boolean), NULL, &alreadyPosted)
				!= noErr)
			{
				alreadyPosted = false;
			}

			//NSLog(@"HandleDispatcher() kEventClassWindow: alreadyPosted %i", alreadyPosted);

			if (alreadyPosted) {
				/* Sometimes the same event keeps being re-used (possibly only
				 * as a model for CopyEvent()).
				 */
				SetEventParameter(theEvent, kEventParamJEPAlreadyPosted,
					typeBoolean, sizeof(Boolean), &boolFalse);
				SetEventParameter(theEvent, kEventParamJEPNotForPosting,
					typeBoolean, sizeof(Boolean), &boolTrue);
			}
			[localPool release];
			return eventNotHandledErr;
#ifdef PRINT_ALL_CARBON_EVENTS
		case kEventClassTarget:
			{
			EventRef anEvent = nil;
			UInt32 aKind = 0, aClass = 0;
			Boolean alreadyPrinted = false;
			if (kind == kEventTargetGetNext) {
				if (GetEventParameter(theEvent, kEventParamEventRef,
					typeEventRef, NULL, sizeof(EventRef), NULL,
					&anEvent) != noErr)
					anEvent = nil;
			} else {
				anEvent = theEvent;
			}
			if (anEvent) {
				if (GetEventParameter(anEvent, kEventParamAlreadyPrinted,
					typeBoolean, NULL, sizeof(Boolean), NULL,
					&alreadyPrinted) != noErr)
					alreadyPrinted = false;
				if (!alreadyPrinted) {
					aKind = GetEventKind(anEvent);
					aClass = GetEventClass(anEvent);
					if (((aClass != kEventClassTarget) || (aKind != kEventTargetGetNext)) &&
						((aClass != kEventClassMouse) || (aKind != kEventMouseMoved)))
						DebugPrintEvent(anEvent);
					SetEventParameter(anEvent, kEventParamAlreadyPrinted,
						typeBoolean, sizeof(Boolean), &boolTrue);
				}
			}
			[localPool release];
			return eventNotHandledErr;
			}
#endif
		default:
			break;
	}

	/* Firefox 1.5 appears to have a bug that sometimes causes the wrong
	 * TSMDocument to be active after a popup window has been closed (perhaps
	 * especially if the window was popped up by an applet).  This isn't the
	 * same as the problem that's fixed by _activate_TSMIC().  Firefox 1.0.X
	 * doesn't seem to be effected by this bug.
	 */
	activeDoc = TSMGetActiveDocument();
	if (TSMGetDocumentProperty(activeDoc, kPropertyCocoaTSMDoc,
		sizeof(Boolean), nil, &isActiveDocCocoa) != noErr)
		isActiveDocCocoa = false;
	if ((class == kEventClassKeyboard) && controller && cocoaWindow) {
		if (controller->tsmInfo.carbonStateSet) {
			if (controller->tsmInfo.parentActiveDoc && isActiveDocCocoa)
				ActivateTSMDocument(controller->tsmInfo.parentActiveDoc);
		} else if (controller->tsmInfo.cocoaStateSet) {
			if (activeDoc && !isActiveDocCocoa)
				DeactivateTSMDocument(activeDoc);
		}
	}

	/* Things are much simpler now that we no longer have to use Apple's
	 * mouse and keyboard Cocoa-Carbon interface handlers.  For more
	 * information see the comment above CreateNSEvent() above.
	 */
	if (cocoaWindow && controller) {
		gotEventRec = GetEventPlatformEventRecord(theEvent, &eventRec);
#ifdef DEBUG_EVENTS
		if (!gotEventRec) {
			NSLog(@"HandleDispatcher: Didn't get eventRec for event class %s, kind %u",
				className, kind);
		}
#endif
		if (gotEventRec && cocoaWantsEvent) {
			cocoaEvent = CreateNSEvent(&eventRec, theEvent);
			if (cocoaEvent) {
				wasInEventTrackingMode = false;
				[NSApp sendEvent:cocoaEvent];
				if (cocoaGrabsEvent)
					retval = noErr;
				/* Left-clicking on certain kinds of objects in applets
				 * generates (by default) a mouse-down Carbon event but not a
				 * mouse-up Carbon event.  (Examples are the "Fill" and "Draw"
				 * buttons in the JDK ArcTest sample applet, and the button in
				 * the "Set Animation Speed" slider in the NOAA radar looping
				 * applets.)  The proximate cause is that, in these objects,
				 * left-clicking initiates an NSEventTrackingRunLoopMode (using
				 * NSCell trackMouse:inRect:ofView:untilMouseUp: and related
				 * methods) that lasts until you let go of the mouse button,
				 * and which swallows the resulting mouse-up event.  Cocoa apps
				 * (like the JVM) expect this behavior, and don't work properly
				 * without it.  But Carbon apps don't expect it, and it has
				 * some nasty side effects in Mozilla.org's Carbon-based
				 * browsers:  1) Many spurious updates are generated as you
				 * move the mouse (these are caught in JEPController
				 * handleCarbonUpdate).  2) In recent Firefox versions (at
				 * least), moving the mouse selects text and other objects
				 * outside of any applet in the browser page.  So I needed to
				 * come up with a workaround that suits both Carbon-based
				 * browsers and the Cocoa-based JVM.
				 * If theEvent is a left-mouse-down, I check to see if an
				 * NSEventTrackingRunLoopMode was entered while processing a
				 * Cocoa event.  If it was, I call AppletView doMatchingLeftMouseUp
				 * to create and post a matching left-mouse-up Carbon event --
				 * this keeps Carbon browsers happy.  But to make sure that,
				 * when the Cocoa-Carbon interface posts a corresponding Cocoa
				 * event, that it doesn't reach it's "target", I label this
				 * event as "not for Cocoa", and swallow it at the appropriate
				 * place in JEPController routeEvent -- this keeps the JVM
				 * happy.
				 * In JEP 0.9.4 I introduced a partial workaround for this
				 * problem.  But it only dealt with it's effects on Carbon
				 * browsers, and had unfortunate (though rarely encountered)
				 * bad effects on the JVM itself -- for example it caused
				 * bugzilla bug 320380.  My new workaround (introduced in JEP
				 * 0.9.6) gets rid of these side effects, and resolves bug
				 * 320380.
				 */
				if (wasInEventTrackingMode && (class == kEventClassMouse) &&
					(kind == kEventMouseDown) && (mouseButton == kEventMouseButtonPrimary))
				{
					[controller->myAppletView doMatchingLeftMouseUp:theEvent];
				}
			}
		}
	}

#ifdef DEBUG_EVENTS
	if ((class != kEventClassMouse) || (kind != kEventMouseMoved)) {
		NSLog(@"HandleDispatcher: Event class %s, kind %u, part %i, carbonWindow 0x%.8X, applet %@, mouseLoc X (%i) Y (%i), gotEventRec %i, cocoaWantsEvent %i, cocoaGrabsEvent %i, retval %i",
			className, kind, part, carbonWindow,
			controller->myAppletView ? controller->myAppletView->myAppletName : nil,
			mouseLoc.h, mouseLoc.v, gotEventRec, cocoaWantsEvent, cocoaGrabsEvent, retval);
	}
#endif

	[localPool release];
	return retval;
}

/* This is a handler for all "interesting" events associated with a particular
 * window.  It's installed once for every NSCarbonWindow object that we
 * create, but only after having removed the handler that we installed for
 * NSCarbonWindow objects previously created in the same window -- so there's
 * one of these handlers per Carbon window, which may contain several applet
 * views.
 */
static pascal OSStatus HandleWindow(EventHandlerCallRef nextHandler,
	EventRef theEvent, void *userData)
{
	OSStatus retval = eventNotHandledErr;
	OSStatus retval2;
	UInt32 kind, class;
	char className[10] = {0};
	WindowRef windowRef = nil;
	WindowModality carbonModal = 0;
	WindowRef unavailableWindow = nil;
	NSWindow *cocoaWindow = nil;
	NSWindow *cocoaWindowOrg = nil;
	JEPController *controller = (JEPController *) userData;
	NSAutoreleasePool *localPool = [[NSAutoreleasePool alloc] init];
	NSInvocation *message = nil;
	NSMethodSignature *sig = nil;
	ActivateInputContext *activateInputContext;
	JEPController *aController;
	NSMutableArray *controllersFound;
	BOOL skipUpdate = false;
	UInt32 eventAttributes;
	unsigned i, count;
	TSMDocumentID activeDoc = nil;
	Boolean isActiveDocCocoa = false;
	Boolean notForPosting = false;
	Boolean boolFalse = false;
	Boolean boolTrue = true;

	if (!localPool)
		return eventNotHandledErr;

	kind = GetEventKind(theEvent);
	class = GetEventClass(theEvent);
	memcpy(className, &class, 4);

	/* The JEPController pointer in userData points to the last controller
	 * created in our (Carbon) window.  The following block of code makes
	 * sure that "controller" and "cocoaWindow" are set to the JEPController/
	 * myWindow pair corresponding to the applet that most recently had the
	 * focus (and which is currently in NSApplication's window cache).
	 */
	if (controller && controller->myWindow) {
		cocoaWindowOrg = controller->myWindow;
		cocoaWindow = [NSApp windowWithWindowNumber:
			[controller->myWindow _realWindowNumber]];
		if (cocoaWindow) {
			controller = [JEPController controllerFromNSWindow:cocoaWindow
				timeoutType:lockTimeoutNone];
		} else {
			cocoaWindow = cocoaWindowOrg;
		}
	}

	if (class == kEventClassWindow) {
		if (GetEventParameter(theEvent, kEventParamDirectObject,
			typeWindowRef, NULL, sizeof(windowRef), NULL, &windowRef) != noErr)
			windowRef = nil;
		GetWindowModality(GetUserFocusWindow(), &carbonModal,
			&unavailableWindow);
	}

	if (class == kEventClassWindow) {
		switch (kind) {
			case kEventWindowUpdate:
				if (!windowRef)
					break;
				/* The "skipUpdate" fix helps deal with the problem described
				 * in the comment to handleCarbonUpdate in Controller.m.
				 * Specifically, it reduces or eliminates the spurious updates
				 * that happen when you change the focus to an applet by
				 * clicking on it.
				 */
				skipUpdate = false;
				if ((controllersFound = [JEPController
					controllersInWindow:windowRef timeoutType:lockTimeoutNormal]) != nil)
				{
					count = [controllersFound count];
					for (i = 1; i <= count; ++i) {
						aController = [controllersFound objectAtIndex:i-1];
						if (aController->skipUpdateOnce) {
							aController->skipUpdateOnce = false;
							skipUpdate = true;
						}
					}
				}
				if (skipUpdate) {
					BeginUpdate(windowRef);
					EndUpdate(windowRef);
					retval = noErr;
				} else {
					/* See handleCarbonUpdate in Controller.m */
					if (controllersFound) {
						for (i = 1; i <= count; ++i) {
							aController = [controllersFound objectAtIndex:i-1];
							retval2 = [aController handleCarbonUpdate:theEvent];
							if (retval2 == noErr) {
								skipUpdate = true;
								break;
							}
						}
					}
					if (skipUpdate)
						retval = noErr;
				}
				if (controllersFound) {
					if (retval == eventNotHandledErr) {
						Rect updateRect = {0};
						GetWindowBounds(windowRef, kWindowUpdateRgn, &updateRect);
						SetEventParameter(theEvent, kEventParamOrigUpdate,
							typeQDRectangle, sizeof(Rect), &updateRect);
						/* We call through to previously installed Carbon
						 * handler(s) to make sure we let an update event fall
						 * through to WaitNextEvent() only when this is
						 * actually needed (so that older Mozilla.org browsers,
						 * which rely exclusively on WaitNextEvent() to handle
						 * updates, still work properly).
						 */
						retval = CallNextEventHandler(nextHandler, theEvent);
						/* CallNextEventHandler() can return eventNotHandledErr
						 * even when the "next handler" has handled our event.
						 */
						if (retval == eventNotHandledErr) {
							GetWindowBounds(windowRef, kWindowUpdateRgn,
								&updateRect);
							if (EmptyRect(&updateRect))
								retval = noErr;
						}
					}
					[controllersFound removeAllObjects];
					[controllersFound release];
				}
				break;
			case kEventWindowResizeStarted:
			case kEventWindowBoundsChanging:
				/* Prior to JEP 0.8.6, we used to handle resizing in
				 * handleMouseDownEvent_CW().  It's much better to do it
				 * here.
				 */
				if (!windowRef)
					break;
				if (kind == kEventWindowBoundsChanging) {
					if (GetEventParameter(theEvent, kEventParamAttributes,
						typeUInt32, NULL, sizeof(eventAttributes), NULL,
						&eventAttributes) != noErr)
						eventAttributes = 0;
					if (!(eventAttributes & kWindowBoundsChangeZoom))
						break;
				}
				sig = [JEPController instanceMethodSignatureForSelector:
					@selector(suspendAppletUpdates)];
				if (sig)
					message = [NSInvocation invocationWithMethodSignature:sig];
				if (message) {
					[message setSelector:@selector(suspendAppletUpdates)];
					[JEPController sendToControllersInWindow:message
						carbonWindow:windowRef targetIsMyWindow:false
						timeoutType:lockTimeoutNone];
				}
				break;
			case kEventWindowResizeCompleted:
				if (!windowRef)
					break;
				sig = [JEPController instanceMethodSignatureForSelector:
					@selector(resumeAppletUpdates)];
				if (sig)
					message = [NSInvocation invocationWithMethodSignature:sig];
				if (message) {
					[message setSelector:@selector(resumeAppletUpdates)];
					[JEPController sendToControllersInWindow:message
						carbonWindow:windowRef targetIsMyWindow:false
						timeoutType:lockTimeoutNone];
				}
				break;
			/* We need to prevent updates when our window is closing
			 * (handleCarbonUpdates in Controller.m uses the value of
			 * myWindowClosing to do this) -- otherwise we sometimes crash on
			 * CallNextEventHandler() while processing a kEventWindowUpdate
			 * event (above).  A Carbon window is always "hidden" before it's
			 * "closed" (in OS X 10.2 and above).  But sometimes updates occur
			 * for a window that's been "hidden" though not yet "closed" (for
			 * which JEPController windowWillClose hasn't yet set
			 * myWindowClosing) -- which can also cause these crashes.  So we
			 * also set myWindowClosing here.  (And since a window may also be
			 * "hidden" without being closed, we unset myWindowClosing on a
			 * kEventWindowShown event (below).)
			 */
			case kEventWindowHidden:
				if (!windowRef)
					break;
				sig = [JEPController instanceMethodSignatureForSelector:
					@selector(setWindowClosing)];
				if (sig)
					message = [NSInvocation invocationWithMethodSignature:sig];
				if (message) {
					[message setSelector:@selector(setWindowClosing)];
					[JEPController sendToControllersInWindow:message
						carbonWindow:windowRef targetIsMyWindow:false
						timeoutType:lockTimeoutNone];
				}
				break;
			/* Cocoa event handling is broken in NSCarbonWindow objects, so we
			 * use carbon event handlers to see (and respond to) events that
			 * we're interested in -- like window closed and bounds changed
			 * events.
			 */
			case kEventWindowClosed:
				/* We need to send the "close" message to the "original"
				 * NSCarbonWindow object -- the last one created in this
				 * carbon window.
				 */
				if (cocoaWindowOrg)
					[cocoaWindowOrg close];
				break;
			case kEventWindowDeactivated:
				/* See "case kEventClassWindow" in HandleDispatcher(). */
				if (GetEventParameter(theEvent, kEventParamJEPNotForPosting,
					typeBoolean, NULL, sizeof(Boolean), NULL, &notForPosting)
					!= noErr)
				{
					notForPosting = false;
				}
				if (notForPosting) {
					/* Sometimes the same event keeps being re-used (possibly
					 * only as a model for CopyEvent()).
					 */
					SetEventParameter(theEvent, kEventParamJEPNotForPosting,
						typeBoolean, sizeof(Boolean), &boolFalse);

					//NSLog(@"kEventWindowDeactivated: notForPosting");

					[localPool release];
					return noErr;
				}
				SetEventParameter(theEvent, kEventParamJEPAlreadyPosted,
					typeBoolean, sizeof(Boolean), &boolTrue);
				break;
			case kEventWindowActivated:
				/* See "case kEventClassWindow" in HandleDispatcher(). */
				if (GetEventParameter(theEvent, kEventParamJEPNotForPosting,
					typeBoolean, NULL, sizeof(Boolean), NULL, &notForPosting)
					!= noErr)
				{
					notForPosting = false;
				}
				if (notForPosting) {
					/* Sometimes the same event keeps being re-used (possibly
					 * only as a model for CopyEvent()).
					 */
					SetEventParameter(theEvent, kEventParamJEPNotForPosting,
						typeBoolean, sizeof(Boolean), &boolFalse);

					//NSLog(@"kEventWindowActivated: notForPosting");

					[localPool release];
					return noErr;
				}
				SetEventParameter(theEvent, kEventParamJEPAlreadyPosted,
					typeBoolean, sizeof(Boolean), &boolTrue);
				retval = CallNextEventHandler(nextHandler, theEvent);
				/* At this point the browser's TSM doc for windowRef should be
				 * active -- which makes it desirable to set tsmInfo.
				 * parentActiveDoc here.  But sometimes Firefox fails to
				 * reset the TSM doc when one of its windows is made active
				 * (usually when this happens as the result of another window
				 * closing).  So we don't set tsmInfo.parentActiveDoc if the
				 * active TSM doc is "Cocoa-specific".
				 */
				activeDoc = TSMGetActiveDocument();
				if (!activeDoc || (TSMGetDocumentProperty(activeDoc,
					kPropertyCocoaTSMDoc, sizeof(Boolean), nil,
					&isActiveDocCocoa) != noErr))
					isActiveDocCocoa = false;
				if (!isActiveDocCocoa && windowRef && ((controllersFound =
					[JEPController controllersInWindow:windowRef
					timeoutType:lockTimeoutNone]) != nil))
				{
					count = [controllersFound count];
					for (i = 1; i <= count; ++i) {
						aController = [controllersFound objectAtIndex:i-1];
						aController->tsmInfo.parentActiveDoc = activeDoc;
					}
					SetWindowProperty(windowRef, kJEPCreatorCode,
						kPropertyBrowserTSMDoc, sizeof(TSMDocumentID),
						&activeDoc);
					[controllersFound removeAllObjects];
					[controllersFound release];
				}
				/* Another symptom of how badly broken Cocoa event handling is
				 * in NSCarbonWindow objects:  Sometimes a window that receives
				 * a "window activated" event isn't made key.  This can cause
				 * keystrokes to beep and/or be disabled in various contexts.
				 * (Among other things, the call to makeKeyWindow is needed to
				 * set the "current input context".)  But don't make cocoaWindow
				 * key when we're in a Carbon-based modal loop.
				 */
				if (!carbonModal && cocoaWindow && ![cocoaWindow isKeyWindow])
					[cocoaWindow makeKeyWindow];
				/* See the ActivateInputContext class in Controller.m */
				if (controller = [JEPController focusedControllerInWindow:windowRef
					timeoutType:lockTimeoutNone])
				{
					activateInputContext = [[ActivateInputContext alloc]
						initWithParams:GetCurrentEventQueue() event:theEvent
						controller:controller];
					if (activateInputContext) {
						[NSThread detachNewThreadSelector:@selector(waitForEventComplete)
							toTarget:activateInputContext withObject:nil];
					}
				}
				break;
			case kEventWindowBoundsChanged:
				/* The handleCarbonBoundsChange, suspendAppletUpdates and
				 * resumeAppletUpdates methods (unlike most of our other
				 * handler code) expect to be called once per NSCarbonWindow
				 * object we've created.
				 */
				if (!windowRef)
					break;
				if (GetEventParameter(theEvent, kEventParamAttributes,
					typeUInt32, NULL, sizeof(eventAttributes), NULL,
					&eventAttributes) != noErr)
					eventAttributes = 0;
				/* Don't call handleCarbonBoundsChange if the window is just
				 * being dragged around without being resized.
				 */
				if (!(eventAttributes & (kWindowBoundsChangeUserResize |
					kWindowBoundsChangeSizeChanged | kWindowBoundsChangeZoom)))
					break;
				sig = [carbonWindowClass instanceMethodSignatureForSelector:
					@selector(handleCarbonBoundsChange)];
				if (sig)
					message = [NSInvocation invocationWithMethodSignature:sig];
				if (message) {
					[message setSelector:@selector(handleCarbonBoundsChange)];
					[JEPController sendToControllersInWindow:message
						carbonWindow:windowRef targetIsMyWindow:true
						timeoutType:lockTimeoutNormal];
				}
				/* Only call resumeAppletUpdates if our bounds have changed
				 * because zooming (in our out) has completed.
				 */
				if (eventAttributes & kWindowBoundsChangeZoom) {
					message = nil;
					sig = [JEPController instanceMethodSignatureForSelector:
						@selector(resumeAppletUpdates)];
					if (sig)
						message = [NSInvocation invocationWithMethodSignature:sig];
					if (message) {
						[message setSelector:@selector(resumeAppletUpdates)];
						[JEPController sendToControllersInWindow:message
							carbonWindow:windowRef targetIsMyWindow:false
							timeoutType:lockTimeoutNone];
					}
				}
				break;
			/* Applets (and the window's entire content region) can sometimes
			 * become invisible when a browser window is hidden and then
			 * shown, or minimized and then restored (usually when the
			 * keyboard focus is in one of the applets).  To deal with this
			 * we suspend updates when the process of showing (or expanding)
			 * begins, and then restore them after it has finished.  Sometimes
			 * the rest of the browser page is _still_ invisible ... but that
			 * seems to be a bug in the Mozilla-family Carbon browsers.
			 */
			case kEventWindowShowing:
			case kEventWindowExpanding:
				if (!windowRef)
					break;
				sig = [JEPController instanceMethodSignatureForSelector:
					@selector(suspendAppletUpdates)];
				if (sig)
					message = [NSInvocation invocationWithMethodSignature:sig];
				if (message) {
					[message setSelector:@selector(suspendAppletUpdates)];
					[JEPController sendToControllersInWindow:message
						carbonWindow:windowRef targetIsMyWindow:false
						timeoutType:lockTimeoutNone];
				}
				break;
			case kEventWindowShown:
				if (!windowRef)
					break;
				/* Since kEventWindowHidden (above) is sometimes matched with 
				 * kEventWindowShown, we need to undo what we may have done at
				 * kEventWindowHidden.
				 */
				sig = [JEPController instanceMethodSignatureForSelector:
					@selector(unsetWindowClosing)];
				if (sig)
					message = [NSInvocation invocationWithMethodSignature:sig];
				if (message) {
					[message setSelector:@selector(unsetWindowClosing)];
					[JEPController sendToControllersInWindow:message
						carbonWindow:windowRef targetIsMyWindow:false
						timeoutType:lockTimeoutNone];
				}
				// Fall through
			case kEventWindowExpanded:
				if (!windowRef)
					break;
				sig = [JEPController instanceMethodSignatureForSelector:
					@selector(resumeAppletUpdates)];
				if (sig)
					message = [NSInvocation invocationWithMethodSignature:sig];
				if (message) {
					[message setSelector:@selector(resumeAppletUpdates)];
					[JEPController sendToControllersInWindow:message
						carbonWindow:windowRef targetIsMyWindow:false
						timeoutType:lockTimeoutNone];
				}
				break;
			default:
				break;
		}
	}

#ifdef DEBUG_EVENTS
	NSLog(@"HandleWindow: Event class is %s, kind is %u, windowRef is 0x%.8X, retval is %i",
		className, kind, windowRef, retval);
#endif

	[localPool release];
	return retval;
}

static void appQuit_break(void)
{
	return;
}

/* This is a handler for all "interesting" events associated with our
 * application -- the browser that loaded our bundle.  It's installed just
 * once (per application).
 */
static pascal OSStatus HandleApp(EventHandlerCallRef nextHandler,
	EventRef theEvent, void *userData)
{
	OSStatus retval = eventNotHandledErr;
	NSAutoreleasePool *localPool = [[NSAutoreleasePool alloc] init];
	UInt32 kind = GetEventKind(theEvent);
	UInt32 class = GetEventClass(theEvent);
	char className[10] = {0};
	JEPController *controller = nil;
	WindowRef carbonWindow = nil;
	ActivateInputContext *activateInputContext;
	Boolean boolFalse = false;

	if (!localPool)
		return eventNotHandledErr;
	memcpy(className, &class, 4);

	if (class == kEventClassApplication) {
		switch (kind) {
			case kEventAppActivated:
				nsAppActive = true;
				carbonWindow = GetUserFocusWindow();
				if (carbonWindow) {
					SetWindowProperty(carbonWindow, kJEPCreatorCode,
						kPropertyMouseActivated, sizeof(Boolean), &boolFalse);
				}
				/* See the ActivateInputContext class in Controller.m */
				if (controller =
					[JEPController focusedControllerInWindow:carbonWindow
						timeoutType:lockTimeoutNone])
				{
					activateInputContext = [[ActivateInputContext alloc]
						initWithParams:GetCurrentEventQueue() event:theEvent
						controller:controller];
					if (activateInputContext) {
						[NSThread detachNewThreadSelector:
							@selector(waitForEventComplete)
							toTarget:activateInputContext withObject:nil];
					}
				}
				break;
			case kEventAppDeactivated:
				nsAppActive = false;
				break;
			case kEventAppQuit:
				appQuit_break();
				if (nsAppShadow)
					[nsAppShadow applicationWillTerminate:nil];
				break;
			default:
				break;
		}
	} else if (class == kEventClassCommand) {
		/* Mozilla.org Carbon-based browsers can behave strangely on menu
		 * commands if a JVM-created window is top-most when those commands
		 * are invoked.  At worst the JEP (and the browser) can end up in an
		 * unstable state -- if the JVM-created window is above a browser
		 * window containing an applet when "Quit" is chosen from the
		 * "Firefox" (or "Seamonkey") menu.  The following code works around
		 * this problem by swallowing the "Quit" command when it won't be
		 * handled correctly, and changing the window disposition so that the
		 * command can be invoked a second time (by the user), and this time
		 * be handled without trouble.
		 */
		/* Before JEP 0.9.5+h this fix used to be much more aggressive -- for
		 * example it intervened for _any_ menu command.  But this led to very
		 * strange results with context menus, and still didn't eliminate the
		 * wierdness completely.  Now I've decided to get rid of only the most
		 * serious wierdness (what happens with the Quit command), and leave
		 * the rest all hanging out.  For example, when a JVM window is key
		 * and in front, the About command has a different result, and the New
		 * Window and New Tab commands don't work at all.  I doubt very much
		 * I'll ever be able to fix all of this crap.  This change resolves
		 * http://sourceforge.net/tracker/index.php?func=detail&aid=1560855&group_id=107955&atid=649116.
		 */
		HICommand command = {0};
		NSArray *onscreenNSWindows = [NSApp orderedWindows];
		if (GetEventParameter(theEvent, kEventParamDirectObject,
			typeHICommand, nil, sizeof(HICommand), nil, &command) != noErr)
			memset(&command, 0, sizeof(HICommand));
		if (onscreenNSWindows && (command.commandID == kHICommandQuit)) {
			unsigned count, i;
			Boolean done = false;
			WindowRef jvmWindow = nil;
			/* If the first window in the list of on-screen NSWindows belongs
			 * to the CocoaAppWindow class, swallow the current HICommand (by
			 * setting retval to noErr).  Then keep going down the list until
			 * we find an NSWindow that's visible and doesn't belong to the
			 * CocoaAppWindow class (this should always be a browser window or
			 * one of its children) -- if we find one, make it key and put it
			 * in front.
			 */
			count = [onscreenNSWindows count];
			for (i = 1; i <= count; ++i) {
				NSWindow *aWindow = [onscreenNSWindows objectAtIndex:i-1];
				if ([aWindow isKindOfClass:NSClassFromString(@"CocoaAppWindow")]) {
					if (!jvmWindow)
						jvmWindow = [MyNSWindow existingCarbonWindowFor:aWindow];
					retval = noErr;
				} else {
					if (![aWindow isKindOfClass:carbonWindowClass])
						continue;
					if (retval != noErr)
						break;
					if ([aWindow isVisible]) {
						[aWindow makeKeyAndOrderFront:nil];
						done = true;
						break;
					}
				}
			}
			/* Browser windows that don't have a corresponding NSCarbonWindow
			 * won't be included in onscreenNSWindows, so if need be look next
			 * for a visible Carbon-only browser window to activate.  (Be
			 * careful to exclude the Carbon window that corresponds to the
			 * browser's icon in the Dock -- which (oddly) can be activated
			 * (it has kWindowActivationScopeAll), but which isn't
			 * collapsable.)
			 */
			if (jvmWindow && !done) {
				WindowRef aWindow = GetNextWindow(jvmWindow);
				while (aWindow) {
					WindowActivationScope scope = 0;
					if (GetWindowActivationScope(aWindow, &scope) != noErr)
						scope = 0;
					if ((scope != kWindowActivationScopeAll) ||
						!IsWindowVisible(aWindow) ||
						!IsWindowCollapsable(aWindow))
					{
						aWindow = GetNextWindow(aWindow);
						continue;
					}
					if (!IsWindowActive(aWindow)) {
						SelectWindow(aWindow);
						done = true;
						break;
					} else if (!IsWindowHilited(aWindow)) {
						BringToFront(aWindow);
						ShowWindow(aWindow);
						done = true;
						break;
					}
					aWindow = GetNextWindow(aWindow);
				}
			}
			/* If we didn't find any suitable browser window, create and send
			 * a "reopen" Apple event (which should force the browser to open
			 * a new browser window and make it active).
			 */
			if ((retval == noErr) && !done) {
				OSErr errval;
				AppleEvent aeEvent, aeReply;
				AEAddressDesc aeAddress;
				ProcessSerialNumber aeProc = {0};
				GetCurrentProcess(&aeProc);
				AECreateDesc(typeNull, NULL, 0, &aeEvent);
				AECreateDesc(typeNull, NULL, 0, &aeReply);
				AECreateDesc(typeNull, NULL, 0, &aeAddress);
				errval = AECreateDesc(typeProcessSerialNumber, (Ptr) &aeProc,
					sizeof(aeProc), &aeAddress);
				if (errval == noErr) {
					errval = AECreateAppleEvent(kCoreEventClass,
						kAEReopenApplication, &aeAddress, kAutoGenerateReturnID,
						kAnyTransactionID, &aeEvent);
				}
				if (errval == noErr) {
					errval = AESend(&aeEvent, &aeReply, kAENoReply,
						kAENormalPriority, kAEDefaultTimeout, NULL, NULL);
				}
			}
		}
	/* It's actually possible for the Mozilla.org Carbon handler(s) installed
	 * on the "window" target to _expand_ a kEventWindowUpdate's update region.
	 * A kEventClassWindow event is sent first to the "window" target and then
	 * to the "application" target (before (possibly) being passed to
	 * WaitNextEvent()).  So we check here for any change to the update
	 * region's outer bounds -- and if we find one we vet the update again
	 * through JEPController handleCarbonUpdate.  This may not help with
	 * current Firefox and Seamonkey releases.  But it _does_ seem to help (a
	 * little) with the changes at bmo bug 332579 (which gets rid of
	 * WaitNextEvent() and replaces it with a Carbon handler on the
	 * "application" target (in widget/src/mac/nsMacMessagePump.cpp).  (The
	 * first non-nightly these changes appeared in was BonEcho Alpha 2.)
	 */
	} else if ((class == kEventClassWindow) && (kind == kEventWindowUpdate)) {
		WindowRef carbonWindow;
		NSMutableArray *controllersFound;
		if (GetEventParameter(theEvent, kEventParamDirectObject,
			typeWindowRef, NULL, sizeof(WindowRef), NULL,
			&carbonWindow) != noErr)
			carbonWindow = nil;
		if ((controllersFound = [JEPController
			controllersInWindow:carbonWindow timeoutType:lockTimeoutNormal]) != nil)
		{
			Rect updateRect = {0};
			Rect updateRectOrg = {0};
			GetWindowBounds(carbonWindow, kWindowUpdateRgn, &updateRect);
			if (GetEventParameter(theEvent, kEventParamOrigUpdate,
				typeQDRectangle, NULL, sizeof(Rect), NULL,
				&updateRectOrg) != noErr)
				updateRectOrg = updateRect;
			if (!EmptyRect(&updateRect) &&
				!EqualRectFuzzy(updateRect, updateRectOrg, 0))
			{
				unsigned count, i;
				count = [controllersFound count];
				for (i = 1; i <= count; ++i) {
					JEPController *aController =
						[controllersFound objectAtIndex:i-1];
					OSStatus retval2 =
						[aController handleCarbonUpdate:theEvent];
					if (retval2 == noErr) {
						retval = noErr;
						break;
					}
				}
			}
			[controllersFound removeAllObjects];
			[controllersFound release];
		}
#ifdef PRINT_ALL_CARBON_EVENTS
	} else if (class == kEventClassTarget) {
		EventRef anEvent = nil;
		Boolean alreadyPrinted = false;
		Boolean boolTrue = true;
		UInt32 aKind = 0, aClass = 0;
		if (kind == kEventTargetGetNext) {
			if (GetEventParameter(theEvent, kEventParamEventRef,
				typeEventRef, NULL, sizeof(EventRef), NULL,
				&anEvent) != noErr)
				anEvent = nil;
		} else {
			anEvent = theEvent;
		}
		if (anEvent) {
			if (GetEventParameter(anEvent, kEventParamAlreadyPrinted,
				typeBoolean, NULL, sizeof(Boolean), NULL,
				&alreadyPrinted) != noErr)
				alreadyPrinted = false;
			if (!alreadyPrinted) {
				aKind = GetEventKind(anEvent);
				aClass = GetEventClass(anEvent);
				if (((aClass != kEventClassTarget) || (aKind != kEventTargetGetNext)) &&
					((aClass != kEventClassMouse) || (aKind != kEventMouseMoved)))
					DebugPrintEvent(anEvent);
				SetEventParameter(anEvent, kEventParamAlreadyPrinted,
					typeBoolean, sizeof(Boolean), &boolTrue);
			}
		}
		[localPool release];
		return eventNotHandledErr;
#endif
	}
#ifdef DEBUG_EVENTS
	NSLog(@"HandleApp: Event class is %s, kind is %u, retval is %i",
		className, kind, retval);
#endif
	[localPool release];
	return retval;
}

/* Yet another application quit handler (installed just once, per application).
 */
static pascal OSErr HandleAEQuit(const AppleEvent *theAppleEvent,
	AppleEvent *reply, SInt32 handlerRefcon)
{
	OSErr retval;
	AEEventClass eventClass;
	AEEventID eventID;
	char eventClassName[10] = {0};
	char eventIDName[10] = {0};
	DescType actualType;
	Size actualSize;
	NSAutoreleasePool *localPool = [[NSAutoreleasePool alloc] init];

	if (!localPool)
		return errAEEventNotHandled;

	if ((retval = AEGetAttributePtr(theAppleEvent, keyEventClassAttr, typeType,
		&actualType, &eventClass, sizeof(eventClass), &actualSize)) != noErr)
	{
		[localPool release];
		return retval;
	}
	if ((retval = AEGetAttributePtr(theAppleEvent, keyEventIDAttr, typeType,
		&actualType, &eventID, sizeof(eventID), &actualSize)) != noErr)
	{
		[localPool release];
		return retval;
	}
	memcpy(eventClassName, &eventClass, 4);
	memcpy(eventIDName, &eventID, 4);
#ifdef DEBUG_EVENTS
	NSLog(@"HandleAEQuit: eventClass is %s, eventID is %s", eventClassName,
		eventIDName);
#endif

	if ((eventClass == kCoreEventClass) && (eventID == kAEQuitApplication)) {
		if (nsAppShadow)
			[nsAppShadow applicationWillTerminate:nil];
	}

	[localPool release];
	return errAEEventNotHandled;
}

/* Handler for kEventClassTextInput events -- for Carbon events associated
 * with TSM.  For Mozilla and Firefox (which use Apple event handlers to deal
 * with TSM input) this handler serves no purpose.  But it would be useful
 * for other Carbon-based browsers that use Carbon event handlers to handle
 * TSM input.  This handler only gets installed when the user focus is in
 * an applet view.
 */
static pascal OSStatus HandleTSM(EventHandlerCallRef nextHandler,
	EventRef theEvent, void *userData)
{
	OSStatus nextRetval = -1;
	OSStatus retval = eventNotHandledErr;
	NSAutoreleasePool *localPool = [[NSAutoreleasePool alloc] init];
	wchar_t blankUnichar[1] = {0};
	long zeroLong = 0;
	UInt32 kind = GetEventKind(theEvent);
	UInt32 class = GetEventClass(theEvent);
#ifdef DEBUG_EVENTS
	char className[10] = {0};
	memcpy(className, &class, 4);
#endif
	if (!localPool)
		return eventNotHandledErr;
	/* Trial and error shows that, when the host browser's TSM context is
	 * interrupted (by using TSM input in an applet), the browser's
	 * Apple event TSM handlers will crash when they receive the equivalents
	 * of the following events, if the content has not previously been
	 * removed.  So I assume that we need to perform the same service for
	 * browsers that use Carbon event handlers to handle TSM input.
	 */
	if (class == kEventClassTextInput) {
		if (kind == kEventTextInputUpdateActiveInputArea) {
			//NSLog(@"HandleTSM: Blanking out input in kEventTextInputUpdateActiveInputArea event");
			SetEventParameter(theEvent, kEventParamTextInputSendFixLen,
				typeLongInteger, sizeof(zeroLong), &zeroLong);
			SetEventParameter(theEvent, kEventParamTextInputSendText,
				typeUnicodeText, sizeof(blankUnichar), blankUnichar);
		} else if (kind == kEventTextInputUnicodeForKeyEvent) {
			//NSLog(@"HandleTSM: Blanking out input in kEventTextInputUnicodeForKeyEvent event");
			SetEventParameter(theEvent, kEventParamTextInputSendText,
				typeUnicodeText, sizeof(blankUnichar), blankUnichar);
		} else if (kind == kEventTextInputUnicodeText) {
			//NSLog(@"HandleTSM: Blanking out input in kEventTextInputUnicodeText event");
			SetEventParameter(theEvent, kEventParamTextInputSendText,
				typeUnicodeText, sizeof(blankUnichar), blankUnichar);
		}
	}
	if (nextHandler)
		retval = nextRetval = CallNextEventHandler(nextHandler, theEvent);
#ifdef DEBUG_EVENTS
	NSLog(@"HandleTSM: Event class is %s, kind is %u, retval is %i, nextRetval = %i",
		className, kind, retval, nextRetval);
#endif
	[localPool release];
	return retval;
}

/* Handler for Apple events associated with TSM.  Unlike most of the other
 * handlers, this one is installed just once (per application), rather than
 * for the most recently created JEPController object.  The reason is that
 * special handling is needed for TSM input once any NSCarbonWindow object has
 * been created -- even if no applet or applet view currently exists in any
 * window.
 */
static pascal OSErr HandleAETSM(const AppleEvent *theAppleEvent,
	AppleEvent *reply, SInt32 handlerRefcon)
{
	OSErr retval;
	AppleEvent eventCopy;
	AEEventClass eventClass;
	AEEventID eventID;
	char eventClassName[10] = {0};
	char eventIDName[10] = {0};
	DescType actualType;
	Size actualSize;
	WindowRef carbonWindow = nil;
	Boolean visible = false;
	WindowLatentVisibility latent = 0;
	TSMDocumentID currentActiveDoc = nil;
	Boolean isActiveDocCocoa = false;
	NSAutoreleasePool *localPool = [[NSAutoreleasePool alloc] init];

	if (!localPool)
		return eventNotHandledErr;

#ifdef DEBUG_EVENTS
	NSLog(@"HandleAETSM: Called");
#endif

	if ((retval = AEGetAttributePtr(theAppleEvent, keyEventClassAttr, typeType,
		&actualType, &eventClass, sizeof(eventClass), &actualSize)) != noErr)
	{
		[localPool release];
		return retval;
	}
	if ((retval = AEGetAttributePtr(theAppleEvent, keyEventIDAttr, typeType,
		&actualType, &eventID, sizeof(eventID), &actualSize)) != noErr)
	{
		[localPool release];
		return retval;
	}

	memcpy(eventClassName, &eventClass, 4);
	memcpy(eventIDName, &eventID, 4);
#ifdef DEBUG_EVENTS
	NSLog(@"HandleAETSM: eventClass is %s, eventID is %s", eventClassName,
		eventIDName);
#endif

	if (eventClass != kTextServiceClass) {
		[localPool release];
		return errAEEventNotHandled;
	}

	if ((carbonWindow = GetUserFocusWindow()) == nil) {
#ifdef DEBUG_EVENTS
		NSLog(@"HandleAETSM: returning errAEEventNotHandled because no key window");
#endif
		[localPool release];
		return errAEEventNotHandled;
	}

	/* Swallow the current event if the user focus is in an applet view */
	if ([JEPController windowHasKeyWindow:carbonWindow
		timeoutType:lockTimeoutNone])
	{
#ifdef DEBUG_EVENTS
		NSLog(@"HandleAETSM: returning errAEEventNotHandled because in Cocoa");
#endif
		[localPool release];
		return errAEEventNotHandled;
	}

	/* Swallow the current event if the active TSM doc belongs to a Cocoa
	 * input context.  Doing this check makes it possible to get rid of our
	 * (old) check for a non-zero "default input method".  That check
	 * inadvertently caught cases where Firefox had failed to activate one of
	 * its own TSM docs when that doc's window was made active (this usually
	 * left it set to a "Cocoa-specific" TSM doc, which caused a crash here).
	 * Now we catch these errors on purpose.  This change resolves bmo bug
	 * 347041.  Previously the "default input method" check had already been
	 * relaxed (by making an exception for kUnicodeNotFromInputMethod events)
	 * to resolve bmo bug 313807.
	 */
	currentActiveDoc = TSMGetActiveDocument();
	if (!currentActiveDoc || (TSMGetDocumentProperty(currentActiveDoc,
		kPropertyCocoaTSMDoc, sizeof(Boolean), nil, &isActiveDocCocoa) != noErr))
		isActiveDocCocoa = false;
	if (isActiveDocCocoa) {
#ifdef DEBUG_EVENTS
		NSLog(@"HandleAETSM: returning errAEEventNotHandled because Cocoa TSM doc is active");
#endif
		[localPool release];
		return errAEEventNotHandled;
	}

	/* This handler sometimes gets called when an inappropriate window has the
	 * user focus -- which leads to crashes when we call the browser's Apple
	 * event handlers below.  An "appropriate" window is either a browser
	 * window, one of its "child" windows, or the Dock window.  Before JEP
	 * 0.9.5+g, we labeled each browser window in which we'd ever created an
	 * applet, and considered "appropriate" every window that had such a label
	 * or was above a labelled window in the "window list" (Carbon has no
	 * concept of parent or child windows).  But if none of the browser's
	 * windows contain any applets (after we've created at least one), that
	 * test fails even on an "appropriate" window.  Now we just check if our
	 * window is visible (since it seems that all the "inappropriate" windows
	 * in Mozilla.org browsers are invisible).  This change resolves the
	 * problem described in bmo bug 344701 comments 6-8.
	 */
	visible = IsWindowLatentVisible(carbonWindow, &latent);
	if (!visible && !latent) {
#ifdef DEBUG_EVENTS
		NSLog(@"HandleAETSM: returning errAEEventNotHandled because window invisible");
#endif
		[localPool release];
		return errAEEventNotHandled;
	}

#ifdef DEBUG_EVENTS
	{
	TSMDocumentID browserActiveDoc = nil;
	if (GetWindowProperty(carbonWindow, kJEPCreatorCode,
		kPropertyBrowserTSMDoc, sizeof(TSMDocumentID), nil,
		&browserActiveDoc) != noErr)
		browserActiveDoc = nil;
	NSLog(@"HandleAETSM: browserActiveDoc 0x%.8X, currentActiveDoc 0x%.8X, isActiveDocCocoa %i, carbonWindow 0x%.8X",
		browserActiveDoc, currentActiveDoc, isActiveDocCocoa, carbonWindow);
	}
#endif

	if ((retval = AEDuplicateDesc(theAppleEvent, &eventCopy)) != noErr) {
		[localPool release];
		return retval;
	}

	/* Otherwise pass the current event to the browser's TSM handlers */
	retval = errAEEventNotHandled;
	switch (eventID) {
		case kUpdateActiveInputArea:
			if (parentTSMAEHandlerInfo.updateActiveInputAreaHandler) {
				retval = InvokeAEEventHandlerUPP(&eventCopy, reply,
					parentTSMAEHandlerInfo.updateActiveInputAreaRefcon,
					parentTSMAEHandlerInfo.updateActiveInputAreaHandler);
			} else if (parentTSMAEHandlerInfo.textServicesHandler) {
				retval = InvokeAEEventHandlerUPP(&eventCopy, reply,
					parentTSMAEHandlerInfo.textServicesRefcon,
					parentTSMAEHandlerInfo.textServicesHandler);
			}
			break;
		case kUnicodeNotFromInputMethod:
			if (parentTSMAEHandlerInfo.unicodeNotFromInputMethodHandler) {
				retval = InvokeAEEventHandlerUPP(&eventCopy, reply,
					parentTSMAEHandlerInfo.unicodeNotFromInputMethodRefcon,
					parentTSMAEHandlerInfo.unicodeNotFromInputMethodHandler);
			} else if (parentTSMAEHandlerInfo.textServicesHandler) {
				retval = InvokeAEEventHandlerUPP(&eventCopy, reply,
					parentTSMAEHandlerInfo.textServicesRefcon,
					parentTSMAEHandlerInfo.textServicesHandler);
			}
			break;
		case kOffset2Pos:
			if (parentTSMAEHandlerInfo.offset2PosHandler) {
				retval = InvokeAEEventHandlerUPP(&eventCopy, reply,
					parentTSMAEHandlerInfo.offset2PosRefcon,
					parentTSMAEHandlerInfo.offset2PosHandler);
			} else if (parentTSMAEHandlerInfo.textServicesHandler) {
				retval = InvokeAEEventHandlerUPP(&eventCopy, reply,
					parentTSMAEHandlerInfo.textServicesRefcon,
					parentTSMAEHandlerInfo.textServicesHandler);
			}
			break;
		case kPos2Offset:
			if (parentTSMAEHandlerInfo.pos2OffsetHandler) {
				retval = InvokeAEEventHandlerUPP(&eventCopy, reply,
					parentTSMAEHandlerInfo.pos2OffsetRefcon,
					parentTSMAEHandlerInfo.pos2OffsetHandler);
			} else if (parentTSMAEHandlerInfo.textServicesHandler) {
				retval = InvokeAEEventHandlerUPP(&eventCopy, reply,
					parentTSMAEHandlerInfo.textServicesRefcon,
					parentTSMAEHandlerInfo.textServicesHandler);
			}
			break;
		case kShowHideInputWindow:
			if (parentTSMAEHandlerInfo.showHideInputWindowHandler) {
				retval = InvokeAEEventHandlerUPP(&eventCopy, reply,
					parentTSMAEHandlerInfo.showHideInputWindowRefcon,
					parentTSMAEHandlerInfo.showHideInputWindowHandler);
			} else if (parentTSMAEHandlerInfo.textServicesHandler) {
				retval = InvokeAEEventHandlerUPP(&eventCopy, reply,
					parentTSMAEHandlerInfo.textServicesRefcon,
					parentTSMAEHandlerInfo.textServicesHandler);
			}
			break;
		case kGetSelectedText:
			if (parentTSMAEHandlerInfo.getSelectedTextHandler) {
				retval = InvokeAEEventHandlerUPP(&eventCopy, reply,
					parentTSMAEHandlerInfo.getSelectedTextRefcon,
					parentTSMAEHandlerInfo.getSelectedTextHandler);
			} else if (parentTSMAEHandlerInfo.textServicesHandler) {
				retval = InvokeAEEventHandlerUPP(&eventCopy, reply,
					parentTSMAEHandlerInfo.textServicesRefcon,
					parentTSMAEHandlerInfo.textServicesHandler);
			}
			break;
		default:
			break;
	}

#ifdef DEBUG_EVENTS
	NSLog(@"HandleAETSM: retval is %i", retval);
#endif
	AEDisposeDesc(&eventCopy);
	[localPool release];
	return retval;
}

/*enum { 
   kEventClassTSMDocumentAccess = 'tdac'
};

enum { 
   kEventTSMDocumentAccessGetLength = 1,
   kEventTSMDocumentAccessGetSelectedRange = 2,
   kEventTSMDocumentAccessGetCharactersPtr = 3,
   kEventTSMDocumentAccessGetCharactersPtrForLargestBuffer = 4,
   kEventTSMDocumentAccessGetCharacters = 5,
   kEventTSMDocumentAccessGetFont = 6,
   kEventTSMDocumentAccessGetGlyphInfo = 7,
   kEventTSMDocumentAccessLockDocument = 8,
   kEventTSMDocumentAccessUnlockDocument = 9
};*/

/* Called every time we change the TSM state to one appropriate for an applet
 * view (i.e. when the user focus changes from outside any applet view to
 * inside one of them).
 */
OSStatus InstallTSMEventHandler(WindowRef parentWindow,
	JEPController *controller)
{
	OSStatus retval = noErr;
	EventTypeSpec eventTypes[20] = {{0}};
	EventHandlerUPP tsmHandlerUPP = nil;
	EventHandlerRef tsmHandlerRef = nil;

	if (!parentWindow || !controller)
		return EINVAL;

	eventTypes[0].eventClass = kEventClassTextInput;
	eventTypes[0].eventKind = kEventTextInputUnicodeForKeyEvent;
	eventTypes[1].eventClass = kEventClassTextInput;
	eventTypes[1].eventKind = kEventTextInputPosToOffset;
	eventTypes[2].eventClass = kEventClassTextInput;
	eventTypes[2].eventKind = kEventTextInputOffsetToPos;
	eventTypes[3].eventClass = kEventClassTextInput;
	eventTypes[3].eventKind = kEventTextInputUpdateActiveInputArea;
	eventTypes[4].eventClass = kEventClassTextInput;
	eventTypes[4].eventKind = kEventTextInputShowHideBottomWindow;
	eventTypes[5].eventClass = kEventClassTextInput;
	eventTypes[5].eventKind = kEventTextInputGetSelectedText;
	eventTypes[6].eventClass = kEventClassTextInput;
	eventTypes[6].eventKind = kEventTextInputUnicodeText;

	/*eventTypes[7].eventClass = kEventClassTSMDocumentAccess;
	eventTypes[7].eventKind = kEventTSMDocumentAccessGetLength;
	eventTypes[8].eventClass = kEventClassTSMDocumentAccess;
	eventTypes[8].eventKind = kEventTSMDocumentAccessGetSelectedRange;
	eventTypes[9].eventClass = kEventClassTSMDocumentAccess;
	eventTypes[9].eventKind = kEventTSMDocumentAccessGetCharactersPtr;
	eventTypes[10].eventClass = kEventClassTSMDocumentAccess;
	eventTypes[10].eventKind = kEventTSMDocumentAccessGetCharactersPtrForLargestBuffer;
	eventTypes[11].eventClass = kEventClassTSMDocumentAccess;
	eventTypes[11].eventKind = kEventTSMDocumentAccessGetCharacters;
	eventTypes[12].eventClass = kEventClassTSMDocumentAccess;
	eventTypes[12].eventKind = kEventTSMDocumentAccessGetFont;
	eventTypes[13].eventClass = kEventClassTSMDocumentAccess;
	eventTypes[13].eventKind = kEventTSMDocumentAccessGetGlyphInfo;
	eventTypes[14].eventClass = kEventClassTSMDocumentAccess;
	eventTypes[14].eventKind = kEventTSMDocumentAccessLockDocument;
	eventTypes[15].eventClass = kEventClassTSMDocumentAccess;
	eventTypes[15].eventKind = kEventTSMDocumentAccessUnlockDocument;*/

	tsmHandlerUPP = NewEventHandlerUPP(HandleTSM);
	retval = InstallWindowEventHandler(parentWindow, tsmHandlerUPP,
		7, eventTypes, controller, &tsmHandlerRef);

	if (retval == noErr) {
		controller->tsmHandlerUPP = tsmHandlerUPP;
		controller->tsmHandlerRef = tsmHandlerRef;
	}

	return retval;
}

/* Called every time we create another NSCarbonWindow object (i.e. when
 * creating a new applet in a Carbon browser), but the handlers only ever
 * get installed once -- if the parent app (the browser) has Apple event
 * TSM event handlers, which we need to override.
 */
OSStatus MaybeInstallTSMAEEventHandler(void)
{
	OSStatus retval = noErr;
	AEEventHandlerUPP tsmAEHandlerUPP = nil;
	BOOL ourHandlerNeeded = FALSE;

	if (parentTSMAEHandlerInfo.handlersUpdated)
		return noErr;
	parentTSMAEHandlerInfo.handlersUpdated = TRUE;

	if (AEGetEventHandler(kTextServiceClass, typeWildCard,
		&parentTSMAEHandlerInfo.textServicesHandler,
		&parentTSMAEHandlerInfo.textServicesRefcon, FALSE) != noErr)
	{
		parentTSMAEHandlerInfo.textServicesHandler = nil;
		parentTSMAEHandlerInfo.textServicesRefcon = 0;
	}
	if (AEGetEventHandler(kTextServiceClass, kUpdateActiveInputArea,
		&parentTSMAEHandlerInfo.updateActiveInputAreaHandler,
		&parentTSMAEHandlerInfo.updateActiveInputAreaRefcon, FALSE) != noErr)
	{
		parentTSMAEHandlerInfo.updateActiveInputAreaHandler = nil;
		parentTSMAEHandlerInfo.updateActiveInputAreaRefcon = 0;
	}
	if (AEGetEventHandler(kTextServiceClass, kShowHideInputWindow,
		&parentTSMAEHandlerInfo.showHideInputWindowHandler,
		&parentTSMAEHandlerInfo.showHideInputWindowRefcon, FALSE) != noErr)
	{
		parentTSMAEHandlerInfo.showHideInputWindowHandler = nil;
		parentTSMAEHandlerInfo.showHideInputWindowRefcon = 0;
	}
	if (AEGetEventHandler(kTextServiceClass, kPos2Offset,
		&parentTSMAEHandlerInfo.pos2OffsetHandler,
		&parentTSMAEHandlerInfo.pos2OffsetRefcon, FALSE) != noErr)
	{
		parentTSMAEHandlerInfo.pos2OffsetHandler = nil;
		parentTSMAEHandlerInfo.pos2OffsetRefcon = 0;
	}
	if (AEGetEventHandler(kTextServiceClass, kOffset2Pos,
		&parentTSMAEHandlerInfo.offset2PosHandler,
		&parentTSMAEHandlerInfo.offset2PosRefcon, FALSE) != noErr)
	{
		parentTSMAEHandlerInfo.offset2PosHandler = nil;
		parentTSMAEHandlerInfo.offset2PosRefcon = 0;
	}
	if (AEGetEventHandler(kTextServiceClass, kUnicodeNotFromInputMethod,
		&parentTSMAEHandlerInfo.unicodeNotFromInputMethodHandler,
		&parentTSMAEHandlerInfo.unicodeNotFromInputMethodRefcon, FALSE) != noErr)
	{
		parentTSMAEHandlerInfo.unicodeNotFromInputMethodHandler = nil;
		parentTSMAEHandlerInfo.unicodeNotFromInputMethodRefcon = 0;
	}
	if (AEGetEventHandler(kTextServiceClass, kGetSelectedText,
		&parentTSMAEHandlerInfo.getSelectedTextHandler,
		&parentTSMAEHandlerInfo.getSelectedTextRefcon, FALSE) != noErr)
	{
		parentTSMAEHandlerInfo.getSelectedTextHandler = nil;
		parentTSMAEHandlerInfo.getSelectedTextRefcon = 0;
	}

	if (parentTSMAEHandlerInfo.textServicesHandler) {
		AERemoveEventHandler(kTextServiceClass, typeWildCard,
			parentTSMAEHandlerInfo.textServicesHandler, FALSE);
		ourHandlerNeeded = TRUE;
	}
	if (parentTSMAEHandlerInfo.updateActiveInputAreaHandler) {
		AERemoveEventHandler(kTextServiceClass, kUpdateActiveInputArea,
			parentTSMAEHandlerInfo.updateActiveInputAreaHandler, FALSE);
		ourHandlerNeeded = TRUE;
	}
	if (parentTSMAEHandlerInfo.showHideInputWindowHandler) {
		AERemoveEventHandler(kTextServiceClass, kShowHideInputWindow,
			parentTSMAEHandlerInfo.showHideInputWindowHandler, FALSE);
		ourHandlerNeeded = TRUE;
	}
	if (parentTSMAEHandlerInfo.pos2OffsetHandler) {
		AERemoveEventHandler(kTextServiceClass, kPos2Offset,
			parentTSMAEHandlerInfo.pos2OffsetHandler, FALSE);
		ourHandlerNeeded = TRUE;
	}
	if (parentTSMAEHandlerInfo.offset2PosHandler) {
		AERemoveEventHandler(kTextServiceClass, kOffset2Pos,
			parentTSMAEHandlerInfo.offset2PosHandler, FALSE);
		ourHandlerNeeded = TRUE;
	}
	if (parentTSMAEHandlerInfo.unicodeNotFromInputMethodHandler) {
		AERemoveEventHandler(kTextServiceClass, kUnicodeNotFromInputMethod,
			parentTSMAEHandlerInfo.unicodeNotFromInputMethodHandler, FALSE);
		ourHandlerNeeded = TRUE;
	}
	if (parentTSMAEHandlerInfo.getSelectedTextHandler) {
		AERemoveEventHandler(kTextServiceClass, kGetSelectedText,
			parentTSMAEHandlerInfo.getSelectedTextHandler, FALSE);
		ourHandlerNeeded = TRUE;
	}

	if (ourHandlerNeeded) {
		tsmAEHandlerUPP = NewAEEventHandlerUPP(HandleAETSM);
		retval = AEInstallEventHandler(kTextServiceClass, typeWildCard,
			tsmAEHandlerUPP, nil, FALSE);
		if (retval == noErr)
			ourTSMAEHandlerUPP = tsmAEHandlerUPP;
	}

	return retval;
}

void RemoveTSMAEEventHandler(void)
{
	AEEventHandlerUPP tsmAEHandlerUPP = ourTSMAEHandlerUPP;
	if (!ourTSMAEHandlerUPP)
		return;
	ourTSMAEHandlerUPP = nil;
	AERemoveEventHandler(kTextServiceClass, typeWildCard, tsmAEHandlerUPP, FALSE);
	DisposeAEEventHandlerUPP(tsmAEHandlerUPP);
}

/* Called every time we create another NSCarbonWindow object (i.e. when
 * creating a new applet in a Carbon browser), but the handlers only ever
 * get installed once.
 */
OSStatus MaybeInstallAppEventHandlers(void)
{
	OSStatus retval = noErr;
	EventTypeSpec eventTypes[10] = {{0}};
	EventHandlerUPP appHandlerUPPLocal = nil;
	EventHandlerRef appHandlerRefLocal = nil;
	AEEventHandlerUPP quitAEHandlerUPPLocal = nil;
	static Boolean entered = false;

	if (!entered)
		entered = true;
	else return noErr;

	if (appHandlerUPP) {
		entered = false;
		return noErr;
	}

	eventTypes[0].eventClass = kEventClassApplication;
	eventTypes[0].eventKind = kEventAppActivated;
	eventTypes[1].eventClass = kEventClassApplication;
	eventTypes[1].eventKind = kEventAppDeactivated;
	eventTypes[2].eventClass = kEventClassApplication;
	eventTypes[2].eventKind = kEventAppQuit;
	eventTypes[3].eventClass = kEventClassWindow;
	eventTypes[3].eventKind = kEventWindowUpdate;
	eventTypes[4].eventClass =  kEventClassCommand;
	eventTypes[4].eventKind = kEventCommandProcess;
#ifdef PRINT_ALL_CARBON_EVENTS
	eventTypes[5].eventClass = kEventClassTarget;
	eventTypes[5].eventKind = kEventTargetGetNext;
	eventTypes[6].eventClass = kEventClassTarget;
	eventTypes[6].eventKind = kEventTargetInstallStandard;
	eventTypes[7].eventClass = kEventClassTarget;
	eventTypes[7].eventKind = kEventTargetRemoveStandard;
	eventTypes[8].eventClass = kEventClassTarget;
	eventTypes[8].eventKind = kEventTargetHandlerInstalled;
	eventTypes[9].eventClass = kEventClassTarget;
	eventTypes[9].eventKind = kEventTargetHandlerRemoved;
	appHandlerUPPLocal = NewEventHandlerUPP(HandleApp);
	retval = InstallApplicationEventHandler(appHandlerUPPLocal,
		10, eventTypes, nil, &appHandlerRefLocal);
#else
	appHandlerUPPLocal = NewEventHandlerUPP(HandleApp);
	retval = InstallApplicationEventHandler(appHandlerUPPLocal,
		5, eventTypes, nil, &appHandlerRefLocal);
#endif

	if (retval == noErr) {
		quitAEHandlerUPPLocal = NewAEEventHandlerUPP(HandleAEQuit);
		retval = AEInstallEventHandler(kCoreEventClass, kAEQuitApplication,
			quitAEHandlerUPPLocal, nil, false);
	}

	if (retval == noErr) {
		appHandlerUPP = appHandlerUPPLocal;
		appHandlerRef = appHandlerRefLocal;
		quitAEHandlerUPP = quitAEHandlerUPPLocal;
	}

	entered = false;
	return retval;
}

void RemoveAppEventHandlers(void)
{
	EventHandlerUPP appHandlerUPPLocal = appHandlerUPP;
	EventHandlerRef appHandlerRefLocal = appHandlerRef;
	AEEventHandlerUPP quitAEHandlerUPPLocal = quitAEHandlerUPP;

	if (!appHandlerUPP)
		return;
	appHandlerUPP = nil;
	appHandlerRef = nil;
	quitAEHandlerUPP = nil;

	if (appHandlerRefLocal)
		RemoveEventHandler(appHandlerRefLocal);
	if (appHandlerUPPLocal)
		DisposeEventHandlerUPP(appHandlerUPPLocal);
	if (quitAEHandlerUPPLocal) {
		AERemoveEventHandler(kCoreEventClass, kAEQuitApplication,
			quitAEHandlerUPPLocal, false);
		DisposeAEEventHandlerUPP(quitAEHandlerUPPLocal);
	}
}

/* Called once every time we create another NSCarbonWindow object, but only
 * after having removed the handlers that we installed for NSCarbonWindow
 * objects previously created in the same window -- so there's one set of
 * these handlers per Carbon window, which may contain several applet views.
 */
OSStatus InstallCarbonEventHandlers(WindowRef parentWindow,
	JEPController *controller)
{
	OSStatus retval = noErr;
	EventTypeSpec eventTypes[20] = {{0}};
	EventHandlerUPP windowHandlerUPP = nil;
	EventHandlerRef windowHandlerRef = nil;
	EventHandlerUPP dispatcherHandlerUPP = nil;
	EventHandlerRef dispatcherHandlerRef = nil;

	if (!parentWindow || !controller)
		return EINVAL;

	eventTypes[0].eventClass = kEventClassWindow;
	eventTypes[0].eventKind = kEventWindowUpdate;
	eventTypes[1].eventClass = kEventClassWindow;
	eventTypes[1].eventKind = kEventWindowClosed;
	eventTypes[2].eventClass = kEventClassWindow;
	eventTypes[2].eventKind = kEventWindowActivated;
	eventTypes[3].eventClass = kEventClassWindow;
	eventTypes[3].eventKind = kEventWindowDeactivated;
	eventTypes[4].eventClass = kEventClassWindow;
	eventTypes[4].eventKind = kEventWindowBoundsChanged;
	eventTypes[5].eventClass = kEventClassWindow;
	eventTypes[5].eventKind = kEventWindowResizeStarted;
	eventTypes[6].eventClass = kEventClassWindow;
	eventTypes[6].eventKind = kEventWindowResizeCompleted;
	eventTypes[7].eventClass = kEventClassWindow;
	eventTypes[7].eventKind = kEventWindowBoundsChanging;
	eventTypes[8].eventClass = kEventClassWindow;
	eventTypes[8].eventKind = kEventWindowShowing;
	eventTypes[9].eventClass = kEventClassWindow;
	eventTypes[9].eventKind = kEventWindowShown;
	eventTypes[10].eventClass = kEventClassWindow;
	eventTypes[10].eventKind = kEventWindowExpanding;
	eventTypes[11].eventClass = kEventClassWindow;
	eventTypes[11].eventKind = kEventWindowExpanded;
	eventTypes[12].eventClass = kEventClassWindow;
	eventTypes[12].eventKind = kEventWindowHidden;
	windowHandlerUPP = NewEventHandlerUPP(HandleWindow);
	retval = InstallWindowEventHandler(parentWindow, windowHandlerUPP,
		13, eventTypes, controller, &windowHandlerRef);

	if (retval == noErr) {
		eventTypes[0].eventClass = kEventClassKeyboard;
		eventTypes[0].eventKind = kEventRawKeyDown;
		eventTypes[1].eventClass = kEventClassKeyboard;
		eventTypes[1].eventKind = kEventRawKeyUp;
		eventTypes[2].eventClass = kEventClassKeyboard;
		eventTypes[2].eventKind = kEventRawKeyModifiersChanged;
		eventTypes[3].eventClass = kEventClassMouse;
		eventTypes[3].eventKind = kEventMouseWheelMoved;
		eventTypes[4].eventClass = kEventClassMouse;
		eventTypes[4].eventKind = kEventMouseDown;
		eventTypes[5].eventClass = kEventClassMouse;
		eventTypes[5].eventKind = kEventMouseUp;
		eventTypes[6].eventClass = kEventClassMouse;
		eventTypes[6].eventKind = kEventMouseMoved;
		eventTypes[7].eventClass = kEventClassMouse;
		eventTypes[7].eventKind = kEventMouseDragged;
		eventTypes[8].eventClass = kEventClassMouse;
		eventTypes[8].eventKind = kEventMouseScroll;
		eventTypes[9].eventClass = kEventClassApplication;
		eventTypes[9].eventKind = kEventAppActivated;
		/* Disable part of our fix for duplicate kEventWindowActivated and
		 * kEventWindowDeactivated events.  For more info see "case
		 * kEventClassWindow" in HandleDispatcher() above.
		 */
		//eventTypes[10].eventClass = kEventClassWindow;
		//eventTypes[10].eventKind = kEventWindowActivated;
		//eventTypes[11].eventClass = kEventClassWindow;
		//eventTypes[11].eventKind = kEventWindowDeactivated;
#ifdef PRINT_ALL_CARBON_EVENTS
		eventTypes[10].eventClass = kEventClassTarget;
		eventTypes[10].eventKind = kEventTargetGetNext;
		eventTypes[11].eventClass = kEventClassTarget;
		eventTypes[11].eventKind = kEventTargetInstallStandard;
		eventTypes[12].eventClass = kEventClassTarget;
		eventTypes[12].eventKind = kEventTargetRemoveStandard;
		eventTypes[13].eventClass = kEventClassTarget;
		eventTypes[13].eventKind = kEventTargetHandlerInstalled;
		eventTypes[14].eventClass = kEventClassTarget;
		eventTypes[14].eventKind = kEventTargetHandlerRemoved;
		dispatcherHandlerUPP = NewEventHandlerUPP(HandleDispatcher);
		retval = InstallEventHandler(GetEventDispatcherTarget(),
			dispatcherHandlerUPP, 15, eventTypes, controller,
			&dispatcherHandlerRef);
#else
		dispatcherHandlerUPP = NewEventHandlerUPP(HandleDispatcher);
		retval = InstallEventHandler(GetEventDispatcherTarget(),
			dispatcherHandlerUPP, 10, eventTypes, controller,
			&dispatcherHandlerRef);
#endif
	}

	if (retval == noErr) {
		controller->windowHandlerUPP = windowHandlerUPP;
		controller->dispatcherHandlerUPP = dispatcherHandlerUPP;
		controller->windowHandlerRef = windowHandlerRef;
		controller->dispatcherHandlerRef = dispatcherHandlerRef;
	}

	return retval;
}

/* Based on sample code in "The Objective-C Programming Language" under objc_addClass().
 * (http://developer.apple.com/documentation/Cocoa/Conceptual/ObjectiveC/index.html)
 */
static BOOL PoseAsUndocumentedClass(char *originalClass, char *posingClass,
	Class *classRef, Class *posingClassRef, struct objc_method_list *instanceMethods,
	struct objc_method_list *classMethods)
{
	unsigned newNameSize;
	struct objc_class *meta_class, *super_class;
	struct objc_class *new_class, *root_class;

	super_class = (struct objc_class *) objc_lookUpClass(originalClass);
	if (super_class == nil)
		return FALSE;

	root_class = super_class;
	while (root_class->super_class != nil)
		root_class = root_class->super_class;

	new_class = calloc(2, sizeof(struct objc_class));
	meta_class = &new_class[1];

	new_class->isa = meta_class;
	new_class->info = CLS_CLASS;
	meta_class->info = CLS_META;

	newNameSize = strlen(posingClass)+1;
	if ((new_class->name = malloc(newNameSize)) == nil)
		return FALSE;
	if ((meta_class->name = malloc(newNameSize)) == nil)
		return FALSE;
	strcpy((char *)new_class->name, posingClass);
	strcpy((char *)meta_class->name, posingClass);

	if ((new_class->methodLists =
		calloc(10, sizeof(struct objc_method_list *))) == nil)
		return FALSE;
	if ((meta_class->methodLists =
		calloc(10, sizeof(struct objc_method_list *))) == nil)
		return FALSE;

	new_class->super_class = super_class;
	meta_class->super_class = super_class->isa;
	meta_class->isa = (void *) root_class->isa;

	// Very important, and missing from original sample
	new_class->instance_size = new_class->super_class->instance_size;
	meta_class->instance_size = meta_class->super_class->instance_size;

	objc_addClass(new_class);
	if (instanceMethods)
		class_addMethods(new_class, instanceMethods);
	if (classMethods)
		class_addMethods(meta_class, classMethods);

	class_poseAs(new_class, super_class);

	*classRef = objc_lookUpClass(originalClass);
	*posingClassRef = objc_lookUpClass(posingClass);

	return TRUE;
}

/* NSCarbonWindow's original handleMouseDownEvent method is broken -- it
 * doesn't allocate an autorelease pool, even though it's sometimes called
 * without one in place.
 */
static OSStatus handleMouseDownEvent_CW(id self, SEL sel, EventRef theEvent,
	Point point, WindowPartCode part, UInt32 modifiers)
{
	OSStatus retval = 0;
	struct objc_super target;
	NSAutoreleasePool *localPool;
	JEPController *ourController = nil;

	if ((localPool = [[NSAutoreleasePool alloc] init]) == nil)
		return eventNotHandledErr;

	/* Under some (unusual) circumstances, our superclass's version of this
	 * method will call NSWindow's sendEvent method -- but that will lead to
	 * the mouse down event being processed twice (once by NSWindow's
	 * sendEvent method "alone", and again by that method via Controller.m's
	 * routeEvent method).  To prevent this from happening, suspend NSWindow's
	 * sendEvent method's processing of mouse down events before we call up to
	 * our superclass, then afterwards restore its processing of mouse down
	 * events.
	 */
	ourController = [JEPController controllerFromNSWindow:self
		timeoutType:lockTimeoutNone];
	if (ourController)
		ourController->suspendMouseDown = true;

	target.receiver = self;
	target.class = [carbonWindowClassPoser superclass];
	retval = (OSStatus) objc_msgSendSuper(&target, sel, theEvent, point,
		part, modifiers);
#ifdef DEBUG_EVENTS
	NSLog(@"NSCarbonWindow: Called handleMouseDownEvent from %@, retval is %i",
		self, retval);
#endif

	if (ourController)
		ourController->suspendMouseDown = false;

	[localPool release];
	return retval;
}

/* Called once per NSCarbonWindow object that we've created (unlike most of
 * our other handler code, which is called once per Carbon window, which
 * might contain several NSCarbonWindow objects).
 */
static void handleCarbonBoundsChange_CW(id self, SEL sel)
{
	struct objc_super target;
	JEPController *controller;
	NSAutoreleasePool *localPool;
	if ((localPool = [[NSAutoreleasePool alloc] init]) == nil)
		return;
	target.receiver = self;
	target.class = [carbonWindowClassPoser superclass];
	objc_msgSendSuper(&target, sel);
	/* We need to reset the bounds of our NSCarbonWindowFrame and
	 * NSCarbonWindowContentView objects ourselves (in refreshBounds).
	 */
	if ((controller = [JEPController controllerFromNSWindow:self
		timeoutType:lockTimeoutNormal]) != nil)
		[controller refreshBounds];
	/* Recalculates the bounds of each NSCarbonWindow object.  Sometimes
	 * causes wierd ghosts unless called after refreshBounds.
	 */
	[(NSCarbonWindow *) self reconcileToCarbonWindowBounds];
#ifdef DEBUG_EVENTS
	NSLog(@"NSCarbonWindow: Called handleCarbonBoundsChange from %@", self);
#endif
	[localPool release];
}

/* Called only from our Carbon event handler, HandleWindow() above, once for
 * each Carbon window (all of whose NSCarbonWindow objects have the same
 * WindowRef).
 */
static void close_CW(id self, SEL sel)
{
	struct objc_super target;
	NSInvocation *message = nil;
	NSMethodSignature *sig = nil;
	NSNotification *arg = nil;
	sig = [JEPController instanceMethodSignatureForSelector:
		@selector(windowWillClose:)];
	if (sig)
		message = [NSInvocation invocationWithMethodSignature:sig];
	if (message) {
		[message setSelector:@selector(windowWillClose:)];
		[message setArgument:&arg atIndex:2];
		[JEPController sendToControllersInWindow:message carbonWindow:[self windowRef]
			targetIsMyWindow:false timeoutType:lockTimeoutNone];
	}
#ifdef DEBUG_EVENTS
	NSLog(@"NSCarbonWindow: Calling close from %@", self);
#endif
	target.receiver = self;
	target.class = [carbonWindowClassPoser superclass];
	objc_msgSendSuper(&target, sel);
}

/* Here we work around a bug in Apple's Cocoa-Carbon interface, and use
 * JEPController routeEvent to ensure that each event is sent to its correct
 * NSCarbonWindow object (since there may be more than on in the same Carbon
 * window).  The bug is that calling NSCarbonWindow's sendEvent method causes
 * infinite loops and crashes -- so instead we (in routeEvent) call NSWindow's
 * sendEvent method.
 */
static void sendEvent_CW(id self, SEL sel, NSEvent *theEvent)
{
#ifdef DEBUG_EVENTS
	NSLog(@"NSCarbonWindow: About to route event %@, from %@", theEvent, self);
#endif
	[JEPController routeEvent:theEvent origTarget:self];
}

/* We need to make at least one call to our applet view's makeKeyAndOrderFront
 * method after we've created it -- otherwise our window will never be correctly
 * ordered relative to other windows (ultimately this seems due to another
 * Cocoa-Carbon interface bug).  But calling that method has the side effect
 * (yet another bug) of blanking our entire window.  We can avoid this by
 * skipping one call to NSCarbonWindow's display method.  (As of JEP 0.8.4 this
 * is no longer used ... but I'm leaving it in for the time being.)
 */
static void display_CW(id self, SEL sel)
{
	struct objc_super target;
	JEPController *controller;
	NSMutableArray *controllersFound;
	BOOL skipDisplay = FALSE;
	unsigned i, count;
	if ((controllersFound = [JEPController controllersInWindow:[self windowRef]
		timeoutType:lockTimeoutNone]) != nil)
	{
		count = [controllersFound count];
		for (i = 1; i <= count; ++i) {
			controller = [controllersFound objectAtIndex:i-1];
			if (controller->skipDisplayOnce) {
				controller->skipDisplayOnce = FALSE;
				skipDisplay = TRUE;
			}
		}
		[controllersFound removeAllObjects];
		[controllersFound release];
	}
	if (skipDisplay)
		return;
	target.receiver = self;
	target.class = [carbonWindowClassPoser superclass];
	objc_msgSendSuper(&target, sel);
}

/* resignKeyWindow and becomeKeyWindow are sometimes called after their
 * NSCarbonWindow object has been destroyed.  Also, if we use the NSWindow
 * class version of these two methods plus resignMainWindow and
 * becomeMainWindow, we will avoid sending some redundant and unnecessary
 * kEventWindowActivated and kEventWindowDeactivated events.  The additional
 * handlers for resignMainWindow and becomeMainWindow help resolve bmo bug
 * 344150 (together with changes to HandleDispatcher() above).
 */
static void resignKeyWindow_CW(id self, SEL sel)
{
	struct objc_super target;
	WindowRef carbonWindow;
	NSWindow *nsWindowProperty = nil;
	JEPController *controller;
	if ((carbonWindow = [self windowRef]) != nil) {
		if (GetWindowProperty(carbonWindow, kJEPCreatorCode,
			kPropertyNSWindow, sizeof(nsWindowProperty), nil,
			&nsWindowProperty) != noErr)
		{
			nsWindowProperty = nil;
		}
	}
	if (nsWindowProperty) {
		controller = [JEPController controllerFromNSWindow:self
			timeoutType:lockTimeoutNone];
		if (!controller || [controller destroying])
			return;
	}
	target.receiver = self;
	target.class = [NSWindow class];
	objc_msgSendSuper(&target, sel);
}

static void becomeKeyWindow_CW(id self, SEL sel)
{
	struct objc_super target;
	WindowRef carbonWindow;
	NSWindow *nsWindowProperty = nil;
	JEPController *controller;
	if ((carbonWindow = [self windowRef]) != nil) {
		if (GetWindowProperty(carbonWindow, kJEPCreatorCode,
			kPropertyNSWindow, sizeof(nsWindowProperty), nil,
			&nsWindowProperty) != noErr)
		{
			nsWindowProperty = nil;
		}
	}
	if (nsWindowProperty) {
		controller = [JEPController controllerFromNSWindow:self
			timeoutType:lockTimeoutNone];
		if (!controller || [controller destroying])
			return;
	}
	target.receiver = self;
	target.class = [NSWindow class];
	objc_msgSendSuper(&target, sel);
}

static void resignMainWindow_CW(id self, SEL sel)
{
	struct objc_super target;
	target.receiver = self;
	target.class = [NSWindow class];
	objc_msgSendSuper(&target, sel);
}

static void becomeMainWindow_CW(id self, SEL sel)
{
	struct objc_super target;
	target.receiver = self;
	target.class = [NSWindow class];
	objc_msgSendSuper(&target, sel);
}

/* Here are three more methods that get called in NSCarbonWindow objects
 * (though it doesn't appear that we need to do anything more to handle
 * the events that trigger these calls).
 */

/*static BOOL reconcileToCarbonWindowBounds_CW(id self, SEL sel)
{
	BOOL retval;
	struct objc_super target;
	target.receiver = self;
	target.class = [carbonWindowClassPoser superclass];
	retval = (BOOL) objc_msgSendSuper(&target, sel);
	return retval;
}*/

/*static void _windowMovedToRect_CW(id self, SEL sel, NSRect theRect)
{
	struct objc_super target;
	target.receiver = self;
	target.class = [carbonWindowClassPoser superclass];
	objc_msgSendSuper(&target, sel, theRect);
}*/

/*static void _windowMoved_CW(id self, SEL sel, id unknown)
{
	struct objc_super target;
	target.receiver = self;
	target.class = [carbonWindowClassPoser superclass];
	objc_msgSendSuper(&target, sel, unknown);
}*/

BOOL PoseAsNSCarbonWindow(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	/* i0@4:8^{OpaqueEventRef=}12{Point=ss}16s20I24 */
	/* v0@4:8@12 */
	//{
	//struct objc_method *blah1, *blah2;
	//blah1 = class_getInstanceMethod(NSClassFromString(@"NSCarbonWindow"),
	//	@selector(handleMouseDownEvent:at:inPart:withMods:));
	//NSLog(@"method_types for handleMouseDownEvent is %s", blah1->method_types);
	//blah2 = class_getInstanceMethod(NSClassFromString(@"NSCarbonWindow"),
	//	@selector(sendEvent:));
	//NSLog(@"method_types for sendEvent is %s", blah2->method_types);
	//}
	/* */

	if ((instance_methods =
		calloc(20, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 9;
	instance_methods->method_list[0].method_name =
		sel_registerName("handleMouseDownEvent:at:inPart:withMods:");
	instance_methods->method_list[0].method_types =
		"i0@4:8^{OpaqueEventRef=}12{Point=ss}16s20I24";
	instance_methods->method_list[0].method_imp =
		(IMP) handleMouseDownEvent_CW;
	instance_methods->method_list[1].method_name =
		sel_registerName("handleCarbonBoundsChange");
	instance_methods->method_list[1].method_types = "v0@4:8";
	instance_methods->method_list[1].method_imp =
		(IMP) handleCarbonBoundsChange_CW;
	instance_methods->method_list[2].method_name =
		sel_registerName("close");
	instance_methods->method_list[2].method_types = "v0@4:8";
	instance_methods->method_list[2].method_imp =
		(IMP) close_CW;
	instance_methods->method_list[3].method_name =
		sel_registerName("sendEvent:");
	instance_methods->method_list[3].method_types = "v0@4:8@12";
	instance_methods->method_list[3].method_imp =
		(IMP) sendEvent_CW;
	instance_methods->method_list[4].method_name =
		sel_registerName("display");
	instance_methods->method_list[4].method_types = "v0@4:8";
	instance_methods->method_list[4].method_imp =
		(IMP) display_CW;
	instance_methods->method_list[5].method_name =
		sel_registerName("resignKeyWindow");
	instance_methods->method_list[5].method_types = "v0@4:8";
	instance_methods->method_list[5].method_imp =
		(IMP) resignKeyWindow_CW;
	instance_methods->method_list[6].method_name =
		sel_registerName("becomeKeyWindow");
	instance_methods->method_list[6].method_types = "v0@4:8";
	instance_methods->method_list[6].method_imp =
		(IMP) becomeKeyWindow_CW;
	instance_methods->method_list[7].method_name =
		sel_registerName("resignMainWindow");
	instance_methods->method_list[7].method_types = "v0@4:8";
	instance_methods->method_list[7].method_imp =
		(IMP) resignMainWindow_CW;
	instance_methods->method_list[8].method_name =
		sel_registerName("becomeMainWindow");
	instance_methods->method_list[8].method_types = "v0@4:8";
	instance_methods->method_list[8].method_imp =
		(IMP) becomeMainWindow_CW;

	retval = PoseAsUndocumentedClass("NSCarbonWindow", "MyNSCarbonWindow",
		&carbonWindowClass, &carbonWindowClassPoser, instance_methods, NULL);

	return retval;
}

/* NSCarbonWindowContentView's version of this method erases the whole
 * window before (re)drawing an applet view object!!  Which we don't
 * need.  We'll fix the problem by doing nothing here and never calling
 * super.  (Versions prior to 0.8.2 did fancy clipping here before
 * erasing the unclipped part (if any) of aRect.  But it's easier to do
 * this in AppletView's drawRect method -- which is where we now do it.)
 * (As of Tiger, Mac OS X uses some NSCarbonWindow objects (and their
 * associated NSCarbonWindowContentView and NSCarbonWindowFrame objects)
 * in Carbon apps on its own account.  An example is the OS's "Print"
 * dialog for Carbon apps.  So now we need to make sure we only fiddle
 * with "our" windows.)
 */
static void drawRect_CWV(id self, SEL sel, NSRect aRect)
{
	struct objc_super target;
	NSWindow *cocoaWindow = nil;
	WindowRef carbonWindow = nil;
	NSWindow *nsWindowProperty = nil;
	/* We can't use controllerFromNSWindow or similar methods to check whether
	 * or not "self" is "our" window -- they wouldn't work if the applet once
	 * associated with "self" had been destroyed.  In Controller.m's
	 * CreateCocoaWindow() we set our parent window's kPropertyNSWindow
	 * property to the latest NSCarbonWindow we've created in it.  myWindow's
	 * windowRef is the same as our parent window.  So the presence of this
	 * property indicates that "self" is "our" window, and its absence
	 * indicates that it isn't "our" window.  (We don't care about the actual
	 * value of nsWindowProperty.)
	 */
	if ((cocoaWindow = [self window]) != nil) {
		if ((carbonWindow = [cocoaWindow windowRef]) != nil) {
			if (GetWindowProperty(carbonWindow, kJEPCreatorCode,
				kPropertyNSWindow, sizeof(nsWindowProperty), nil,
				&nsWindowProperty) != noErr)
			{
				nsWindowProperty = nil;
			}
		}
	}
	if (nsWindowProperty)
		return;
	target.receiver = self;
	target.class = [carbonWindowViewClassPoser superclass];
	objc_msgSendSuper(&target, sel, aRect);
}

/* Needed to shift the coordinate system's origin from the bottom left
 * (Cocoa's default) to the top left (Carbon's default).  (As of Tiger,
 * Mac OS X uses some NSCarbonWindow objects (and their associated
 * NSCarbonWindowContentView and NSCarbonWindowFrame objects) in Carbon
 * apps on its own account.  An example is the OS's "Print" dialog for
 * Carbon apps.  So now we need to make sure we only fiddle with "our"
 * windows.)
 */
static BOOL isFlipped_CWV(id self, SEL sel)
{
	int retval;
	struct objc_super target;
	NSWindow *cocoaWindow = nil;
	WindowRef carbonWindow = nil;
	NSWindow *nsWindowProperty = nil;
	if ((cocoaWindow = [self window]) != nil) {
		if ((carbonWindow = [cocoaWindow windowRef]) != nil) {
			if (GetWindowProperty(carbonWindow, kJEPCreatorCode,
				kPropertyNSWindow, sizeof(nsWindowProperty), nil,
				&nsWindowProperty) != noErr)
			{
				nsWindowProperty = nil;
			}
		}
	}
	if (nsWindowProperty)
		return TRUE;
	target.receiver = self;
	target.class = [carbonWindowViewClassPoser superclass];
	retval = (int) objc_msgSendSuper(&target, sel);
	return (BOOL) retval;
}

BOOL PoseAsNSCarbonWindowContentView(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 2;
	instance_methods->method_list[0].method_name =
		sel_registerName("isFlipped");
	instance_methods->method_list[0].method_types = "c0@4:8";
	instance_methods->method_list[0].method_imp =
		(IMP) isFlipped_CWV;
	instance_methods->method_list[1].method_name =
		sel_registerName("drawRect:");
	instance_methods->method_list[1].method_types =
		"v0@4:8{_NSRect={_NSPoint=ff}{_NSSize=ff}}12";
	instance_methods->method_list[1].method_imp =
		(IMP) drawRect_CWV;

	retval = PoseAsUndocumentedClass("NSCarbonWindowContentView",
		"MyNSCarbonWindowContentView", &carbonWindowViewClass,
		&carbonWindowViewClassPoser, instance_methods, NULL);

	return retval;
}

/* This method doesn't do anything.  But without it you get error messages
 * that NSCarbonWindowFrame doesn't implement such a method.
 */
static id contentFill_CWF(id self, SEL sel)
{
	return nil;
}

/* By default, the NSCarbonWindowFrame object that's created during an
 * applet view's initialization has the dimensions of the entire
 * window that it's created in -- not just it's content region.  But this
 * means that an applet view object positioned at 0,0 overwrites the
 * title bar!!  We fix this problem here.  By the way, after initialization
 * the Carbon window's content view is an NSCarbonWindowContentView object,
 * but above it (it's superview) is an NSCarbonWindowFrame object!  I
 * suppose this has to do with the "model-view-controller" model used by
 * Apple's Web Kit (see "Displaying Web Content"
 * http://developer.apple.com/documentation/Cocoa/Conceptual/DisplayWebContent/index.html)
 * (As of Tiger, Mac OS X uses some NSCarbonWindow objects (and their
 * associated NSCarbonWindowContentView and NSCarbonWindowFrame objects)
 * in Carbon apps on its own account.  An example is the OS's "Print"
 * dialog for Carbon apps.  So now we need to make sure we only fiddle with
 * "our" windows.)
 */
static void setFrameSize_CWF(id self, SEL sel, NSSize newSize)
{
	struct objc_super target;
	Rect frameCarbon = {0};
	NSRect frameCocoa = {{0},{0}};
	NSWindow *window = [self window];
	JEPController *controller;
	controller = [JEPController controllerFromNSWindow:window
		timeoutType:lockTimeoutNone];
	if (controller && window) {
		GetWindowBounds([window windowRef], kWindowContentRgn, &frameCarbon);
		frameCocoa.origin.x = frameCocoa.origin.y = 0;
		frameCocoa.size.width = frameCarbon.right - frameCarbon.left;
		frameCocoa.size.height = frameCarbon.bottom - frameCarbon.top;
		if (newSize.height > frameCocoa.size.height)
			newSize.height = frameCocoa.size.height;
		if (newSize.width > frameCocoa.size.width)
			newSize.width = frameCocoa.size.width;
	}
	target.receiver = self;
	target.class = [carbonWindowFrameClassPoser superclass];
	objc_msgSendSuper(&target, sel, newSize);
}

/* Needed to shift the coordinate system's origin from the bottom left
 * (Cocoa's default) to the top left (Carbon's default).  (As of Tiger,
 * Mac OS X uses some NSCarbonWindow objects (and their associated
 * NSCarbonWindowContentView and NSCarbonWindowFrame objects) in Carbon
 * apps on its own account.  An example is the OS's "Print" dialog for
 * Carbon apps.  So now we need to make sure we only fiddle with "our"
 * windows.)
 */
static BOOL isFlipped_CWF(id self, SEL sel)
{
	int retval;
	struct objc_super target;
	NSWindow *cocoaWindow = nil;
	WindowRef carbonWindow = nil;
	NSWindow *nsWindowProperty = nil;
	if ((cocoaWindow = [self window]) != nil) {
		if ((carbonWindow = [cocoaWindow windowRef]) != nil) {
			if (GetWindowProperty(carbonWindow, kJEPCreatorCode,
				kPropertyNSWindow, sizeof(nsWindowProperty), nil,
				&nsWindowProperty) != noErr)
			{
				nsWindowProperty = nil;
			}
		}
	}
	if (nsWindowProperty)
		return TRUE;
	target.receiver = self;
	target.class = [carbonWindowFrameClassPoser superclass];
	retval = (int) objc_msgSendSuper(&target, sel);
	return (BOOL) retval;
}

BOOL PoseAsNSCarbonWindowFrame(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	/* v0@4:8{_NSSize=ff}12 */
	//{
	//struct objc_method *blah;
	//blah = class_getInstanceMethod(NSClassFromString(@"NSCarbonWindowFrame"),
	//	@selector(setFrameSize:));
	//NSLog(@"method_types for setFrameSize is %s", blah->method_types);
	//}
	/* */

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 3;
	instance_methods->method_list[0].method_name =
		sel_registerName("contentFill");
	instance_methods->method_list[0].method_types = "@0@4:8";
	instance_methods->method_list[0].method_imp =
		(IMP) contentFill_CWF;
	instance_methods->method_list[1].method_name =
		sel_registerName("setFrameSize:");
	instance_methods->method_list[1].method_types = "v0@4:8{_NSSize=ff}12";
	instance_methods->method_list[1].method_imp =
		(IMP) setFrameSize_CWF;
	instance_methods->method_list[2].method_name =
		sel_registerName("isFlipped");
	instance_methods->method_list[2].method_types = "c0@4:8";
	instance_methods->method_list[2].method_imp =
		(IMP) isFlipped_CWF;

	retval = PoseAsUndocumentedClass("NSCarbonWindowFrame",
		"MyNSCarbonWindowFrame", &carbonWindowFrameClass,
		&carbonWindowFrameClassPoser, instance_methods, NULL);

	return retval;
}

/* This method contains part of our grand strategy to ensure that our applet
 * view is clipped correctly.  All Cocoa-initiated ("first thread") drawing
 * operations on a whole applet view come through this method.  Sometimes one
 * of the parts will be drawn using a different drawRect method, but we have
 * other ways to clip those parts (see drawRect_AWTBN() and so-forth below).
 * No asynchronous Java-initiated "second thread" drawing comes through here,
 * but likewise we have other ways of dealing with it (see handleEvent() and
 * getGraphics() in MyCPanel.java, MyCAppletFrame.java, MyCCanvas141.java
 * and MyCCanvas142.java).  Asnychronous "third thread" drawing gets clipped
 * in lockFocusIfCanDraw_AWT() below (in Java versions prior to Java 1.4.2
 * Update 1).
 */
static void drawRect_AWT(id self, SEL sel, NSRect aRect)
{
	struct objc_super target;
	JEPController *controller;
	WindowRef carbonWindow;
	NSWindow *cocoaWindow;
	NSWindow *nsWindowProperty;

	target.receiver = self;
	target.class = [awtViewClassPoser superclass];

	/* We're now also setting the kJEPCreatorCode in Cocoa apps (see
	 * CreateCocoaWindow() in Controller.m).  We need it to help avoid crashes
	 * that happen here in OS X 10.2.8, especially in Camino.  These crashes
	 * tend to be triggered by switching between pages that contain lots of
	 * applets.
	 */
	if (osxVersion < 0x1030) {
		nsWindowProperty = nil;
		if ((cocoaWindow = [self window]) != nil) {
			carbonWindow = [MyNSWindow existingCarbonWindowFor:cocoaWindow];
			if (carbonWindow) {
				if (GetWindowProperty(carbonWindow, kJEPCreatorCode,
					kPropertyNSWindow, sizeof(nsWindowProperty), nil,
					&nsWindowProperty) != noErr)
				{
					nsWindowProperty = nil;
				}
			}
		}
		if (!nsWindowProperty) {
			objc_msgSendSuper(&target, sel, aRect);
			return;
		}
	}

	controller = [JEPController controllerContainingNSView:self
		timeoutType:lockTimeoutNormal];
	if (osxVersion < 0x1030) {
		if (!controller || [controller destroying])
			return;
	} else {
		if (controller && [controller destroying]) {
			[NSBezierPath clipRect:NSZeroRect];
			objc_msgSendSuper(&target, sel, aRect);
			return;
		}
	}
	if (controller && controller->myAppletView) {
		if (!controller->appletWindow && (osxVersion < 0x1040))
			controller->appletWindow = [self cWindow];
		if (controller->appletWindow && !controller->appletAWTContext) {
			if ([controller->appletWindow
				respondsToSelector:@selector(getNSViewAWTContext)])
			{
				controller->appletAWTContext =
					[controller->appletWindow getNSViewAWTContext];
			} else if ([controller->appletWindow
				respondsToSelector:@selector(getAWTDrawableContext)])
			{
				controller->appletAWTContext =
					[controller->appletWindow getAWTDrawableContext];
			}
		}
		if (controller->updatesOff ||
			![controller->myAppletView isDisplayable])
		{
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			[AppletView clipWithTranslation:self controller:controller];
		}
	} else if (controllersLock) {
		if (![controllersLock tryLock]) {
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			[controllersLock unlock];
		}
	}

	objc_msgSendSuper(&target, sel, aRect);
}

/* In versions before 0.8.2 we missed some drawing operations that needed
 * clipping -- the "third thread" ones.  "Third thread" drawing seems to be
 * Java-initiated, but to be distinct from the ("second thread") Java-initiated
 * drawing that calls prepareIfCanJavaDraw.  One Java method that does "third
 * thread" drawing is apple.awt.CRenderer.doRect().  None of the "third thread"
 * drawing operations pass through any of the Cocoa drawRect methods.  It seems
 * that the only place that all of them pass through is NSViewAWT's
 * lockFocusIfCanDraw method -- where, fortunately, we're able to clip them.
 */
/* "Third thread" and "first thread" (i.e. Cocoa-initiated) drawing operations
 * can both draw the same object but don't seem to be thread-safe.  We try to
 * deal with this by making the "first thread" lockFocus method also acquire
 * a "third thread" lock.  We need to unlock this extra lock in our
 * unlockFocus method.  (This solution doesn't work with Cocoa browsers like
 * Camino.)
 */
/* As of Java 1.4.2 Update 1 "third thread" drawing seems to have disappeared.
 * Though there are still some paint events that don't go through either
 * drawRect_AWT() (on the main thread) or handleEvent() (in MyCPanel.java,
 * MyCAppletFrame.java and MyCCanvas142.java, on a "second thread"), it's no
 * longer possible to clip them here.  Fortunately it's possible to use
 * getGraphics() (in MyCPanel.java and so forth) to clip them.
 */
static BOOL lockFocusIfCanDraw_AWT(id self, SEL sel)
{
	struct objc_super target;
	JEPController *controller = nil;
	NSThread *currentThread = nil;

	currentThread = [NSThread currentThread];

	if (!isJava142Update1 && isCarbonApp && mainThread &&
		[mainThread isEqual:currentThread])
	{
		controller = [JEPController controllerContainingNSView:self
			timeoutType:lockTimeoutNormal];
	}

	if (controller) {
		if ([controller destroying])
			return false;
		if (!controller->appletWindow)
			controller->appletWindow = [self cWindow];
		if (!controller->appletWindow ||
			![controller->appletWindow windowLockOnThirdThread:self])
			return false;
	}

	target.receiver = self;
	target.class = [awtViewClassPoser superclass];
	if (!objc_msgSendSuper(&target, sel)) {
		if (controller && controller->appletWindow)
			[controller->appletWindow windowUnlock];
		return false;
	}

	if (isJava142Update1 || !mainThread || [mainThread isEqual:currentThread])
		return true;

	controller = [JEPController controllerContainingNSView:self
		timeoutType:lockTimeoutNormal];
	if (controller && controller->myAppletView) {
		if (controller->updatesOff || controller->asyncUpdatesOff ||
			![controller->myAppletView isDisplayable])
		{
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			[AppletView clipWithTranslation:self controller:controller];
		}
	} else if (controllersLock) {
		if (![controllersLock tryLock]) {
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			[controllersLock unlock];
		}
	}

	return true;
}

static void unlockFocus_AWT(id self, SEL sel)
{
	struct objc_super target;
	NSThread *currentThread = nil;
	JEPController *controller = nil;
	currentThread = [NSThread currentThread];
	if (!isJava142Update1 && isCarbonApp && mainThread &&
		[mainThread isEqual:currentThread])
	{
		controller = [JEPController controllerContainingNSView:self
			timeoutType:lockTimeoutNone];
	}
	if (controller && controller->appletWindow)
		[controller->appletWindow windowUnlock];
	target.receiver = self;
	target.class = [awtViewClassPoser superclass];
	objc_msgSendSuper(&target, sel);
}

/* Though "third thread" drawing disappeared with Java 1.4.2 Update 1, a lot
 * of Java-initiated drawing does still take place on other threads than the
 * main thread.  In all Java 1.4.1 and 1.4.2 versions, NSView:canDraw is
 * called before (though not necessarily just before) any drawing takes place,
 * whether on the main thread or other threads.  We can't do clipping here,
 * but we can still decide whether or not to allow any drawing at all.  As of
 * JEP 0.9.1 we distinguish between regular updates (which take place on the
 * main thread) and "asynchronous" ones (which take place on other threads).
 * And, though both kinds of updates are turned off at the same time (in
 * JEPController.suspendAppletUpdates), we now turn asynchronous updates back
 * on slightly after sychronous ones -- for some reason this helps avoid
 * ghosts.  It's here that we decide whether or not to allow asynchronous
 * updates.
 */
static BOOL canDraw_AWT(id self, SEL sel)
{
	int retval;
	struct objc_super target;
	JEPController *controller = nil;
	NSThread *currentThread = [NSThread currentThread];
	BOOL notMainThread = (mainThread && ![mainThread isEqual:currentThread]);
	target.receiver = self;
	target.class = [awtViewClassPoser superclass];
	retval = (int) objc_msgSendSuper(&target, sel);
	/* The following check is only needed on Java 1.4.2 Update 1
	 * and above (on earlier versions it's taken care of in
	 * lockFocusIfCanDraw).
	 */
	if (isJava142Update1 && retval && notMainThread) {
		controller = [JEPController controllerContainingNSView:self
			timeoutType:lockTimeoutNormal];
		if (controller) {
			if (controller->asyncUpdatesOff)
				retval = false;
			else if (!controller->myAppletView ||
				![controller->myAppletView isDisplayable])
				retval = false;
		} else if (controllersLock) {
			if (![controllersLock tryLock]) {
				retval = false;
			} else {
				[controllersLock unlock];
			}
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"NSViewAWT canDraw: self %@, controller %@, %s, returning %s",
		self, controller, notMainThread ? "secondary thread" : "main thread",
		retval ? "true" : "false");
#endif
	return (BOOL) retval;
}

/* This method is supposed to deliver mouse-moved events to our applet's Java
 * peer (actually to the peer of its Panel object).  The original version
 * goofs this up.  In a Carbon browser it often fails to deliver them at all,
 * especially if the applet is clipped and the events are near one of its
 * boundaries.  In a Cocoa browser it errs in the other direction --
 * delivering events outside the applet's clipped boundaries.  We fix these
 * problems here.
 */
static void mouseMovedAWT_AWT(id self, SEL sel, id event)
{
	jobject peer = nil;
	JNIEnv *env = nil;
	jclass myCToolkitClass = nil;
	jmethodID postMouseMovedEvent = nil;
	jboolean posted = false;
	NSPoint location;	// Mouse location in our NSViewAWT
	NSPoint locationInAppletView; // Ditto in our applet view.
	struct timeval time;// Current time in seconds/microseconds since 1970
	double timediff;	// Age in milliseconds of Cocoa event's "timestamp"
	jlong when;			// Java event timestamp in milliseconds since 1970
	JEPController *controller = nil;
	struct objc_super target;

	peer = [self peer];
	if (![AppletView getJavaEnv:&env] || !event || !peer)
		return;

	/* Convert event's "locationInWindow" (origin lower-left) to a flipped
	 * (origin upper-left) point in our NSViewAWT.
	 */
	location = [self convertPoint:[event locationInWindow] fromView:nil];
	/* Don't deliver the event if our applet is currently invisible or if the
	 * event's location is outside our current bounds (i.e. current clip).
	 */
	controller = [JEPController controllerContainingNSView:self
		timeoutType:lockTimeoutNormal];
	if (controller && [controller destroying])
		return;
	if (controller && controller->myAppletView) {
		if (controller->myAppletView->isInvisible ||
			[controller->myAppletView isCurrentClipEmpty] ||
			![controller->myAppletView isAppletVisible])
			return;
		locationInAppletView = [controller->myAppletView convertPoint:location
			fromView:self];
		if (![self mouse:locationInAppletView 
			inRect:controller->myAppletView->currentBounds])
			return;
	}

	if (!isCarbonApp) {
		target.receiver = self;
		target.class = [awtViewClassPoser superclass];
		objc_msgSendSuper(&target, sel, event);
#ifdef DEBUG_EVENTS
		NSLog(@"NSViewAWT mouseMovedAWT: self is %@, event is %@, peer is %@, x is %f, y is %f",
			self, event, [AppletView toString:peer javaEnv:env],
			location.x, location.y);
#endif
		return;
	}

	/* Compute the timestamp for our new Java mouse-moved event. */
	gettimeofday(&time, nil);
	timediff = (GetCurrentEventTime() - [event timestamp]) * 1000;
	when = ((jlong) time.tv_sec) * 1000 + (jlong) (time.tv_usec / 1000);
	when -= (jlong) rint(timediff);

	myCToolkitClass = (*env)->FindClass(env, "apple/awt/MyCToolkit");
	postMouseMovedEvent = (*env)->GetStaticMethodID(env, myCToolkitClass,
		"postMouseMovedEvent", "(Ljava/lang/Object;IIJ)Z");
	posted = (*env)->CallStaticBooleanMethod(env, myCToolkitClass,
		postMouseMovedEvent, peer, (jint) rint(location.x),
		(jint) rint(location.y), when);
	(*env)->DeleteLocalRef(env, myCToolkitClass);
	if ((*env)->ExceptionCheck(env)) {
		(*env)->ExceptionClear(env);
		posted = false;
	}
	if (!posted) {
		target.receiver = self;
		target.class = [awtViewClassPoser superclass];
		objc_msgSendSuper(&target, sel, event);
	}
#ifdef DEBUG_EVENTS
	NSLog(@"NSViewAWT mouseMovedAWT: self is %@, event is %@, peer is %@, x is %f, y is %f, posted is %s",
		self, event, [AppletView toString:peer javaEnv:env],
		location.x, location.y, posted ? "true" : "false");
#endif
}

/* In Java 1.4.2 Update 1 and later (I think), you often get strange crashes
 * if "text" represents a Control+key or Alt+key combination.  This is still
 * a problem in Tiger, though it happens less often.  (Sometimes 'modifiers'
 * doesn't get set in the "current event" when a control key is being pressed.
 * But the right thing still happens even if we ignore the value of modifiers.)
 */
static void insertText_AWT(id self, SEL sel, NSString *text)
{
	unichar character = 0;
	unsigned modifiers, length;
	unsigned ctrlOrAlt = 0;
	struct objc_super target;
	if (text) {
		modifiers = [[NSApp currentEvent] modifierFlags];
		length = [text length];
		if (!modifiers) {
			ctrlOrAlt = 1;
		} else {
			ctrlOrAlt = ((modifiers & NSControlKeyMask) |
				(modifiers & NSAlternateKeyMask));
		}
		if (length)
			character = [text characterAtIndex:0];
#ifdef DEBUG_EVENTS
		NSLog(@"NSViewAWT insertText: modifiers 0x%.8X, length %u, first character %u",
			modifiers, length, character);
#endif
		if (ctrlOrAlt && (length == 1) && (character <= 0xFF)) {
#ifdef DEBUG_EVENTS
			NSLog(@"NSViewAWT insertText: Skipping because Control or Option key pressed");
#endif
			return;
		}
	}
	target.receiver = self;
	target.class = [awtViewClassPoser superclass];
	objc_msgSendSuper(&target, sel, text);
}

/* You get lots of crashes in this method (in OS X 10.3.X) when you
 * "aggressively" resize map24.com's maps in a Cocoa browser.  The following
 * works around the problem without (as far as I can tell) any side effects.
 */
static void viewDidEndLiveResize_AWT(id self, SEL sel)
{
	struct objc_super target;
	target.receiver = self;
	if (isCarbonApp || (osxVersion >= 0x1040)) {
		target.class = [awtViewClassPoser superclass];
	} else {
		target.class = [NSView class];
	}
	objc_msgSendSuper(&target, sel);
}

BOOL PoseAsNSViewAWT(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 7;

	instance_methods->method_list[0].method_name =
		sel_registerName("drawRect:");
	instance_methods->method_list[0].method_types =
		"v0@4:8{_NSRect={_NSPoint=ff}{_NSSize=ff}}12";
	instance_methods->method_list[0].method_imp =
		(IMP) drawRect_AWT;
	instance_methods->method_list[1].method_name =
		sel_registerName("lockFocusIfCanDraw");
	instance_methods->method_list[1].method_types = "c0@4:8";
	instance_methods->method_list[1].method_imp =
		(IMP) lockFocusIfCanDraw_AWT;
	instance_methods->method_list[2].method_name =
		sel_registerName("unlockFocus");
	instance_methods->method_list[2].method_types = "v0@4:8";
	instance_methods->method_list[2].method_imp =
		(IMP) unlockFocus_AWT;
	instance_methods->method_list[3].method_name =
		sel_registerName("canDraw");
	instance_methods->method_list[3].method_types = "c0@4:8";
	instance_methods->method_list[3].method_imp =
		(IMP) canDraw_AWT;
	instance_methods->method_list[4].method_name =
		sel_registerName("mouseMovedAWT:");
	instance_methods->method_list[4].method_types = "v0@4:8@12";
	instance_methods->method_list[4].method_imp =
		(IMP) mouseMovedAWT_AWT;
	instance_methods->method_list[5].method_name =
		sel_registerName("insertText:");
	instance_methods->method_list[5].method_types = "v0@4:8@12";
	instance_methods->method_list[5].method_imp =
		(IMP) insertText_AWT;
	instance_methods->method_list[6].method_name =
		sel_registerName("viewDidEndLiveResize");
	instance_methods->method_list[6].method_types = "v0@4:8";
	instance_methods->method_list[6].method_imp =
		(IMP) viewDidEndLiveResize_AWT;

	retval = PoseAsUndocumentedClass("NSViewAWT", "MyNSViewAWT",
		&awtViewClass, &awtViewClassPoser, instance_methods, NULL);

	return retval;
}

/* See JEPController's getWindowTSMDocIfShouldBeActive method in
 * Controller.m.
 */
static BOOL _activate_TSMIC(id self, SEL sel)
{
	int retval;
	TSMDocumentID activeDoc;
	TSMDocumentID shouldActivateDoc;
	Boolean boolTrue = true;
	struct objc_super target;
	target.receiver = self;
	target.class = [tsmInputClassPoser superclass];
	retval = (int) objc_msgSendSuper(&target, sel);
	/* When used in a Carbon browser, NSTSMInputContext _activate should
	 * always result in a "Cocoa-specific" TSMDocument being made active.
	 * So we mark the current active TSMDocument with a property that
	 * indicates this, and which we can check in other locations.
	 */
	if ((activeDoc = TSMGetActiveDocument()) != nil) {
		TSMSetDocumentProperty(activeDoc, kPropertyCocoaTSMDoc,
			sizeof(Boolean), &boolTrue);
	}
	shouldActivateDoc =
		[JEPController getWindowTSMDocIfShouldBeActive:GetUserFocusWindow()
		timeoutType:lockTimeoutNone];
	if (shouldActivateDoc)
		ActivateTSMDocument(shouldActivateDoc);
#ifdef DEBUG_EVENTS
	NSLog(@"NSTSMInputContext _activate: active TSM doc is 0x%.8X, shouldActivateDoc is 0x%.8X",
		activeDoc, shouldActivateDoc);
	activeDoc = TSMGetActiveDocument();
	NSLog(@"NSTSMInputContext _activate called on %@, active TSM doc is now 0x%.8X",
		self, activeDoc);
#endif
	return (BOOL) retval;
}

BOOL PoseAsNSTSMInputContext(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 1;
	instance_methods->method_list[0].method_name =
		sel_registerName("_activate");
	instance_methods->method_list[0].method_types = "c0@4:8";
	instance_methods->method_list[0].method_imp =
		(IMP) _activate_TSMIC;

	retval = PoseAsUndocumentedClass("NSTSMInputContext", "MyNSTSMInputContext",
		&tsmInputClass, &tsmInputClassPoser, instance_methods, NULL);

	return retval;
}

/* CTextField setText (or its later equivalents in Tiger) can interfere with
 * text input in the current tab's applet(s) (in Cocoa browsers) if the
 * applet that triggered this call is (invisible) in another tab in the same
 * browser window.  One way this call may be triggered by an invisible applet
 * is if the Java method that triggers it runs on a timed loop (possibly in a
 * separate thread).  One example of an applet that triggers setText from a
 * timed loop is the Intellicast weather applet.  One example of an applet
 * whose text input gets interfered with is http://www.lohn1.de/lobn.htm.
 */
static void setText_CTF(id self, SEL sel, id text)
{
	id owningWindow = nil;
	JEPController *controller = nil;
	struct objc_super target;
	owningWindow = [self getOwningWindow];
	controller = [JEPController controllerFromCWindow:owningWindow
		timeoutType:lockTimeoutNone];
	if (controller &&
		(!controller->myAppletView || ![controller->myAppletView isDisplayable]))
	{
#ifdef DEBUG_EVENTS
		NSLog(@"CTextField setText: Skipping because applet not displayable");
#endif
		return;
	}
	target.receiver = self;
	target.class = [cTextFieldClassPoser superclass];
	objc_msgSendSuper(&target, sel, text);
#ifdef DEBUG_EVENTS
	NSLog(@"CTextField setJavaText: self %@, text %@, owningWindow %@",
		self, text, owningWindow);
#endif
}

static void setJavaText_CTF(id self, SEL sel, id text)
{
	id owningModel = nil;
	JEPController *controller = nil;
	struct objc_super target;
	owningModel = [self getOwningModel];
	controller = [JEPController controllerFromCWindow:owningModel
		timeoutType:lockTimeoutNone];
	if (controller &&
		(!controller->myAppletView || ![controller->myAppletView isDisplayable]))
	{
#ifdef DEBUG_EVENTS
		NSLog(@"CTextField setJavaText: Skipping because applet not displayable");
#endif
		return;
	}
	target.receiver = self;
	target.class = [cTextFieldClassPoser superclass];
	objc_msgSendSuper(&target, sel, text);
#ifdef DEBUG_EVENTS
	NSLog(@"CTextField setJavaText: self %@, text %@, owningModel %@",
		self, text, owningModel);
#endif
}

static void _setNativeText_CTF(id self, SEL sel, id text)
{
	id owningModel = nil;
	JEPController *controller = nil;
	struct objc_super target;
	owningModel = [self getOwningModel];
	controller = [JEPController controllerFromCWindow:owningModel
		timeoutType:lockTimeoutNone];
	if (controller &&
		(!controller->myAppletView || ![controller->myAppletView isDisplayable]))
	{
#ifdef DEBUG_EVENTS
		NSLog(@"CTextField _setNativeText: Skipping because applet not displayable");
#endif
		return;
	}
	target.receiver = self;
	target.class = [cTextFieldClassPoser superclass];
	objc_msgSendSuper(&target, sel, text);
#ifdef DEBUG_EVENTS
	NSLog(@"CTextField _setNativeText: self %@, text %@, owningModel %@",
		self, text, owningModel);
#endif
}

BOOL PoseAsCTextField(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 3;

	instance_methods->method_list[0].method_name =
		sel_registerName("setText:");
	instance_methods->method_list[0].method_types = "v0@4:8@12";
	instance_methods->method_list[0].method_imp =
		(IMP) setText_CTF;
	instance_methods->method_list[1].method_name =
		sel_registerName("setJavaText:");
	instance_methods->method_list[1].method_types = "v0@4:8@12";
	instance_methods->method_list[1].method_imp =
		(IMP) setJavaText_CTF;
	instance_methods->method_list[2].method_name =
		sel_registerName("_setNativeText:");
	instance_methods->method_list[2].method_types = "v0@4:8@12";
	instance_methods->method_list[2].method_imp =
		(IMP) _setNativeText_CTF;

	retval = PoseAsUndocumentedClass("CTextField", "MyCTextField",
		&cTextFieldClass, &cTextFieldClassPoser, instance_methods, NULL);

	return retval;
}

/* Disable Java-initiated modal windows on OS X 10.2.8 and 10.3.X.  Prior to
 * JEP 0.9.6.1 we did this only for Cocoa browsers, and used a hack in
 * stopModal_AWTCW() to get around one problem with these windows in Carbon
 * browsers.  (Java-initiated modal windows work in the simplest case -- that
 * of a single window that the user just closes.  But if that window opens
 * another window or redisplays itself, the brower's menus stay blocked when
 * the user closes the window.)  Now I've found another problem that the
 * stopModal hack doesn't resolve -- if you've enabled "Show applet exception
 * alerts" and you load a page in which alerts are displayed for two or more
 * applets, the alerts will be displayed on top of each other, and keyboard
 * and mouse events will only work (be handled) in the alert box at the bottom
 * of the pile (the one that was displayed first).  So I've decided to stop
 * making heroic efforts to save Java-initiated modal windows on these old
 * versions of OS X.  Both of these problems are fixed in Tiger and above.
 * And in any case the CWindow class in newer OS X versions no longer has an
 * "isModal" method -- so what we do here only has effect on OS X 10.2.8 and
 * 10.3.X.
 */
static BOOL isModal_AWTCW(id self, SEL sel)
{
#ifdef DEBUG_EVENTS
	NSLog(@"CWindow isModal: Self %@, returning false (Cocoa app)", self);
#endif
	return FALSE;
}

static BOOL isModal2_AWTCW(id self, SEL sel, JNIEnv *env)
{
#ifdef DEBUG_EVENTS
	NSLog(@"CWindow isModal(142): Self %@, returning false (Cocoa app)", self);
#endif
	return FALSE;
}

BOOL PoseAsCWindow(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 2;
	instance_methods->method_list[0].method_name =
		sel_registerName("isModal");
	instance_methods->method_list[0].method_types = "c0@4:8";
	instance_methods->method_list[0].method_imp =
		(IMP) isModal_AWTCW;
	instance_methods->method_list[1].method_name =
		sel_registerName("isModal:");
	instance_methods->method_list[1].method_types =
		"c0@4:8^^{JNINativeInterface_}12";
	instance_methods->method_list[1].method_imp =
		(IMP) isModal2_AWTCW;

	retval = PoseAsUndocumentedClass("CWindow", "MyCWindow",
		&cWindowClass, &cWindowClassPoser, instance_methods, nil);

	return retval;
}

/* This seems to be where Apple's AWT library does it's cleanup of an applet
 * that's being destroyed.  Deleting our AppletView object before this happens
 * will cause crashes.  So, if need be, we can delay triggering that action
 * until the AWT library has done its job.  (The following is for Java on
 * Panther and Jaguar.)
 */
static void cleanup_AWTCAW(id self, SEL sel)
{
	NSString *info;
	JEPController *controller;
	struct objc_super target;
	/* The following avoids occasional crashes in NSWindow resignKeyWindow.
	 */
	[[NSNotificationCenter defaultCenter] removeObserver:self];
	controller = [JEPController controllerFromCWindow:self
		timeoutType:lockTimeoutNone];
	if (!controller)
		return;
	target.receiver = self;
	target.class = [cAppletWindowClassPoser superclass];
	objc_msgSendSuper(&target, sel);
	if (controller->myAppletView)
		controller->myAppletView->awaitingAppletWindowCleanup = false;
	if (debugRelease) {
		info = [NSString stringWithFormat:@"%@ CAppletWindow:cleanup for %@", [NSDate date],
			(controller->myAppletView ? controller->myAppletView->myAppletName : nil)];
		[AppletView printMessage:info javaEnv:nil];
	}
	if ([controller purgeOnAppletWindowCleanup]) {
		/* Before JEP 0.9.5, we called JEPController purgeControllerArray here
		 * after the call to setNeedsCleanup.  But that caused our AppletView
		 * object to be destroyed too quickly -- the JVM kept trying to send
		 * it (Cocoa) messages after it had been deallocated.  Now we wait for
		 * other code to call purgeControllerArray.
		 */
		[controller performSelector:@selector(setNeedsCleanup)];
	}
}

static id initWithPeer_AWTCAW(id self, SEL sel, jobject peer,
	jobject component, id screen, NSRect aRect, int style, id parent,
	BOOL asDialog, const char *title, BOOL lock, id parentView)
{
	id retval;
	struct objc_super target;
	AppletView *appletView;
	target.receiver = self;
	target.class = [cAppletWindowClassPoser superclass];
	retval = objc_msgSendSuper(&target, sel, peer, component, screen, aRect,
		style, parent, asDialog, title, lock, parentView);
	if (retval && parentView && [parentView isMemberOfClass:[AppletView class]]) {
		appletView = (AppletView *) parentView;
		if (appletView->myController)
			appletView->myController->appletWindow = retval;
	}
#ifdef DEBUG_EVENTS
	NSLog(@"CAppletWindow initWithPeer(141): peer %@, component %@, parent %@, title %s, parentView %@",
		[AppletView toString:peer javaEnv:nil], [AppletView toString:component javaEnv:nil],
		parent, title ? title : "null", parentView);
#endif
	return retval;
}

static id initWithPeer2_AWTCAW(id self, SEL sel, jobject peer,
	jobject component, id screen, NSRect aRect, long style, id parent,
	BOOL asDialog, const char *title, BOOL lock, id parentView, JNIEnv *env)
{
	id retval;
	struct objc_super target;
	AppletView *appletView;
	target.receiver = self;
	target.class = [cAppletWindowClassPoser superclass];
	retval = objc_msgSendSuper(&target, sel, peer, component, screen, aRect,
		style, parent, asDialog, title, lock, parentView, env);
	if (retval && parentView && [parentView isMemberOfClass:[AppletView class]]) {
		appletView = (AppletView *) parentView;
		if (appletView->myController)
			appletView->myController->appletWindow = retval;
		if (!appletView->myController->appletAWTContext &&
			[retval respondsToSelector:@selector(getNSViewAWTContext)])
		{
			appletView->myController->appletAWTContext =
				[retval getNSViewAWTContext];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"CAppletWindow initWithPeer(142): self %@, peer %@, component %@, parent %@, title %s, parentView %@, returning %@",
		self, [AppletView toString:peer javaEnv:env], [AppletView toString:component javaEnv:env],
		parent, title ? title : "null", parentView, retval);
#endif
	return retval;
}

/* The following belongs in Ripley's Believe It Or Not!  Sometimes a
 * CAppletWindow object is immediately re-allocated just after it's been
 * deallocated.  Probably this also happens with other objects.  But when it
 * happens with CAppletWindow objects, the applet (sometimes? always?) doesn't
 * get displayed and can't receive keystrokes or mouseclicks ... even though
 * (to all indications) it's enabled and visible!  The cure for this is just
 * as strange as the disease -- don't allow a CAppletWindow object to be
 * re-allocated just after it's been deallocated.  This problem seems to have
 * been fixed in Tiger, so it's not necessary to do the same thing for the
 * CEmbedded interface.
 */

NSMutableArray *deletedCAWs = nil;
NSLock *allocCAWLock = nil;

static void dealloc_AWTCAW(id self, SEL sel)
{
	NSNumber *number;
	struct objc_super target;
	/* The following avoids occasional crashes in NSWindow resignKeyWindow.
	 */
	[[NSNotificationCenter defaultCenter] removeObserver:self];
	target.receiver = self;
	target.class = [cAppletWindowClassPoser superclass];
	if (!allocCAWLock || !deletedCAWs) {
		objc_msgSendSuper(&target, sel);
		return;
	}
	[allocCAWLock lock];
#ifdef SUPPORT_64BITS
	[deletedCAWs addObject:
		[NSNumber numberWithUnsignedLongLong:(unsigned long long)self]];
#else
	[deletedCAWs addObject:
		[NSNumber numberWithUnsignedInt:(unsigned)self]];
#endif
	if ([deletedCAWs count] >= 30) {
		number = [deletedCAWs objectAtIndex:0];
#ifdef SUPPORT_64BITS
		target.receiver = (id) [number unsignedLongLongValue];
#else
		target.receiver = (id) [number unsignedIntValue];
#endif
		objc_msgSendSuper(&target, sel);
		[deletedCAWs removeObjectAtIndex:0];
	}
	[allocCAWLock unlock];
}

/* syncFromJava can sometimes be called on a CAppletWindow object for an
 * applet that's being destroyed -- which can lead to crashes.
 */
static void syncFromJava_AWTCAW(id self, SEL sel, JNIEnv *env)
{
	struct objc_super target;
	JEPController *controller;
	controller = [JEPController controllerFromCWindow:self
		timeoutType:lockTimeoutNormal];
	if (!controller || [controller destroying])
		return;
	target.receiver = self;
	target.class = [cAppletWindowClassPoser superclass];
	objc_msgSendSuper(&target, sel, env);
}

/* windowDidBecomeKey can sometimes be called on a CAppletWindow object for
 * an applet that's being destroyed -- which can lead to crashes.
 */
static void windowDidBecomeKey_AWTCAW(id self, SEL sel, id aNotification)
{
	JEPController *controller;
	struct objc_super target;
	controller = [JEPController controllerFromCWindow:self
		timeoutType:lockTimeoutNormal];
	if (!controller || [controller destroying])
		return;
	target.receiver = self;
	target.class = [cAppletWindowClassPoser superclass];
	objc_msgSendSuper(&target, sel, aNotification);
}

/* setState can sometimes be called on a CAppletWindow object for an applet
 * that's being destroyed -- which can lead to strange hangs.
 */
static void setState_AWTCAW(id self, SEL sel, BOOL state, BOOL visible)
{
	struct objc_super target;
	JEPController *controller;
	controller = [JEPController controllerFromCWindow:self
		timeoutType:lockTimeoutNormal];
	if (!controller || [controller destroying])
		return;
	target.receiver = self;
	target.class = [cAppletWindowClassPoser superclass];
	objc_msgSendSuper(&target, sel, state, visible);
#ifdef DEBUG_EVENTS
	NSLog(@"CAppletWindow setState(141): self %@, state %s, visible %s", self,
		state ? "true" : "false", visible ? "true" : "false");
#endif
}

static void setState2_AWTCAW(id self, SEL sel, BOOL state, BOOL visible, JNIEnv *env)
{
	struct objc_super target;
	JEPController *controller;
	controller = [JEPController controllerFromCWindow:self
		timeoutType:lockTimeoutNormal];
	if (!controller || [controller destroying])
		return;
	target.receiver = self;
	target.class = [cAppletWindowClassPoser superclass];
	objc_msgSendSuper(&target, sel, state, visible, env);
#ifdef DEBUG_EVENTS
	NSLog(@"CAppletWindow setState(142): self %@, state %s, visible %s", self,
		state ? "true" : "false", visible ? "true" : "false");
#endif
}

BOOL PoseAsCAppletWindow(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 8;
	instance_methods->method_list[0].method_name =
		sel_registerName("cleanup");
	instance_methods->method_list[0].method_types = "v0@4:8";
	instance_methods->method_list[0].method_imp =
		(IMP) cleanup_AWTCAW;
	instance_methods->method_list[1].method_name =
		sel_registerName("initWithPeer:ofComponent:onScreen:withRect:ofStyle:withParent:asDialog:withTitle:lock:usingParentView:");
	instance_methods->method_list[1].method_types =
		"@0@4:8^{_jobject=}12^{_jobject=}16@20{_NSRect={_NSPoint=ff}{_NSSize=ff}}24i28@32c36*40c44@48";
	instance_methods->method_list[1].method_imp =
		(IMP) initWithPeer_AWTCAW;
	instance_methods->method_list[2].method_name =
		sel_registerName("initWithPeer:ofComponent:onScreen:withRect:ofStyle:withParent:asDialog:withTitle:lock:usingParentView:withEnv:");
	instance_methods->method_list[2].method_types =
		"@0@4:8^{_jobject=}12^{_jobject=}16@20{_NSRect={_NSPoint=ff}{_NSSize=ff}}24l28@32c36*40c44@48^^{JNINativeInterface_}52";
	instance_methods->method_list[2].method_imp =
		(IMP) initWithPeer2_AWTCAW;
	instance_methods->method_list[3].method_name =
		sel_registerName("dealloc");
	instance_methods->method_list[3].method_types = "v0@4:8";
	instance_methods->method_list[3].method_imp =
		(IMP) dealloc_AWTCAW;
	instance_methods->method_list[4].method_name =
		sel_registerName("syncFromJava:");
	instance_methods->method_list[4].method_types =
		"v0@4:8^^{JNINativeInterface_}12";
	instance_methods->method_list[4].method_imp =
		(IMP) syncFromJava_AWTCAW;
	instance_methods->method_list[5].method_name =
		sel_registerName("windowDidBecomeKey:");
	instance_methods->method_list[5].method_types =
		"v0@4:8@12";
	instance_methods->method_list[5].method_imp =
		(IMP) windowDidBecomeKey_AWTCAW;
	instance_methods->method_list[6].method_name =
		sel_registerName("setState:isVisible:");
	instance_methods->method_list[6].method_types = "v0@4:8c12c16";
	instance_methods->method_list[6].method_imp =
		(IMP) setState_AWTCAW;
	instance_methods->method_list[7].method_name =
		sel_registerName("setState:isVisible:withEnv:");
	instance_methods->method_list[7].method_types =
		"v0@4:8c12c16^^{JNINativeInterface_}20";
	instance_methods->method_list[7].method_imp =
		(IMP) setState2_AWTCAW;

	retval = PoseAsUndocumentedClass("CAppletWindow", "MyCAppletWindow",
		&cAppletWindowClass, &cAppletWindowClassPoser, instance_methods, nil);

	if (retval)
		appletWindowClass = cAppletWindowClass;

	return retval;
}

/* This seems to be where Apple's AWT library does it's cleanup of an applet
 * that's being destroyed.  Deleting our AppletView object before this happens
 * will cause crashes.  So, if need be, we can delay triggering that action
 * until the AWT library has done its job.  (The following is for Java on
 * Tiger and Leopard.)
 */
static void cleanup_AWTCE(id self, SEL sel)
{
	NSString *info;
	JEPController *controller;
	struct objc_super target;
	/* The following avoids occasional crashes in NSWindow resignKeyWindow.
	 */
	[[NSNotificationCenter defaultCenter] removeObserver:self];
	controller = [JEPController controllerFromCWindow:self
		timeoutType:lockTimeoutNone];
	if (!controller)
		return;
	target.receiver = self;
	target.class = [cEmbeddedClassPoser superclass];
	objc_msgSendSuper(&target, sel);
	if (controller->myAppletView)
		controller->myAppletView->awaitingAppletWindowCleanup = false;
	if (debugRelease) {
		info = [NSString stringWithFormat:@"%@ CEmbedded:cleanup for %@", [NSDate date],
			(controller->myAppletView ? controller->myAppletView->myAppletName : nil)];
		[AppletView printMessage:info javaEnv:nil];
	}
	if ([controller purgeOnAppletWindowCleanup]) {
		/* Before JEP 0.9.5, we called JEPController purgeControllerArray here
		 * after the call to setNeedsCleanup.  But that caused our AppletView
		 * object to be destroyed too quickly -- the JVM kept trying to send
		 * it (Cocoa) messages after it had been deallocated.  Now we wait for
		 * other code to call purgeControllerArray.
		 */
		[controller performSelector:@selector(setNeedsCleanup)];
	}
}

static id initWithPeer_AWTCE(id self, SEL sel, jobject peer, id parentView,
	JNIEnv *env, jobject byteParms)
{
	id retval;
	struct objc_super target;
	AppletView *appletView;
	target.receiver = self;
	target.class = [cEmbeddedClassPoser superclass];
	retval = objc_msgSendSuper(&target, sel, peer, parentView, env, byteParms);
	if (retval && parentView && [parentView isMemberOfClass:[AppletView class]]) {
		appletView = (AppletView *) parentView;
		if (appletView->myController)
			appletView->myController->appletWindow = retval;
		if (!appletView->myController->appletAWTContext) {
			appletView->myController->appletAWTContext =
				[retval getAWTDrawableContext];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"CEmbedded initWithPeer(150): peer %@, parentView %@, returning %@",
		[AppletView toString:peer javaEnv:env], parentView, retval);
#endif
	return retval;
}

static id initWithPeer2_AWTCE(id self, SEL sel, jobject peer, id parentView,
	BOOL focusable, JNIEnv *env, jobject byteParms)
{
	id retval;
	struct objc_super target;
	AppletView *appletView;
	target.receiver = self;
	target.class = [cEmbeddedClassPoser superclass];
	retval = objc_msgSendSuper(&target, sel, peer, parentView, focusable, env, byteParms);
	if (retval && parentView && [parentView isMemberOfClass:[AppletView class]]) {
		appletView = (AppletView *) parentView;
		if (appletView->myController)
			appletView->myController->appletWindow = retval;
		if (!appletView->myController->appletAWTContext) {
			appletView->myController->appletAWTContext =
				[retval getAWTDrawableContext];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"CEmbedded initWithPeer(160): peer %@, parentView %@, focusable %i, returning %@",
		[AppletView toString:peer javaEnv:env], parentView, focusable, retval);
#endif
	return retval;
}

/* This avoids crashes on OS X 10.4.X -- particularly when resizing the map
 * applets at http://map24.com/.  (Still needed?)
 */
static id hostWindow_AWTCE(id self, SEL sel, id parentView)
{
	id retval;
	struct objc_super target;
	if (![JEPController controllerFromAppletView:(AppletView *)parentView
		timeoutType:lockTimeoutNone])
		return nil;
	target.receiver = self;
	target.class = [cEmbeddedClassPoser superclass];
	retval = objc_msgSendSuper(&target, sel, parentView);
	return retval;
}

BOOL PoseAsCEmbedded(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 3;
	instance_methods->method_list[0].method_name =
		sel_registerName("cleanup");
	instance_methods->method_list[0].method_types = "v0@4:8";
	instance_methods->method_list[0].method_imp =
		(IMP) cleanup_AWTCE;
	instance_methods->method_list[1].method_name =
		sel_registerName("initWithPeer:usingParentView:withEnv:withByteBuffer:");
	instance_methods->method_list[1].method_types =
		"@0@4:8^{_jobject=}12@16^^{JNINativeInterface_}20^{_jobject=}24";
	instance_methods->method_list[1].method_imp =
		(IMP) initWithPeer_AWTCE;
	instance_methods->method_list[2].method_name =
		sel_registerName("initWithPeer:usingParentView:focusable:withEnv:withByteBuffer:");
	instance_methods->method_list[2].method_types =
		"@0@4:8^{_jobject=}12@16c20^^{JNINativeInterface_}24^{_jobject=}28";
	instance_methods->method_list[2].method_imp =
		(IMP) initWithPeer2_AWTCE;
	instance_methods->method_list[3].method_name =
		sel_registerName("hostWindow:");
	instance_methods->method_list[3].method_types = "@0@4:8@12";
	instance_methods->method_list[3].method_imp =
		(IMP) hostWindow_AWTCE;

	retval = PoseAsUndocumentedClass("CEmbedded", "MyCEmbedded",
		&cEmbeddedClass, &cEmbeddedClassPoser, instance_methods, NULL);

	if (retval)
		appletWindowClass = cEmbeddedClass;

	return retval;
}

//#define DEBUG_VIEW_STRUCTURE 1

static void forwardEvent_EF(id self, SEL sel, id anEvent, id toTarget)
{
	Class superclass;
	struct objc_super target;
	NSEventType type = 0;
	JEPController *controller = nil;
	NSThread *currentThread;
#ifdef DEBUG_VIEW_STRUCTURE
	NSRect frame = NSZeroRect;
	NSRect bounds = NSZeroRect;
	NSWindow *cocoaWindow = nil;
	NSView *oneView, *contentView;
	AppletView *oneAppletView;
	NSMutableArray *viewsFound;
	NSMutableArray *appletViewsFound;
	unsigned i, count;
	JNIEnv *env;
	jclass appletHandlerClass;
	jmethodID showAppletInfo;
#endif

	if ([anEvent isKindOfClass:[NSEvent class]])
		type = [((NSEvent *)anEvent) type];

	/* This helps us avoid Camino's spurious per-keystroke and per-mouse-
	 * down or mouse-drag updates in JEPController maybeDrawApplet.  (Camino
	 * triggers an update in the MRJ Plugin for every keystroke received in an
	 * applet, and for many mouse-downs and some mouse-drags.)
	 */
	if (mainThread && nsAppShadow) {
		if ([toTarget isKindOfClass:[NSView class]]) {
			controller = [JEPController
				controllerContainingNSView:(NSView *)toTarget
				timeoutType:lockTimeoutNone];
		}
		if (controller) {
			if (!isCarbonApp && (type == NSKeyDown))
				controller->skipDrawAppletOnce = true;
			if ((type == NSLeftMouseDown) || (type == NSRightMouseDown) ||
				(type == NSOtherMouseDown))
				++controller->suspendDrawAppletCounter;
			else if ((type == NSLeftMouseUp) || (type == NSRightMouseUp) ||
				(type == NSOtherMouseUp))
			{
				currentThread = [NSThread currentThread];
				if ([mainThread isEqual:currentThread]) {
					[nsAppShadow scheduleResumeDrawApplet:controller];
				} else {
					[nsAppShadow performSelectorOnMainThread:
						@selector(scheduleResumeDrawApplet:)
						withObject:controller waitUntilDone:false];
				}
			}
		}
	}
	/* The following is particularly useful for debugging the contents and
	 * structure of windows in Cocoa browsers -- every time you press a key
	 * in an applet's input context, the entire structure of the window is
	 * displayed.
	 */
#ifdef DEBUG_VIEW_STRUCTURE
	if ([toTarget isKindOfClass:[NSWindow class]]) {
		cocoaWindow = (NSWindow *) toTarget;
	} else if ([toTarget isKindOfClass:[NSView class]]) {
		oneView = (NSView *) toTarget;
		cocoaWindow = [oneView window];
	}
	if (cocoaWindow && (type == NSKeyDown) &&
		((viewsFound = [[NSMutableArray alloc] init]) != nil) &&
		((appletViewsFound = [[NSMutableArray alloc] init]) != nil))
	{
		NSLog(@"Views in window %@:", cocoaWindow);
		[JEPController disableScreenUpdates];
		contentView = [cocoaWindow contentView];
		[viewsFound addObject:contentView];
		[JEPController allSubviews:contentView container:viewsFound];
		count = [viewsFound count];
		for (i = 1; i <= count; ++i) {
			oneView = [viewsFound objectAtIndex:i-1];
			if ([oneView isKindOfClass:[AppletView class]])
				[appletViewsFound addObject:oneView];
			NSLog(@"  %@", oneView);
			bounds = [oneView bounds];
			frame = [contentView convertRect:bounds fromView:oneView];
			NSLog(@"    frame x %f y %f width %f height %f",
				frame.origin.x, frame.origin.y,
				frame.size.width, frame.size.height);
			NSLog(@"    bounds x %f y %f width %f height %f",
				bounds.origin.x, bounds.origin.y,
				bounds.size.width, bounds.size.height);
		}
		if ([AppletView getJavaEnv:&env]) {
			count = [appletViewsFound count];
			for (i = 1; i <= count; ++i) {
				oneAppletView = (AppletView *) [appletViewsFound objectAtIndex:i-1];
				if (oneAppletView->myAppletHandler) {
					appletHandlerClass = (*env)->GetObjectClass(env,
						oneAppletView->myAppletHandler);
					showAppletInfo = (*env)->GetMethodID(env, appletHandlerClass,
						"showAppletInfo", "()V");
					(*env)->CallVoidMethod(env,
						oneAppletView->myAppletHandler, showAppletInfo);
					(*env)->DeleteLocalRef(env, appletHandlerClass);
				}
			}
		}
		[JEPController enableScreenUpdates];
		[viewsFound removeAllObjects];
		[viewsFound release];
		[appletViewsFound removeAllObjects];
		[appletViewsFound release];
	}
#endif

	superclass = [eventFactoryClassPoser superclass];
	target.receiver = self;
	target.class = superclass->isa;
	objc_msgSendSuper(&target, sel, anEvent, toTarget);
}

BOOL PoseAsEventFactory(void)
{
	BOOL retval;
	struct objc_method_list *class_methods;

	if ((class_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	class_methods->obsolete = nil;
	class_methods->method_count = 1;
	class_methods->method_list[0].method_name =
		sel_registerName("forwardEvent:toTarget:");
	class_methods->method_list[0].method_types = "v0@4:8@12@16";
	class_methods->method_list[0].method_imp =
		(IMP) forwardEvent_EF;

	retval = PoseAsUndocumentedClass("EventFactory", "MyEventFactory",
		&eventFactoryClass, &eventFactoryClassPoser, NULL, class_methods);

	return retval;
}

/* You sometimes get crashes in FocusManager viewBecameKey (at least), in OS X
 * 10.3.X, when the JVM tries to call it on a CAppletWindow object that has
 * already been deleted.
 */
static void viewBecameKey_FM(id self, SEL sel, id aModel, JNIEnv *env)
{
	Class superclass;
	struct objc_super target;
	JEPController *controller;
	if (aModel && [aModel isKindOfClass:cAppletWindowClass]) {
		controller = [JEPController controllerFromCWindow:aModel
			timeoutType:lockTimeoutNormal];
		if (controller && [controller destroying])
			return;
	}
	superclass = [focusManagerClassPoser superclass];
	target.receiver = self;
	target.class = superclass->isa;
	objc_msgSendSuper(&target, sel, aModel, env);
}

static void viewResignedKey_FM(id self, SEL sel, id aModel, JNIEnv *env)
{
	Class superclass;
	struct objc_super target;
	JEPController *controller;
	if (aModel && [aModel isKindOfClass:cAppletWindowClass]) {
		controller = [JEPController controllerFromCWindow:aModel
			timeoutType:lockTimeoutNormal];
		if (controller && [controller destroying])
			return;
	}
	superclass = [focusManagerClassPoser superclass];
	target.receiver = self;
	target.class = superclass->isa;
	objc_msgSendSuper(&target, sel, aModel, env);
}

/* As of JEP 0.9.6/0.9.5+e, we're now (in a Carbon-based browser) turning on
 * the plugin's "Cocoa state" (and if necessary making its window key and
 * visible) when that's actually needed -- as the plugin is made first
 * responder.  We used to do it (for the first time) as the plugin was being
 * started -- which was too early and led to subtle timing errors.
 */
static BOOL becomeFirstResponder_FM(id self, SEL sel, id aModel,
	id previousFirstResponder, BOOL superResponse, JNIEnv *env)
{
	int retval;
	Class superclass;
	struct objc_super target;
	JEPController *controller = nil;
	static int entered = 0;
	superclass = [focusManagerClassPoser superclass];
	target.receiver = self;
	target.class = superclass->isa;
	/* A call to NSWindow makeFirstResponder in JEPController
	 * activateCocoaInputContext can cause this method to be re-entered.
	 */
	if (++entered != 1) {
		retval = (int) objc_msgSendSuper(&target, sel, aModel,
			previousFirstResponder, superResponse, env);
		--entered;
		return (BOOL) retval;
	}
	if (isCarbonApp && superResponse) {
		id owningModel = nil;
		WindowModality carbonModal = 0;
		WindowRef unavailableWindow = nil;
		/* Skip this call if the focus is currently in a Carbon-based modal
		 * loop -- Apple's Cocoa-Carbon interface can't handle a Carbon-based
		 * modal loop above a Cocoa-based window.  But first call through to
		 * our superclass if the Carbon-based modal loop is also a Cocoa-based
		 * one (as can happen at least on OS X 10.4 and above).  This resolves
		 * bmo bug 360313.
		 */
		GetWindowModality(GetUserFocusWindow(), &carbonModal, &unavailableWindow);
		if (carbonModal) {
			if ([NSApp _isRunningModal]) {
				retval = (int) objc_msgSendSuper(&target, sel, aModel,
					previousFirstResponder, superResponse, env);
			} else {
				retval = false;
			}
			--entered;
			return (BOOL) retval;
		}
		if (aModel)
			owningModel = [aModel getOwningModel];
		controller = [JEPController controllerFromCWindow:owningModel
			timeoutType:lockTimeoutNone];
		/* Once an applet has been clicked on at least once, only allow some
		 * part of it to get the keyboard focus if the applet as a whole is
		 * focused.  This helps avoid some cases where the keyboard focus
		 * seems to be in a browser text-input field but really is an an
		 * applet's text-input field.
		 */
		if (controller && controller->myWindow && ![controller destroying] &&
			(controller->hasKeyWindow || !controller->everMouseFocused))
		{
			int windowNumber;
			NSWindow *cacheWindow;
			JEPController *cacheController = nil;
			windowNumber = [controller->myWindow _realWindowNumber];
			cacheWindow = [NSApp windowWithWindowNumber:windowNumber];
			if (!cacheWindow || (cacheWindow != controller->myWindow)) {
				if (cacheWindow) {
					cacheController = [JEPController
						controllerFromNSWindow:cacheWindow
						timeoutType:lockTimeoutShort];
					if (cacheController && cacheController->myLock) {
						[cacheController->myLock lock];
						cacheController->hasKeyWindow = false;
						[cacheController setCarbonTSMState];
						[cacheController activateCarbonInputContext];
						if ([cacheWindow isVisible]) {
							[cacheWindow _setVisible:false];
						}
						[NSApp _removeWindowFromCache:cacheWindow];
						[cacheController->myLock unlock];
					}
				}
				[controller->myWindow _setWindowNumber:0xFFFFFFFF];
				[controller->myWindow _setWindowNumber:windowNumber];
				[NSApp _getWindowCache:controller->myWindow add:true];
			}
			if (![controller->myWindow isVisible])
				[controller->myWindow _setVisible:true];
			if (![controller->myWindow isKeyWindow])
				[controller->myWindow makeKeyWindow];
			controller->hasKeyWindow = true;
			if (!controller->tsmInfo.cocoaStateSet) {
				[controller setCocoaTSMState];
				[controller activateCocoaInputContext];
			}
		} else if (controller) {
#ifdef DEBUG_EVENTS
			NSLog(@"FocusManager becomeFirstResponder(10.4/10.5): aModel %@, previousFirstResponder %@, superResponse %s, returning false because focus not in controller %@",
				aModel, previousFirstResponder, superResponse ? "true" : "false", controller);
#endif
			controller->hasKeyWindow = false;
			if (!controller->tsmInfo.carbonStateSet) {
				[controller setCarbonTSMState];
				[controller activateCarbonInputContext];
			}
			/* We need to call our superclass's method here (though we still
			 * must return "false"), because doing so resolves the following
			 * problem:  Open two browser windows, in one of them load an
			 * applet with a text-input field, type contents into the field,
			 * and leave it highlighted.  Then click in the first window
			 * outside of any applet -- sometimes the contents of the applet's
			 * text-input field will be highlighted and grayed out, sometimes
			 * not.  If it isn't highlighted and grayed out, try switching
			 * back and forth between the two windows, clicking on their title
			 * bars.  At least some of the time, on switching to the first
			 * window its applet's text-field's contents will be highlighted
			 * and grayed out.  Click in the text-field -- the highlighting
			 * (and grayness) will disappear.  But without the following call,
			 * it won't be possible to enter text in the field (not until you
			 * click elsewhere in the window and then back on the text-field).
			 */
			objc_msgSendSuper(&target, sel, aModel, previousFirstResponder,
				superResponse, env);
			--entered;
			return false;
		}
	}
	retval = (int) objc_msgSendSuper(&target, sel, aModel,
		previousFirstResponder, superResponse, env);
	if (isCarbonApp && controller && !retval) {
		controller->hasKeyWindow = false;
		if (!controller->tsmInfo.carbonStateSet) {
			[controller setCarbonTSMState];
			[controller activateCarbonInputContext];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"FocusManager becomeFirstResponder(10.4/10.5): aModel %@, previousFirstResponder %@, superResponse %s, returning %s",
		aModel, previousFirstResponder, superResponse ? "true" : "false", retval ? "true" : "false");
#endif
	--entered;
	return (BOOL) retval;
}

static BOOL becomeFirstResponder2_FM(id self, SEL sel, id aModel,
	BOOL superResponse, JNIEnv *env)
{
	int retval;
	Class superclass;
	struct objc_super target;
	NSView *control = [aModel getView];
	JEPController *controller = nil;
	static int entered = 0;
	superclass = [focusManagerClassPoser superclass];
	target.receiver = self;
	target.class = superclass->isa;
	/* A call to NSWindow makeFirstResponder in JEPController
	 * activateCocoaInputContext can cause this method to be re-entered.
	 */
	if (++entered != 1) {
		retval = (int) objc_msgSendSuper(&target, sel, aModel,
			superResponse, env);
		--entered;
		return (BOOL) retval;
	}
	if (isCarbonApp && superResponse) {
		id owningWindow = nil;
		WindowModality carbonModal = 0;
		WindowRef unavailableWindow = nil;
		/* Skip this call if the focus is currently in a Carbon-based modal
		 * loop -- Apple's Cocoa-Carbon interface can't handle a Carbon-based
		 * modal loop above a Cocoa-based window.  But first call through to
		 * our superclass if the Carbon-based modal loop is also a Cocoa-based
		 * one (as can happen at least on OS X 10.4 and above).
		 */
		GetWindowModality(GetUserFocusWindow(), &carbonModal, &unavailableWindow);
		if (carbonModal) {
			if ([NSApp _isRunningModal]) {
				retval = (int) objc_msgSendSuper(&target, sel, aModel,
					superResponse, env);
			} else {
				retval = false;
			}
			--entered;
			return (BOOL) retval;
		}
		if (aModel)
			owningWindow = [aModel getOwningWindow];
		controller = [JEPController controllerFromCWindow:owningWindow
			timeoutType:lockTimeoutNone];
		/* Once an applet has been clicked on at least once, only allow some
		 * part of it to get the keyboard focus if the applet as a whole is
		 * focused.  This helps avoid some cases where the keyboard focus
		 * seems to be in a browser text-input field but really is an an
		 * applet's text-input field.
		 */
		if (controller && controller->myWindow && ![controller destroying] &&
			(controller->hasKeyWindow || !controller->everMouseFocused))
		{
			int windowNumber;
			NSWindow *cacheWindow;
			JEPController *cacheController = nil;
			windowNumber = [controller->myWindow _realWindowNumber];
			cacheWindow = [NSApp windowWithWindowNumber:windowNumber];
			if (!cacheWindow || (cacheWindow != controller->myWindow)) {
				if (cacheWindow) {
					cacheController = [JEPController
						controllerFromNSWindow:cacheWindow
						timeoutType:lockTimeoutShort];
					if (cacheController && cacheController->myLock) {
						[cacheController->myLock lock];
						cacheController->hasKeyWindow = false;
						[cacheController setCarbonTSMState];
						[cacheController activateCarbonInputContext];
						if ([cacheWindow isVisible]) {
							[cacheWindow _setVisible:false];
						}
						[NSApp _removeWindowFromCache:cacheWindow];
						[cacheController->myLock unlock];
					}
				}
				[controller->myWindow _setWindowNumber:0xFFFFFFFF];
				[controller->myWindow _setWindowNumber:windowNumber];
				[NSApp _getWindowCache:controller->myWindow add:true];
			}
			if (![controller->myWindow isVisible])
				[controller->myWindow _setVisible:true];
			if (![controller->myWindow isKeyWindow])
				[controller->myWindow makeKeyWindow];
			controller->hasKeyWindow = true;
			if (!controller->tsmInfo.cocoaStateSet) {
				[controller setCocoaTSMState];
				[controller activateCocoaInputContext];
			}
		} else if (controller) {
#ifdef DEBUG_EVENTS
			NSLog(@"FocusManager becomeFirstResponder(10.3): aModel %@, superResponse %s, returning false because focus not in controller %@",
				aModel, superResponse ? "true" : "false", controller);
#endif
			controller->hasKeyWindow = false;
			if (!controller->tsmInfo.carbonStateSet) {
				[controller setCarbonTSMState];
				[controller activateCarbonInputContext];
			}
			/* We need to call our superclass's method here (though we still
			 * must return "false"), because doing so resolves the following
			 * problem:  Open two browser windows, in one of them load an
			 * applet with a text-input field, type contents into the field,
			 * and leave it highlighted.  Then click in the first window
			 * outside of any applet -- sometimes the contents of the applet's
			 * text-input field will be highlighted and grayed out, sometimes
			 * not.  If it isn't highlighted and grayed out, try switching
			 * back and forth between the two windows, clicking on their title
			 * bars.  At least some of the time, on switching to the first
			 * window its applet's text-field's contents will be highlighted
			 * and grayed out.  Click in the text-field -- the highlighting
			 * (and grayness) will disappear.  But without the following call,
			 * it won't be possible to enter text in the field (not until you
			 * click elsewhere in the window and then back on the text-field).
			 */
			objc_msgSendSuper(&target, sel, aModel, superResponse, env);
			--entered;
			return false;
		}
	}
	retval = (int) objc_msgSendSuper(&target, sel, aModel, superResponse, env);
	/* On OS X 10.3, Apple's Java 1.4.2 JVM (at least) has a bug that
	 * sometimes the above call to return "false" for no apparent reason.  We
	 * work around this by returning whether or not our "model"'s "control"
	 * will allow it to be make a "first responder".  (The ArcTest sample
	 * applet's text-entry fields are sometimes effected by this bug.)
	 */
	if (isCarbonApp && control && !retval)
		retval = [control acceptsFirstResponder];
	if (isCarbonApp && controller && !retval) {
		controller->hasKeyWindow = false;
		if (!controller->tsmInfo.carbonStateSet) {
			[controller setCarbonTSMState];
			[controller activateCarbonInputContext];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"FocusManager becomeFirstResponder(10.3): aModel %@, superResponse %s, returning %s",
		aModel, superResponse ? "true" : "false", retval ? "true" : "false");
#endif
	--entered;
	return (BOOL) retval;
}

static BOOL becomeFirstResponder3_FM(id self, SEL sel, id aModel,
	BOOL superResponse)
{
	int retval;
	Class superclass;
	struct objc_super target;
	JEPController *controller = nil;
	static int entered = 0;
	superclass = [focusManagerClassPoser superclass];
	target.receiver = self;
	target.class = superclass->isa;
	/* A call to NSWindow makeFirstResponder in JEPController
	 * activateCocoaInputContext can cause this method to be re-entered.
	 */
	if (++entered != 1) {
		retval = (int) objc_msgSendSuper(&target, sel, aModel, superResponse);
		--entered;
		return (BOOL) retval;
	}
	if (isCarbonApp && superResponse) {
		id owningWindow = nil;
		WindowModality carbonModal = 0;
		WindowRef unavailableWindow = nil;
		/* Skip this call if the focus is currently in a Carbon-based modal
		 * loop -- Apple's Cocoa-Carbon interface can't handle a Carbon-based
		 * modal loop above a Cocoa-based window.  But first call through to
		 * our superclass if the Carbon-based modal loop is also a Cocoa-based
		 * one (as can happen at least on OS X 10.4 and above).
		 */
		GetWindowModality(GetUserFocusWindow(), &carbonModal, &unavailableWindow);
		if (carbonModal) {
			if ([NSApp _isRunningModal]) {
				retval = (int) objc_msgSendSuper(&target, sel, aModel,
					superResponse);
			} else {
				retval = false;
			}
			--entered;
			return (BOOL) retval;
		}
		if (aModel)
			owningWindow = [aModel getOwningWindow];
		controller = [JEPController controllerFromCWindow:owningWindow
			timeoutType:lockTimeoutNone];
		/* Once an applet has been clicked on at least once, only allow some
		 * part of it to get the keyboard focus if the applet as a whole is
		 * focused.  This helps avoid some cases where the keyboard focus
		 * seems to be in a browser text-input field but really is an an
		 * applet's text-input field.
		 */
		if (controller && controller->myWindow && ![controller destroying] &&
			(controller->hasKeyWindow || !controller->everMouseFocused))
		{
			int windowNumber;
			NSWindow *cacheWindow;
			JEPController *cacheController = nil;
			windowNumber = [controller->myWindow _realWindowNumber];
			cacheWindow = [NSApp windowWithWindowNumber:windowNumber];
			if (!cacheWindow || (cacheWindow != controller->myWindow)) {
				if (cacheWindow) {
					cacheController = [JEPController
						controllerFromNSWindow:cacheWindow
						timeoutType:lockTimeoutShort];
					if (cacheController && cacheController->myLock) {
						[cacheController->myLock lock];
						cacheController->hasKeyWindow = false;
						[cacheController setCarbonTSMState];
						[cacheController activateCarbonInputContext];
						if ([cacheWindow isVisible]) {
							[cacheWindow _setVisible:false];
						}
						[NSApp _removeWindowFromCache:cacheWindow];
						[cacheController->myLock unlock];
					}
				}
				[controller->myWindow _setWindowNumber:0xFFFFFFFF];
				[controller->myWindow _setWindowNumber:windowNumber];
				[NSApp _getWindowCache:controller->myWindow add:true];
			}
			if (![controller->myWindow isVisible])
				[controller->myWindow _setVisible:true];
			if (![controller->myWindow isKeyWindow])
				[controller->myWindow makeKeyWindow];
			controller->hasKeyWindow = true;
			if (!controller->tsmInfo.cocoaStateSet) {
				[controller setCocoaTSMState];
				[controller activateCocoaInputContext];
			}
		} else if (controller) {
#ifdef DEBUG_EVENTS
			NSLog(@"FocusManager becomeFirstResponder(10.2): aModel %@, superResponse %s, returning false because focus not in controller %@",
				aModel, superResponse ? "true" : "false", controller);
#endif
			controller->hasKeyWindow = false;
			if (!controller->tsmInfo.carbonStateSet) {
				[controller setCarbonTSMState];
				[controller activateCarbonInputContext];
			}
			/* We need to call our superclass's method here (though we still
			 * must return "false"), because doing so resolves the following
			 * problem:  Open two browser windows, in one of them load an
			 * applet with a text-input field, type contents into the field,
			 * and leave it highlighted.  Then click in the first window
			 * outside of any applet -- sometimes the contents of the applet's
			 * text-input field will be highlighted and grayed out, sometimes
			 * not.  If it isn't highlighted and grayed out, try switching
			 * back and forth between the two windows, clicking on their title
			 * bars.  At least some of the time, on switching to the first
			 * window its applet's text-field's contents will be highlighted
			 * and grayed out.  Click in the text-field -- the highlighting
			 * (and grayness) will disappear.  But without the following call,
			 * it won't be possible to enter text in the field (not until you
			 * click elsewhere in the window and then back on the text-field).
			 */
			objc_msgSendSuper(&target, sel, aModel, superResponse);
			--entered;
			return false;
		}
	}
	retval = (int) objc_msgSendSuper(&target, sel, aModel, superResponse);
	if (isCarbonApp && controller && !retval) {
		controller->hasKeyWindow = false;
		if (!controller->tsmInfo.carbonStateSet) {
			[controller setCarbonTSMState];
			[controller activateCarbonInputContext];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"FocusManager becomeFirstResponder(10.2): aModel %@, superResponse %s, returning %s",
		aModel, superResponse ? "true" : "false", retval ? "true" : "false");
#endif
	--entered;
	return (BOOL) retval;
}

BOOL PoseAsFocusManager(void)
{
	BOOL retval;
	struct objc_method_list *class_methods;

	if ((class_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	class_methods->obsolete = nil;
	class_methods->method_count = 5;

	class_methods->method_list[0].method_name =
		sel_registerName("viewBecameKey:withEnv:");
	class_methods->method_list[0].method_types =
		"v0@4:8@12^^{JNINativeInterface_}16";
	class_methods->method_list[0].method_imp =
		(IMP) viewBecameKey_FM;
	class_methods->method_list[1].method_name =
		sel_registerName("viewResignedKey:withEnv:");
	class_methods->method_list[1].method_types =
		"v0@4:8@12^^{JNINativeInterface_}16";
	class_methods->method_list[1].method_imp =
		(IMP) viewResignedKey_FM;
	class_methods->method_list[2].method_name =
		sel_registerName("becomeFirstResponder:previousFirstResponder:superResponse:withEnv:");
	class_methods->method_list[2].method_types =
		"c0@4:8@12@16c20^^{JNINativeInterface_}24";
	class_methods->method_list[2].method_imp =
		(IMP) becomeFirstResponder_FM;
	class_methods->method_list[3].method_name =
		sel_registerName("becomeFirstResponder:superResponse:withEnv:");
	class_methods->method_list[3].method_types =
		"c0@4:8@12c16^^{JNINativeInterface_}20";
	class_methods->method_list[3].method_imp =
		(IMP) becomeFirstResponder2_FM;
	class_methods->method_list[4].method_name =
		sel_registerName("becomeFirstResponder:superResponse:");
	class_methods->method_list[4].method_types = "c0@4:8@12c16";
	class_methods->method_list[4].method_imp =
		(IMP) becomeFirstResponder3_FM;

	retval = PoseAsUndocumentedClass("FocusManager", "MyFocusManager",
		&focusManagerClass, &focusManagerClassPoser, NULL, class_methods);

	return retval;
}

/* It seems that the new code in registerModelForUpdate can cause deadlocks
 * if we let that method and updateModels "interrupt" each other.  We still
 * let the interrupts happen, but don't in that case use any of the new code.
 */
NSLock *modelUpdaterLock = nil;

/* This function fixes a problem that exists in all Apple's Java 1.4.X
 * versions (in both Carbon and Cocoa browsers), but which seems only to
 * have visible effects in Java 1.4.2 Update 1 (and possibly Java 1.4.2
 * "plain") (as long as the setAWTDelegate bug described below remains
 * unfixed):  registerModelForUpdate gets called on invisible applets (e.g.
 * ones runing in other tabs), which in turn causes syncFromJava to be
 * called on those applets' components.  This no longer seems to be a
 * problem in Tiger.
 */
static void registerModelForUpdate_TU(id self, SEL sel, id model)
{
	id parent = nil;
	id cWindow = nil;
	JEPController *controller = nil;
	Class superclass;
	struct objc_super target;

	if (isJava142) {
		superclass = [awtModelUpdaterClassPoser superclass];
	} else {
		superclass = [threadUtilitiesClassPoser superclass];
	}
	target.receiver = self;
	target.class = superclass->isa;

	if (osxVersion >= 0x1040) {
		objc_msgSendSuper(&target, sel, model);
		return;
	}

	if (!model || !modelUpdaterLock || ![modelUpdaterLock
		lockBeforeDate:[NSDate dateWithTimeIntervalSinceNow:LOCK_TIMEOUT]])
	{
		return;
	}

	if ([model isKindOfClass:cWindowClass]) {
		cWindow = parent = model;
	} else {
		parent = model;
		while (parent && !cWindow) {
			if ([parent respondsToSelector:@selector(getOwningWindow)])
				cWindow = [parent getOwningWindow];
			if (cWindow)
				break;
			if (![parent respondsToSelector:@selector(getParent)])
				break;
			parent = [parent getParent];
		}
	}
	if (!cWindow || ![cWindow isKindOfClass:cAppletWindowClass]) {
		objc_msgSendSuper(&target, sel, model);
		[modelUpdaterLock unlock];
		return;
	}

	controller = [JEPController controllerFromCWindow:cWindow
		timeoutType:lockTimeoutShort];
#ifdef DEBUG_EVENTS
	NSLog(@"registerModelForUpdate: model %@, parent %@, cWindow %@, controller %@",
		model, parent, cWindow, controller);
#endif
	/* Crashes can happen when this is called on an object that's being
	 * destroyed.
	 */
	if (!controller || [controller destroying]) {
		[modelUpdaterLock unlock];
		return;
	}
	if (controller->myAppletView &&
		(controller->myAppletView->appletState == kAppletStartJEP) &&
		(controller->myAppletView->isInvisible ||
		[controller->myAppletView isCurrentClipEmpty] ||
		![controller->myAppletView isAppletVisible]))
	{
#ifdef DEBUG_EVENTS
		NSLog(@"registerModelForUpdate: Skipping because applet invisible, model %@", model);
#endif
		[modelUpdaterLock unlock];
		return;
	}

	objc_msgSendSuper(&target, sel, model);
	[modelUpdaterLock unlock];
}

static void updateModels_TU(id self, SEL sel, id unknown)
{
	Class superclass;
	struct objc_super target;
	if (isJava142) {
		superclass = [awtModelUpdaterClassPoser superclass];
	} else {
		superclass = [threadUtilitiesClassPoser superclass];
	}

	target.receiver = self;
	target.class = superclass->isa;
	if ((osxVersion >= 0x1040) || !modelUpdaterLock)
		objc_msgSendSuper(&target, sel, unknown);
	else {
		if (![modelUpdaterLock
			lockBeforeDate:[NSDate dateWithTimeIntervalSinceNow:LOCK_TIMEOUT]])
			return;
		objc_msgSendSuper(&target, sel, unknown);
		[modelUpdaterLock unlock];
	}
}

/* This method and start_AWTST() and beginApp_SU() (below) help work around a
 * nasty bug (or bugs) in how Apple loads its AWT libraries, which sometimes
 * leads to hangs while they are being loaded (or while loading applets just
 * afterwards), despite all the other precautions I've taken.  In all three
 * cases I replace the original method with one that calls AppletView
 * performOnMainThread where the original would have called NSObject
 * performSelectorOnMainThread.  For more information see the comment on the
 * CustomEvent class in AppletView.m.  This variation of ThreadUtilities
 * performOnMainThread is only available on Tiger.
 */
static void performOnMainThread_TU(id self, SEL sel, SEL aSelector, id target,
	id object, BOOL waitUntilDone, BOOL awtMode)
{
	id performer;
	NSArray *awtModes = [NSArray arrayWithObjects:@"kCFRunLoopDefaultMode",
		NSModalPanelRunLoopMode, NSEventTrackingRunLoopMode,
		@"AWTRunLoopMode", nil];
	if (awtMode) {
		if ((performer = [cPerformerClass alloc]) != nil) {
			/* In Java 1.6.0 the CPerformer constructor takes four parameters.
			 * On OS X Tiger (and earlier), in other Java versions this
			 * constructor takes three parameters.  The same is true of the
			 * WWDC Leopard Developer Preview (build 9A421).  But with build
			 * 9A283 CPerformer's constructor also takes four parameters in
			 * Java 1.5.0.  Until Leopard settles down, we'll need to go by
			 * whether or not 'performer' responds to the four-parameter
			 * constructor.
			 */
			/* 'target' and 'object' should be "retained" to make sure they
			 * aren't deallocated prematurely.  Before JEP 0.9.6.1 we always
			 * did this ourselves.  But the four-parameter version of
			 * initWithTarget also retains its "target" and "arg" parameters,
			 * (only the three-parameter version doesn't).  So if we retain
			 * these objects when using the four-parameter initWithTarget,
			 * they'll get leaked (and other strange things will happen).
			 * 'target' and 'object' are released in AppletView.m's
			 * [CustomEvent dealloc].
			 */
			/* This change resolves a problem (with Java 6.0 on all platforms
			 * and with Java 5.0 on Leopard) that was extremely difficult to
			 * track down -- clicking on an applet at least once caused it not
			 * to be garbage-collected!  It turns out this was (indirectly)
			 * caused by AWTComponentSetFocusData objects (i.e. "args") not
			 * being deallocated.  (AWTComponentSetFocusData objects are used
			 * by CComponent._requestFocus() (which normally runs on a
			 * secondary thread) to pass data to FocusManager requestFocus
			 * (which needs to run on the main thread) via ThreadUtilities
			 * performOnMainThread.)
			 */
			/* Before JEP 0.9.6.3 we checked 'target' and 'object's retain
			 * count (before and after the call to initWithTarget) to
			 * determine whether or not we needed to "retain" them ourselves.
			 * But under some circumstances, other threads can change these
			 * objects' retain counts in the middle of our check -- causing
			 * us not to retain them when we should, and causing wierd crashes
			 * down the road.  Now we always retain 'target' and 'object' when
			 * using the three-parameter initWithTarget, and never retain them
			 * when using the four-parameter initWithTarget.  This seems to
			 * work correctly.  And it resolves bmo bug 380517.
			 */
			if ([performer respondsToSelector:
				@selector(initWithTarget:selector:arg:wait:)])
			{
				performer = [performer initWithTarget:target
					selector:aSelector arg:object wait:true];
			} else {
				performer = [performer initWithTarget:target
					selector:aSelector arg:object];
				if (target)
					[target retain];
				if (object)
					[object retain];
			}
		}
		if (performer) {
			[AppletView performOnMainThread:@selector(perform)
				onTarget:performer withObject:nil
				waitUntilDone:waitUntilDone inModes:awtModes];
		}
	} else {
		[AppletView performOnMainThread:aSelector onTarget:target
			withObject:object waitUntilDone:waitUntilDone];
	}
}

BOOL PoseAsThreadUtilities(void)
{
	BOOL retval;
	struct objc_method_list *class_methods;

	if ((class_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	class_methods->obsolete = nil;
	class_methods->method_count = 3;
	class_methods->method_list[0].method_name =
		sel_registerName("registerModelForUpdate:");
	class_methods->method_list[0].method_types = "v0@4:8@12";
	class_methods->method_list[0].method_imp =
		(IMP) registerModelForUpdate_TU;
	class_methods->method_list[1].method_name =
		sel_registerName("updateModels:");
	class_methods->method_list[1].method_types = "v0@4:8@12";
	class_methods->method_list[1].method_imp =
		(IMP) updateModels_TU;
	class_methods->method_list[2].method_name =
		sel_registerName("performOnMainThread:onObject:withObject:waitUntilDone:awtMode:");
	class_methods->method_list[2].method_types = "v0@4:8:12@16@20c24c28";
	class_methods->method_list[2].method_imp =
		(IMP) performOnMainThread_TU;

	retval = PoseAsUndocumentedClass("ThreadUtilities", "MyThreadUtilities",
		&threadUtilitiesClass, &threadUtilitiesClassPoser, NULL, class_methods);

	return retval;
}

BOOL PoseAsAWTModelUpdater(void)
{
	BOOL retval;
	struct objc_method_list *class_methods;

	if ((class_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	class_methods->obsolete = nil;
	class_methods->method_count = 2;
	class_methods->method_list[0].method_name =
		sel_registerName("registerModelForUpdate:");
	class_methods->method_list[0].method_types = "v0@4:8@12";
	class_methods->method_list[0].method_imp =
		(IMP) registerModelForUpdate_TU;
	class_methods->method_list[1].method_name =
		sel_registerName("updateModels:");
	class_methods->method_list[1].method_types = "v0@4:8@12";
	class_methods->method_list[1].method_imp =
		(IMP) updateModels_TU;

	retval = PoseAsUndocumentedClass("AWTModelUpdater", "MyAWTModelUpdater",
		&awtModelUpdaterClass, &awtModelUpdaterClassPoser, NULL, class_methods);

	return retval;
}

/* This fixes a problem with Camino hanging on the NOAA radar looping applets
 * in OS X 10.3.X.  Other 0.8.2 changes (notably improved clipping and making
 * the SimpleLayout class less "simple") reduced the number of ways these
 * hangs could occur.  But, at least for now, the following bodacious hack is
 * still sometimes necessary (particularly when the screen changes very
 * rapidly, for example as a result of spinning the mouse wheel).  Thankfully,
 * this seems to have been fixed in Tiger.
 */
static void markAsDirty_CM(id self, SEL sel)
{
	NSView *topView = nil, *view = nil;
	id parent = nil, gparent = nil;
	struct objc_super target;
	if ((osxVersion >= 0x1040) || isCarbonApp) {
		target.receiver = self;
		target.class = [controlModelClassPoser superclass];
		objc_msgSendSuper(&target, sel);
		return;
	}
	if ((parent = [self getParent]) != nil)
		gparent = [parent getParent];
	if ([self isMemberOfClass:NSClassFromString(@"CAppletWindow")])
		topView = [self getView];
	else if (parent && [parent isMemberOfClass:NSClassFromString(@"CAppletWindow")])
		topView = [parent getView];
	else if (gparent && [gparent isMemberOfClass:NSClassFromString(@"CAppletWindow")])
		topView = [gparent getView];
	view = [self getView];
	if (view && [view needsDisplay] && topView && [topView needsDisplay]) {
#ifdef DEBUG_EVENTS
		NSLog(@"ControlModel markAsDirty: Die, you miserable insect!");
#endif
		return;
	}
	target.receiver = self;
	target.class = [controlModelClassPoser superclass];
	objc_msgSendSuper(&target, sel);
}

/* An obscure bug that effects OS X 10.2.8 and 10.3.X (but not 10.4.X) can,
 * under unusual circumstances, cause an applet to be leaked by the Java
 * garbage collector:  Creating a Java "drop target" causes a JNI global
 * reference to its "host" to be created.  But the CDropTarget native peer
 * doesn't always get deallocated when the drop target is removed.  And if the
 * host is the applet itself, this can cause the JNI global reference to never
 * be deleted, which causes the applet to be leaked.  CDropTarget objects are
 * leaked when setDraggingDestination is called with a NULL dropTarget (from
 * apple.awt.CDropTarget.releaseNativeDropTarget(), on a secondary thread),
 * but this isn't followed by a call to updateDraggingDestination (from the
 * host peer object's syncFromJava method, on the main thread).  To work
 * around this problem, we call updateDraggingDestination straight away from
 * setDraggingDestination (on the secondary thread) when "dropTarget" is NULL.
 * Applets that can be leaked by this bug are very rare -- the only examples I
 * know of are at http://javadjvu.foxtrottechnologies.com/.
 */
static void setDraggingDestination_CM(id self, SEL sel, id dropTarget)
{
	struct objc_super target;
	target.receiver = self;
	target.class = [controlModelClassPoser superclass];
	objc_msgSendSuper(&target, sel, dropTarget);
	if (!dropTarget)
		[self updateDraggingDestination];
}

/* _setNativeFrame_CM(), updateFrame_CM() and updateFrame2_CM() intercept
 * calls to update our "model" objects' frame that result from the workaround
 * in reflectScrolledClipView_AWTSV().  If we don't intercept these calls,
 * a ScrollPane's contents will jump around a lot as someone scrolls it.
 */
static void _setNativeFrame_CM(id self, SEL sel, NSRect aRect, id forView)
{
	JNIEnv *env = nil;
	id parent = nil;
	jobject peer = nil;
	jclass myCScrollPaneClass = nil;
	jmethodID readSkipNextScrollView = nil;
	jboolean skipScrollView = false;
	struct objc_super target;
	if ([AppletView getJavaEnv:&env]) {
		parent = [self getParent];
		if (parent && [parent isMemberOfClass:cScrollPaneClass])
			peer = [parent peer];
		if (peer) {
			myCScrollPaneClass = (*env)->FindClass(env, "apple/awt/MyCScrollPane");
			if ((*env)->IsInstanceOf(env, peer, myCScrollPaneClass)) {
				readSkipNextScrollView = (*env)->GetMethodID(env,
					myCScrollPaneClass, "readSkipNextScrollView", "()Z");
				skipScrollView = (*env)->CallBooleanMethod(env, peer,
					readSkipNextScrollView);
				(*env)->DeleteLocalRef(env, myCScrollPaneClass);
				if ((*env)->ExceptionCheck(env)) {
					skipScrollView = false;
					(*env)->ExceptionClear(env);
				}
				if (skipScrollView)
					return;
			} else {
				(*env)->DeleteLocalRef(env, myCScrollPaneClass);
				if ((*env)->ExceptionCheck(env))
					(*env)->ExceptionClear(env);
			}
		}
	}
	target.receiver = self;
	target.class = [controlModelClassPoser superclass];
	objc_msgSendSuper(&target, sel, aRect, forView);
}

static void updateFrame_CM(id self, SEL sel, JNIEnv *env)
{
	id parent = nil;
	jobject peer = nil;
	jclass myCScrollPaneClass = nil;
	jmethodID readSkipNextScrollView = nil;
	jboolean skipScrollView = false;
	struct objc_super target;
	parent = [self getParent];
	if (parent && [parent isMemberOfClass:cScrollPaneClass])
		peer = [parent peer];
	if (peer) {
		myCScrollPaneClass = (*env)->FindClass(env, "apple/awt/MyCScrollPane");
		if ((*env)->IsInstanceOf(env, peer, myCScrollPaneClass)) {
			readSkipNextScrollView = (*env)->GetMethodID(env, myCScrollPaneClass,
				"readSkipNextScrollView", "()Z");
			skipScrollView = (*env)->CallBooleanMethod(env, peer,
				readSkipNextScrollView);
			(*env)->DeleteLocalRef(env, myCScrollPaneClass);
			if ((*env)->ExceptionCheck(env)) {
				skipScrollView = false;
				(*env)->ExceptionClear(env);
			}
			if (skipScrollView)
				return;
		} else {
			(*env)->DeleteLocalRef(env, myCScrollPaneClass);
			if ((*env)->ExceptionCheck(env))
				(*env)->ExceptionClear(env);
		}
	}
	target.receiver = self;
	target.class = [controlModelClassPoser superclass];
	objc_msgSendSuper(&target, sel, env);
}

static void updateFrame2_CM(id self, SEL sel)
{
	JNIEnv *env = nil;
	id parent = nil;
	jobject peer = nil;
	jclass myCScrollPaneClass = nil;
	jmethodID readSkipNextScrollView = nil;
	jboolean skipScrollView = false;
	struct objc_super target;
	if ([AppletView getJavaEnv:&env]) {
		parent = [self getParent];
		if (parent && [parent isMemberOfClass:cScrollPaneClass])
			peer = [parent peer];
		if (peer) {
			myCScrollPaneClass = (*env)->FindClass(env, "apple/awt/MyCScrollPane");
			if ((*env)->IsInstanceOf(env, peer, myCScrollPaneClass)) {
				readSkipNextScrollView = (*env)->GetMethodID(env,
					myCScrollPaneClass, "readSkipNextScrollView", "()Z");
				skipScrollView = (*env)->CallBooleanMethod(env, peer,
					readSkipNextScrollView);
				(*env)->DeleteLocalRef(env, myCScrollPaneClass);
				if ((*env)->ExceptionCheck(env)) {
					skipScrollView = false;
					(*env)->ExceptionClear(env);
				}
				if (skipScrollView)
					return;
			} else {
				(*env)->DeleteLocalRef(env, myCScrollPaneClass);
				if ((*env)->ExceptionCheck(env))
					(*env)->ExceptionClear(env);
			}
		}
	}
	target.receiver = self;
	target.class = [controlModelClassPoser superclass];
	objc_msgSendSuper(&target, sel);
}

BOOL PoseAsControlModel(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 5;
	instance_methods->method_list[0].method_name =
		sel_registerName("markAsDirty");
	instance_methods->method_list[0].method_types = "v0@4:8";
	instance_methods->method_list[0].method_imp =
		(IMP) markAsDirty_CM;
	instance_methods->method_list[1].method_name =
		sel_registerName("setDraggingDestination:");
	instance_methods->method_list[1].method_types = "v0@4:8@12";
	instance_methods->method_list[1].method_imp =
		(IMP) setDraggingDestination_CM;
	instance_methods->method_list[2].method_name =
		sel_registerName("_setNativeFrame:forView:");
	instance_methods->method_list[2].method_types = 
		"v0@4:8{_NSRect={_NSPoint=ff}{_NSSize=ff}}12@16";
	instance_methods->method_list[2].method_imp =
		(IMP) _setNativeFrame_CM;
	instance_methods->method_list[3].method_name =
		sel_registerName("updateFrame:");
	instance_methods->method_list[3].method_types = 
		"v0@4:8^^{JNINativeInterface_}12";
	instance_methods->method_list[3].method_imp =
		(IMP) updateFrame_CM;
	instance_methods->method_list[4].method_name =
		sel_registerName("updateFrame");
	instance_methods->method_list[4].method_types = "v0@4:8";
	instance_methods->method_list[4].method_imp =
		(IMP) updateFrame2_CM;

	retval = PoseAsUndocumentedClass("ControlModel", "MyControlModel",
		&controlModelClass, &controlModelClassPoser, instance_methods, NULL);

	return retval;
}

static void drawRect_AWTBN(id self, SEL sel, NSRect aRect)
{
	struct objc_super target;
	JEPController *controller;
	target.receiver = self;
	target.class = [awtButtonClassPoser superclass];
	controller = [JEPController controllerContainingNSView:self
		timeoutType:lockTimeoutNormal];
	if (controller && [controller destroying]) {
		if (isJava142Update1) {
			[NSBezierPath clipRect:NSZeroRect];
			objc_msgSendSuper(&target, sel, aRect);
		}
		return;
	}
	if (controller && controller->myAppletView) {
		if (controller->updatesOff ||
			![controller->myAppletView isDisplayable])
		{
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			/* Without this line, "Button" objects sometimes get drawn
			 * outside the applet's bounds.
			 */
			[AppletView clipWithTranslation:self controller:controller];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"NSButtonAWT drawRect:  On %@", self);
#endif
	objc_msgSendSuper(&target, sel, aRect);
}

BOOL PoseAsNSButtonAWT(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 1;
	instance_methods->method_list[0].method_name =
		sel_registerName("drawRect:");
	instance_methods->method_list[0].method_types =
		"v0@4:8{_NSRect={_NSPoint=ff}{_NSSize=ff}}12";
	instance_methods->method_list[0].method_imp =
		(IMP) drawRect_AWTBN;

	retval = PoseAsUndocumentedClass("NSButtonAWT", "MyNSButtonAWT",
		&awtButtonClass, &awtButtonClassPoser, instance_methods, NULL);

	return retval;
}

static void drawRect_SC(id self, SEL sel, NSRect aRect)
{
	struct objc_super target;
	JEPController *controller;
	target.receiver = self;
	target.class = [scrollerClassPoser superclass];
	controller = [JEPController controllerContainingNSView:self
		timeoutType:lockTimeoutNormal];
	if (controller && [controller destroying]) {
		if (isJava142Update1) {
			[NSBezierPath clipRect:NSZeroRect];
			objc_msgSendSuper(&target, sel, aRect);
		}
		return;
	}
	if (controller && controller->myAppletView) {
		if (controller->updatesOff ||
			![controller->myAppletView isDisplayable])
		{
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			/* Without this line, "Scroller" objects sometimes get drawn
			 * outside the applet's bounds.
			 */
			[AppletView clipWithTranslation:self controller:controller];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"NSScroller drawRect:  On %@", self);
#endif
	objc_msgSendSuper(&target, sel, aRect);
}

/* This method, isOpaque_AWTTF() and isOpaque_AWTCTF() extend the fix in
 * AppletView isOpaque to objects inside an applet (i.e. an AppletView) that
 * need it.  Trial and error has shown that NSScroller, NSTextFieldAWT and
 * AWTCombinedTextField objects need this fix.  Others may also, but I haven't
 * yet found any.  (The NOAA weather applets contain an NSScroller object.
 * http://www.lohn1.de/lobn.htm contains several NSTextFieldAWT objects.
 * http://java.sun.com/applets/jdk/1.4/demo/applets/ArcTest/example1.html
 * contains two AWTCombinedTextField objects.)
 */
static BOOL isOpaque_SC(id self, SEL sel)
{
	int retval;
	NSRect dirty;
	JEPController *controller = nil;
	struct objc_super target;
	target.receiver = self;
	target.class = [scrollerClassPoser superclass];
	if ((retval = (int) objc_msgSendSuper(&target, sel)) == FALSE)
		return FALSE;
	if (!isCarbonApp) {
		controller = [JEPController controllerContainingNSView:self
			timeoutType:lockTimeoutNone];
	}
	if (controller) {
		if (isJava142Update1 &&
			(controller->updatesOff || !controller->myAppletView ||
			![controller->myAppletView isDisplayable]))
		{
			return FALSE;
		}
		dirty = [(NSView *) self _dirtyRect];
		if ((dirty.size.width <= 0) || (dirty.size.height <= 0))
			return FALSE;
	}
	return (BOOL) retval;
}

/* Before JEP 0.9.6 (0.9.5+d) this was "PoseAsNSScrollerAWT()".  But I found
 * that the NSScroller objects in NSScrollViewAWT objects were often
 * NSScroller objects (not NSScrollerAWT objects).
 */
BOOL PoseAsNSScroller(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 2;
	instance_methods->method_list[0].method_name =
		sel_registerName("drawRect:");
	instance_methods->method_list[0].method_types =
		"v0@4:8{_NSRect={_NSPoint=ff}{_NSSize=ff}}12";
	instance_methods->method_list[0].method_imp =
		(IMP) drawRect_SC;
	instance_methods->method_list[1].method_name =
		sel_registerName("isOpaque");
	instance_methods->method_list[1].method_types = "c0@4:8";
	instance_methods->method_list[1].method_imp =
		(IMP) isOpaque_SC;

	retval = PoseAsUndocumentedClass("NSScroller", "MyNSScroller",
		&scrollerClass, &scrollerClassPoser, instance_methods, NULL);

	return retval;
}

static void drawRect_AWTSV(id self, SEL sel, NSRect aRect)
{
	struct objc_super target;
	JEPController *controller;
	target.receiver = self;
	target.class = [awtScrollViewClassPoser superclass];
	controller = [JEPController controllerContainingNSView:self
		timeoutType:lockTimeoutNormal];
	if (controller && [controller destroying]) {
		if (isJava142Update1) {
			[NSBezierPath clipRect:NSZeroRect];
			objc_msgSendSuper(&target, sel, aRect);
		}
		return;
	}
	if (controller && controller->myAppletView) {
		if (controller->updatesOff ||
			![controller->myAppletView isDisplayable])
		{
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			/* Without this line, "ScrollPane" objects sometimes get drawn
			 * outside the applet's bounds.
			 */
			[AppletView clipWithTranslation:self controller:controller];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"NSScrollViewAWT drawRect:  On %@", self);
#endif
	objc_msgSendSuper(&target, sel, aRect);
}

/* All versions of Apple's 1.4.X and 1.5 JVMs have a bug that prevents
 * ScrollPane objects' contents from being updated correctly when they're
 * scrolled.  The scrollbar works, and the content does get scrolled.  But
 * the content's clipping isn't updated -- so once the first "page" is
 * scrolled out of view, none of the content is visible.  The bug's cause
 * is probably that NSScrollViewAWT objects use NSScroller objects for their
 * scrollers -- not the NSScrollerAWT objects they should use.  And I suppose
 * the best way to fix this bug would be to change this behavior.  But I
 * haven't (yet) figured out how to do this.  And in any case I've found a
 * more indirect workaround that seems to do what's needed.
 * reflectScrolledClipView is called "during scrolling and when an
 * NSClipViews relationship to its document view changes".  On these calls,
 * I call MyCToolkit.setScrollPanePosition() to make the state of the Java
 * ScrollPane object (to which our NSScrollViewAWT object corresponds) match
 * the state of our NSScrollViewAWT object.  To stop this from (in turn)
 * trying to update our NSScrollViewAWT object, I set a skipNextScrollView
 * flag in the ScrollPane's peer (a MyCScrollPane object), and intercept the
 * resulting calls to change our NSScrollViewAWT object's frame (in
 * _setNativeFrame_CM(), updateFrame_CM() and updateFrame2_CM() above).
 * This workaround (mostly) fixes the following bug.  (Scrollwheel behavior
 * still isn't quite correct ... but I don't know what I can do about that.)
 * http://sourceforge.net/tracker/index.php?func=detail&aid=1438338&group_id=107955&atid=649116
 */
static void reflectScrolledClipView_AWTSV(id self, SEL sel, id aClipView)
{
	JNIEnv *env = nil;
	id model = nil;
	jobject peer = nil;
	jclass myCToolkitClass = nil;
	jmethodID setScrollPanePosition = nil;
	NSRect visibleRect = NSZeroRect;
	struct objc_super target;
	target.receiver = self;
	target.class = [awtScrollViewClassPoser superclass];
	objc_msgSendSuper(&target, sel, aClipView);
	if (![AppletView getJavaEnv:&env])
		return;
	/* If we call "self"'s "peer" method directly, we sometimes crash
	 * (possibly when we're called as "self" is being created).  This
	 * change fixes bmo bug 338738.
	 */
	if ((model = [self model]) == nil)
		return;
	if ((peer = [model peer]) == nil)
		return;
	visibleRect = [(NSScrollView *) self documentVisibleRect];
	myCToolkitClass = (*env)->FindClass(env, "apple/awt/MyCToolkit");
	setScrollPanePosition = (*env)->GetStaticMethodID(env, myCToolkitClass,
		"setScrollPanePosition", "(Ljava/lang/Object;II)V");
	(*env)->CallStaticVoidMethod(env, myCToolkitClass,
		setScrollPanePosition, peer, (jint) rint(visibleRect.origin.x),
		(jint) rint(visibleRect.origin.y));
	(*env)->DeleteLocalRef(env, myCToolkitClass);
	if ((*env)->ExceptionCheck(env))
		(*env)->ExceptionClear(env);
}

BOOL PoseAsNSScrollViewAWT(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 2;
	instance_methods->method_list[0].method_name =
		sel_registerName("drawRect:");
	instance_methods->method_list[0].method_types =
		"v0@4:8{_NSRect={_NSPoint=ff}{_NSSize=ff}}12";
	instance_methods->method_list[0].method_imp =
		(IMP) drawRect_AWTSV;
	instance_methods->method_list[1].method_name =
		sel_registerName("reflectScrolledClipView:");
	instance_methods->method_list[1].method_types = "v0@4:8@12";
	instance_methods->method_list[1].method_imp =
		(IMP) reflectScrolledClipView_AWTSV;

	retval = PoseAsUndocumentedClass("NSScrollViewAWT", "MyNSScrollViewAWT",
		&awtScrollViewClass, &awtScrollViewClassPoser, instance_methods, NULL);

	return retval;
}

static void drawRect_AWTCH(id self, SEL sel, NSRect aRect)
{
	struct objc_super target;
	JEPController *controller;
	target.receiver = self;
	target.class = [awtChoiceClassPoser superclass];
	controller = [JEPController controllerContainingNSView:self
		timeoutType:lockTimeoutNormal];
	if (controller && [controller destroying]) {
		if (isJava142Update1) {
			[NSBezierPath clipRect:NSZeroRect];
			objc_msgSendSuper(&target, sel, aRect);
		}
		return;
	}
	if (controller && controller->myAppletView) {
		if (controller->updatesOff ||
			![controller->myAppletView isDisplayable])
		{
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			/* Without this line, "Choice" objects sometimes get drawn
			 * outside the applet's bounds.
			 */
			[AppletView clipWithTranslation:self controller:controller];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"NSChoiceAWT drawRect:  On %@", self);
#endif
	objc_msgSendSuper(&target, sel, aRect);
}

BOOL PoseAsNSChoiceAWT(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 1;
	instance_methods->method_list[0].method_name =
		sel_registerName("drawRect:");
	instance_methods->method_list[0].method_types =
		"v0@4:8{_NSRect={_NSPoint=ff}{_NSSize=ff}}12";
	instance_methods->method_list[0].method_imp =
		(IMP) drawRect_AWTCH;

	retval = PoseAsUndocumentedClass("NSChoiceAWT", "MyNSChoiceAWT",
		&awtChoiceClass, &awtChoiceClassPoser, instance_methods, NULL);

	return retval;
}

static void drawRect_AWTTBV(id self, SEL sel, NSRect aRect)
{
	struct objc_super target;
	JEPController *controller;
	target.receiver = self;
	target.class = [awtTableViewClassPoser superclass];
	controller = [JEPController controllerContainingNSView:self
		timeoutType:lockTimeoutNormal];
	if (controller && [controller destroying]) {
		if (isJava142Update1) {
			[NSBezierPath clipRect:NSZeroRect];
			objc_msgSendSuper(&target, sel, aRect);
		}
		return;
	}
	if (controller && controller->myAppletView) {
		if (controller->updatesOff ||
			![controller->myAppletView isDisplayable])
		{
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			/* Without this line, "TableView" objects sometimes get drawn
			 * outside the applet's bounds.
			 */
			[AppletView clipWithTranslation:self controller:controller];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"NSTableViewAWT drawRect:  On %@", self);
#endif
	objc_msgSendSuper(&target, sel, aRect);
}

BOOL PoseAsNSTableViewAWT(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 1;
	instance_methods->method_list[0].method_name =
		sel_registerName("drawRect:");
	instance_methods->method_list[0].method_types =
		"v0@4:8{_NSRect={_NSPoint=ff}{_NSSize=ff}}12";
	instance_methods->method_list[0].method_imp =
		(IMP) drawRect_AWTTBV;

	retval = PoseAsUndocumentedClass("NSTableViewAWT", "MyNSTableViewAWT",
		&awtTableViewClass, &awtTableViewClassPoser, instance_methods, NULL);

	return retval;
}

static void drawRect_AWTTF(id self, SEL sel, NSRect aRect)
{
	struct objc_super target;
	JEPController *controller;
	target.receiver = self;
	target.class = [awtTextFieldClassPoser superclass];
	controller = [JEPController controllerContainingNSView:self
		timeoutType:lockTimeoutNormal];
	if (controller && [controller destroying]) {
		if (isJava142Update1) {
			[NSBezierPath clipRect:NSZeroRect];
			objc_msgSendSuper(&target, sel, aRect);
		}
		return;
	}
	if (controller && controller->myAppletView) {
		if (controller->updatesOff ||
			![controller->myAppletView isDisplayable])
		{
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			/* Without this line, "Label" objects sometimes get drawn
			 * outside the applet's bounds.
			 */
			[AppletView clipWithTranslation:self controller:controller];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"NSTextFieldAWT drawRect:  On %@", self);
#endif
	objc_msgSendSuper(&target, sel, aRect);
}

static BOOL isOpaque_AWTTF(id self, SEL sel)
{
	int retval;
	NSRect dirty;
	JEPController *controller = nil;
	struct objc_super target;
	target.receiver = self;
	target.class = [awtTextFieldClassPoser superclass];
	if ((retval = (int) objc_msgSendSuper(&target, sel)) == FALSE)
		return FALSE;
	if (!isCarbonApp) {
		controller = [JEPController controllerContainingNSView:self
			timeoutType:lockTimeoutNone];
	}
	if (controller) {
		if (isJava142Update1 &&
			(controller->updatesOff || !controller->myAppletView ||
			![controller->myAppletView isDisplayable]))
		{
			return FALSE;
		}
		dirty = [(NSView *) self _dirtyRect];
		if ((dirty.size.width <= 0) || (dirty.size.height <= 0))
			return FALSE;
	}
	return (BOOL) retval;
}

BOOL PoseAsNSTextFieldAWT(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 2;
	instance_methods->method_list[0].method_name =
		sel_registerName("drawRect:");
	instance_methods->method_list[0].method_types =
		"v0@4:8{_NSRect={_NSPoint=ff}{_NSSize=ff}}12";
	instance_methods->method_list[0].method_imp =
		(IMP) drawRect_AWTTF;
	instance_methods->method_list[1].method_name =
		sel_registerName("isOpaque");
	instance_methods->method_list[1].method_types = "c0@4:8";
	instance_methods->method_list[1].method_imp =
		(IMP) isOpaque_AWTTF;

	retval = PoseAsUndocumentedClass("NSTextFieldAWT", "MyNSTextFieldAWT",
		&awtTextFieldClass, &awtTextFieldClassPoser, instance_methods, NULL);

	return retval;
}

static void drawRect_AWTTV(id self, SEL sel, NSRect aRect)
{
	struct objc_super target;
	JEPController *controller;
	target.receiver = self;
	target.class = [awtTextViewClassPoser superclass];
	controller = [JEPController controllerContainingNSView:self
		timeoutType:lockTimeoutNormal];
	if (controller && [controller destroying]) {
		if (isJava142Update1) {
			[NSBezierPath clipRect:NSZeroRect];
			objc_msgSendSuper(&target, sel, aRect);
		}
		return;
	}
	if (controller && controller->myAppletView) {
		if (controller->updatesOff ||
			![controller->myAppletView isDisplayable])
		{
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			/* Without this line, "TextField" objects sometimes get drawn
			 * outside the applet's bounds.
			 */
			[AppletView clipWithTranslation:self controller:controller];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"NSTextViewAWT drawRect:  On %@", self);
#endif
	objc_msgSendSuper(&target, sel, aRect);
}

BOOL PoseAsNSTextViewAWT(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 1;
	instance_methods->method_list[0].method_name =
		sel_registerName("drawRect:");
	instance_methods->method_list[0].method_types =
		"v0@4:8{_NSRect={_NSPoint=ff}{_NSSize=ff}}12";
	instance_methods->method_list[0].method_imp =
		(IMP) drawRect_AWTTV;

	retval = PoseAsUndocumentedClass("NSTextViewAWT", "MyNSTextViewAWT",
		&awtTextViewClass, &awtTextViewClassPoser, instance_methods, NULL);

	return retval;
}

static void drawRect_AWTTFF(id self, SEL sel, NSRect aRect)
{
	struct objc_super target;
	JEPController *controller;
	target.receiver = self;
	target.class = [awtTextFieldFocusClassPoser superclass];
	controller = [JEPController controllerContainingNSView:self
		timeoutType:lockTimeoutNormal];
	if (controller && [controller destroying]) {
		if (isJava142Update1) {
			[NSBezierPath clipRect:NSZeroRect];
			objc_msgSendSuper(&target, sel, aRect);
		}
		return;
	}
	if (controller && controller->myAppletView) {
		if (controller->updatesOff ||
			![controller->myAppletView isDisplayable])
		{
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			[AppletView clipWithTranslation:self controller:controller];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"NSTextFieldFocusView drawRect:  On %@", self);
#endif
	objc_msgSendSuper(&target, sel, aRect);
}

BOOL PoseAsNSTextFieldFocusView(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 1;
	instance_methods->method_list[0].method_name =
		sel_registerName("drawRect:");
	instance_methods->method_list[0].method_types =
		"v0@4:8{_NSRect={_NSPoint=ff}{_NSSize=ff}}12";
	instance_methods->method_list[0].method_imp =
		(IMP) drawRect_AWTTFF;

	retval = PoseAsUndocumentedClass("NSTextFieldFocusView", "MyNSTextFieldFocusView",
		&awtTextFieldFocusClass, &awtTextFieldFocusClassPoser, instance_methods, NULL);

	return retval;
}

static void drawRect_AWTWV(id self, SEL sel, NSRect aRect)
{
	struct objc_super target;
	JEPController *controller;
	target.receiver = self;
	target.class = [awtWindowViewClassPoser superclass];
	if (!isJava142Update1) {
		objc_msgSendSuper(&target, sel, aRect);
		return;
	}
	controller = [JEPController controllerContainingNSView:self
		timeoutType:lockTimeoutNormal];
	if (controller && [controller destroying]) {
		/* We hung here once, in Camino, on quitting, in OS X 10.4.2, while
		 * trying to post a paint event in our superclass.
		 */
		//[NSBezierPath clipRect:NSZeroRect];
		//objc_msgSendSuper(&target, sel, aRect);
		return;
	}
	if (controller && controller->myAppletView) {
		if (controller->updatesOff ||
			![controller->myAppletView isDisplayable])
		{
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			[AppletView clipWithTranslation:self controller:controller];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"NSWindowViewAWT drawRect:  On %@", self);
#endif
	objc_msgSendSuper(&target, sel, aRect);
}

/* You get lots of crashes in NSWindowViewAWT resizeTimerEvent (in OS X
 * 10.2.8) when you "aggressively" resize map24.com's maps in a Cocoa browser.
 * The following works around the problem without (as far as I can tell) any
 * side effects.  (You still get crashes in one or more other locations, but
 * I haven't yet been able to pin those down -- even gdb freezes when they
 * happen.)
 */
static void viewDidEndLiveResize_AWTWV(id self, SEL sel)
{
	struct objc_super target;
	target.receiver = self;
	if (isCarbonApp) {
		target.class = [awtWindowViewClassPoser superclass];
	} else {
		target.class = [NSView class];
	}
	objc_msgSendSuper(&target, sel);
}

static void viewWillStartLiveResize_AWTWV(id self, SEL sel)
{
	struct objc_super target;
	target.receiver = self;
	if (isCarbonApp) {
		target.class = [awtWindowViewClassPoser superclass];
	} else {
		target.class = [NSView class];
	}
	objc_msgSendSuper(&target, sel);
}

BOOL PoseAsNSWindowViewAWT(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 3;
	instance_methods->method_list[0].method_name =
		sel_registerName("drawRect:");
	instance_methods->method_list[0].method_types =
		"v0@4:8{_NSRect={_NSPoint=ff}{_NSSize=ff}}12";
	instance_methods->method_list[0].method_imp =
		(IMP) drawRect_AWTWV;
	instance_methods->method_list[1].method_name =
		sel_registerName("viewDidEndLiveResize");
	instance_methods->method_list[1].method_types = "v0@4:8";
	instance_methods->method_list[1].method_imp =
		(IMP) viewDidEndLiveResize_AWTWV;
	instance_methods->method_list[2].method_name =
		sel_registerName("viewWillStartLiveResize");
	instance_methods->method_list[2].method_types = "v0@4:8";
	instance_methods->method_list[2].method_imp =
		(IMP) viewWillStartLiveResize_AWTWV;

	retval = PoseAsUndocumentedClass("NSWindowViewAWT", "MyNSWindowViewAWT",
		&awtWindowViewClass, &awtWindowViewClassPoser, instance_methods, NULL);

	return retval;
}

static void drawRect_AWTCTF(id self, SEL sel, NSRect aRect)
{
	struct objc_super target;
	JEPController *controller;
	target.receiver = self;
	target.class = [awtCombTextFieldClassPoser superclass];
	controller = [JEPController controllerContainingNSView:self
		timeoutType:lockTimeoutNormal];
	if (controller && [controller destroying]) {
		if (isJava142Update1) {
			[NSBezierPath clipRect:NSZeroRect];
			objc_msgSendSuper(&target, sel, aRect);
		}
		return;
	}
	if (controller && controller->myAppletView) {
		if (controller->updatesOff ||
			![controller->myAppletView isDisplayable])
		{
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			[AppletView clipWithTranslation:self controller:controller];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"AWTCombinedTextField drawRect:  On %@", self);
#endif
	objc_msgSendSuper(&target, sel, aRect);
}

static BOOL isOpaque_AWTCTF(id self, SEL sel)
{
	int retval;
	NSRect dirty;
	JEPController *controller = nil;
	struct objc_super target;
	target.receiver = self;
	target.class = [awtCombTextFieldClassPoser superclass];
	if ((retval = (int) objc_msgSendSuper(&target, sel)) == FALSE)
		return FALSE;
	if (!isCarbonApp) {
		controller = [JEPController controllerContainingNSView:self
			timeoutType:lockTimeoutNone];
	}
	if (controller) {
		if (isJava142Update1 &&
			(controller->updatesOff || !controller->myAppletView ||
			![controller->myAppletView isDisplayable]))
		{
			return FALSE;
		}
		dirty = [(NSView *) self _dirtyRect];
		if ((dirty.size.width <= 0) || (dirty.size.height <= 0))
			return FALSE;
	}
	return (BOOL) retval;
}

BOOL PoseAsAWTCombinedTextField(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 2;
	instance_methods->method_list[0].method_name =
		sel_registerName("drawRect:");
	instance_methods->method_list[0].method_types =
		"v0@4:8{_NSRect={_NSPoint=ff}{_NSSize=ff}}12";
	instance_methods->method_list[0].method_imp =
		(IMP) drawRect_AWTCTF;
	instance_methods->method_list[1].method_name =
		sel_registerName("isOpaque");
	instance_methods->method_list[1].method_types = "c0@4:8";
	instance_methods->method_list[1].method_imp =
		(IMP) isOpaque_AWTCTF;

	retval = PoseAsUndocumentedClass("AWTCombinedTextField", "MyAWTCombinedTextField",
		&awtCombTextFieldClass, &awtCombTextFieldClassPoser, instance_methods, NULL);

	return retval;
}

static void drawRect_AWTCTFC(id self, SEL sel, NSRect aRect)
{
	struct objc_super target;
	JEPController *controller;
	target.receiver = self;
	target.class = [awtCombTextFieldCellClassPoser superclass];
	controller = [JEPController controllerContainingNSView:self
		timeoutType:lockTimeoutNormal];
	if (controller && [controller destroying]) {
		if (isJava142Update1) {
			[NSBezierPath clipRect:NSZeroRect];
			objc_msgSendSuper(&target, sel, aRect);
		}
		return;
	}
	if (controller && controller->myAppletView) {
		if (controller->updatesOff ||
			![controller->myAppletView isDisplayable])
		{
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			[AppletView clipWithTranslation:self controller:controller];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"AWTCombinedTextFieldCell drawRect:  On %@", self);
#endif
	objc_msgSendSuper(&target, sel, aRect);
}

BOOL PoseAsAWTCombinedTextFieldCell(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 1;
	instance_methods->method_list[0].method_name =
		sel_registerName("drawRect:");
	instance_methods->method_list[0].method_types =
		"v0@4:8{_NSRect={_NSPoint=ff}{_NSSize=ff}}12";
	instance_methods->method_list[0].method_imp =
		(IMP) drawRect_AWTCTFC;

	retval = PoseAsUndocumentedClass("AWTCombinedTextFieldCell", "MyAWTCombinedTextFieldCell",
		&awtCombTextFieldCellClass, &awtCombTextFieldCellClassPoser, instance_methods, NULL);

	return retval;
}

static void drawRect_AWTCTV(id self, SEL sel, NSRect aRect)
{
	struct objc_super target;
	JEPController *controller;
	target.receiver = self;
	target.class = [awtCombTextViewClassPoser superclass];
	controller = [JEPController controllerContainingNSView:self
		timeoutType:lockTimeoutNormal];
	if (controller && [controller destroying]) {
		if (isJava142Update1) {
			[NSBezierPath clipRect:NSZeroRect];
			objc_msgSendSuper(&target, sel, aRect);
		}
		return;
	}
	if (controller && controller->myAppletView) {
		if (controller->updatesOff ||
			![controller->myAppletView isDisplayable])
		{
			[NSBezierPath clipRect:NSZeroRect];
		} else {
			/* Without this line, "TextField" objects sometimes get drawn
			 * outside the applet's bounds.
			 */
			[AppletView clipWithTranslation:self controller:controller];
		}
	}
#ifdef DEBUG_EVENTS
	NSLog(@"AWTCombinedTextView drawRect:  On %@", self);
#endif
	objc_msgSendSuper(&target, sel, aRect);
}

/* Some of the code that calls the setAWTDelegate method is broken in
 * Java 1.4.2 (at least Update 1) in a Carbon browser -- when we switch
 * between applets in tabs, sometimes an AWTCombinedTextView object in the
 * current tab is given an AWT delegate from one of the other tabs!  (For an
 * example of this, load Sun's ArcTest sample in one tab and one of
 * http://www.intellicast.com's interactive local radar looping applets in
 * another.  A non-editable AWTCombinedTextView object on the Intellicast
 * tab has the same location on the page as ArcTest's left-most (editable)
 * AWTCombinedTextView object.  If you switch from the Intellicast tab back
 * to the ArcTest tab and click in its left-most text box, you won't be able
 * to enter any text until you click somewhere else on the page and then click
 * in that box a second time.  If you do sufficient logging, you'll see that
 * (initially) the ArcTest's text box's delegate has been set to the delegate
 * of one of the Intellicast text boxes!)  By a lucky chance the setDelegate
 * method seems always to be used correctly, and we can substitute its results
 * for that of the setAWTDelegate method.  This hasn't yet been fixed in Tiger.
 */
static void setAWTDelegate_AWTCTV(id self, SEL sel, id anObject)
{
	struct objc_super target;
	if (isCarbonApp && isJava142)
		return;
	target.receiver = self;
	target.class = [awtCombTextViewClassPoser superclass];
	objc_msgSendSuper(&target, sel, anObject);
}

static void setDelegate_AWTCTV(id self, SEL sel, id anObject)
{
	struct objc_super target;
	target.receiver = self;
	target.class = [awtCombTextViewClassPoser superclass];
	objc_msgSendSuper(&target, sel, anObject);
	if (isCarbonApp && isJava142) {
		objc_msgSendSuper(&target, @selector(setAWTDelegate:), anObject);
	}
}

BOOL PoseAsAWTCombinedTextView(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 3;
	instance_methods->method_list[0].method_name =
		sel_registerName("drawRect:");
	instance_methods->method_list[0].method_types =
		"v0@4:8{_NSRect={_NSPoint=ff}{_NSSize=ff}}12";
	instance_methods->method_list[0].method_imp =
		(IMP) drawRect_AWTCTV;
	instance_methods->method_list[1].method_name =
		sel_registerName("setAWTDelegate:");
	instance_methods->method_list[1].method_types = "v0@4:8@12";
	instance_methods->method_list[1].method_imp =
		(IMP) setAWTDelegate_AWTCTV;
	instance_methods->method_list[2].method_name =
		sel_registerName("setDelegate:");
	instance_methods->method_list[2].method_types = "v0@4:8@12";
	instance_methods->method_list[2].method_imp =
		(IMP) setDelegate_AWTCTV;

	retval = PoseAsUndocumentedClass("AWTCombinedTextView", "MyAWTCombinedTextView",
		&awtCombTextViewClass, &awtCombTextViewClassPoser, instance_methods, NULL);

	return retval;
}

/* This method and class are only used in Java 1.4.2 Update 1 or later.  But
 * in Update 1 and Update 2 we can get crashes or hangs when this method is
 * called on an object whose applet is being deleted.  This problem seems to
 * have been fixed in Tiger ... which in any case no longer has an
 * NSViewAWTContext class.
 */
static void tickFlusher_AWTCTX(id self, SEL sel)
{
	struct objc_super target;
	if (!((NSViewAWTContext *)self)->alive ||
		!((NSViewAWTContext *)self)->enabled)
		return;
	target.receiver = self;
	target.class = [awtViewContextClassPoser superclass];
	objc_msgSendSuper(&target, sel);
}

BOOL PoseAsNSViewAWTContext(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 1;
	instance_methods->method_list[0].method_name =
		sel_registerName("tickFlusher");
	instance_methods->method_list[0].method_types = "v0@4:8";
	instance_methods->method_list[0].method_imp =
		(IMP) tickFlusher_AWTCTX;

	retval = PoseAsUndocumentedClass("NSViewAWTContext", "MyNSViewAWTContext",
		&awtViewContextClass, &awtViewContextClassPoser, instance_methods, NULL);

	return retval;
}

/* This obscure fix works around an obscure bug in Tiger that causes
 * [NSView setNeedsDisplay] to not work properly on views that contain images
 * (or other objects) that are drawn asynchronously (or lazily) -- without
 * this fix it corrupts the display and stops further updates from happening.
 * A good example is the Video applet at
 * http://java.sun.com/j2se/jre_check/index.jsp.
 */
static CGContextRef getContext_ADCM(id self, SEL sel, char *unknown,
	BOOL canDrawDuringLiveResize)
{
	CGContextRef retval = nil;
	id cWindow = nil;
	JEPController *controller = nil;
	struct objc_super target;
	target.receiver = self;
	target.class = [awtDrawableCtxManagerClassPoser superclass];
	cWindow = [self cWindow];
	controller = [JEPController controllerFromCWindow:cWindow
		timeoutType:lockTimeoutNormal];
	if (controller) {
		if (!controller->myAppletView || ![controller->myAppletView isDisplayable]) {
#ifdef DEBUG_EVENTS
			NSLog(@"AWTDrawableContextManager getContext: controller %@ not displayable", controller);
#endif
			return nil;
		}
		objc_msgSendSuper(&target, @selector(markOutOfSync:), true);
	}

	retval = (CGContextRef) objc_msgSendSuper(&target, sel, unknown, canDrawDuringLiveResize);
#ifdef DEBUG_EVENTS
	NSLog(@"AWTDrawableContextManager getContext: unknown %s, canDrawDuringLiveResize %s, controller %@, cWindow %@, returning 0x%.8X",
		unknown, canDrawDuringLiveResize ? "true" : "false", controller, cWindow, retval);
#endif
	return retval;
}

BOOL PoseAsAWTDrawableContextManager(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 1;

	instance_methods->method_list[0].method_name =
		sel_registerName("getContext:canDrawDuringLiveResize:");
	instance_methods->method_list[0].method_types =
		"^{CGContext=}0@4:8*12c16";
	instance_methods->method_list[0].method_imp =
		(IMP) getContext_ADCM;

	retval = PoseAsUndocumentedClass("AWTDrawableContextManager", "MyAWTDrawableContextManager",
		&awtDrawableCtxManagerClass, &awtDrawableCtxManagerClassPoser, instance_methods, NULL);

	return retval;
}

/* This method is only available on Panther and Tiger.  For more information
 * see performOnMainThread_TU() (above) and the comment on the CustomEvent
 * class in AppletView.m.
 */
static void start_AWTST(id self, SEL sel, BOOL whatever)
{
	[AppletView performOnMainThread:@selector(startAWT:) onTarget:self
		withObject:[NSNumber numberWithBool:whatever] waitUntilDone:true];
}

BOOL PoseAsAWTStarter(void)
{
	BOOL retval;
	struct objc_method_list *class_methods;

	if ((class_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	class_methods->obsolete = nil;
	class_methods->method_count = 1;
	class_methods->method_list[0].method_name =
		sel_registerName("start:");
	class_methods->method_list[0].method_types = "v0@4:8c12";
	class_methods->method_list[0].method_imp =
		(IMP) start_AWTST;

	retval = PoseAsUndocumentedClass("AWTStarter", "MyAWTStarter",
		&awtStarterClass, &awtStarterClassPoser, NULL, class_methods);

	return retval;
}

/* This method is only available on Jaguar.  For more information see
 * performOnMainThread_TU() (above) and the comment on the CustomEvent
 * class in AppletView.m.
 */
static void beginApp_SU(id self, SEL sel)
{
	[AppletView performOnMainThread:@selector(runAppKit:) onTarget:self
		withObject:nil waitUntilDone:true];
}

BOOL PoseAsStartupUtility(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 1;
	instance_methods->method_list[0].method_name =
		sel_registerName("beginApp");
	instance_methods->method_list[0].method_types = "v0@4:8";
	instance_methods->method_list[0].method_imp =
		(IMP) beginApp_SU;

	retval = PoseAsUndocumentedClass("StartupUtility", "MyStartupUtility",
		&startupUtilityClass, &startupUtilityClassPoser, instance_methods, NULL);

	return retval;
}

/* Apple's implementation of Java 1.4.2_09 (at least) calls "release" on an
 * AwtException object that has already been autoreleased (as it was created).
 * This leads to crashes in NSPopAutoreleasePool.  To work around this we
 * send an extra "retain" message as the object is autoreleased.  This causes
 * these objects to leak ... but that's better than a crash.  And in any case
 * the JVM usually stops working after an AwtException has been "thrown" --
 * which means that you have to quit the browser and restart it.  So not too
 * many of these objects will get leaked.
 */
static id autorelease_AWTEX(id self, SEL sel)
{
	id retval;
	struct objc_super target;
	target.receiver = self;
	target.class = [awtExceptionClassPoser superclass];
	retval = objc_msgSendSuper(&target, sel);
	NSLog(@"AwtException autorelease: self %@, returning %@", self, retval);
	return [retval retain];
}

BOOL PoseAsAwtException(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 1;
	instance_methods->method_list[0].method_name =
		sel_registerName("autorelease");
	instance_methods->method_list[0].method_types = "@0@4:8";
	instance_methods->method_list[0].method_imp =
		(IMP) autorelease_AWTEX;

	retval = PoseAsUndocumentedClass("AwtException", "MyAwtException",
		&awtExceptionClass, &awtExceptionClassPoser, instance_methods, NULL);

	return retval;
}

/* This method appears to always be called on the main thread.  But still I
 * always check before calling NSAppShadow dismissJavaPopupMenu.  For more
 * info see the PopupInfo class definition in Controller.m.  This problem
 * seems to be fixed in Java 1.6.0 (which in any case doesn't have a
 * safeShowAtSpot: method).
 */
static void safeShowAtSpot_CPM(id self, SEL sel, id unused)
{
	PopupInfo *info;
	NSThread *currentThread;
	struct objc_super target;
#ifdef DEBUG_EVENTS
	NSLog(@"CPopupMenu safeShowAtSpot before: self %@, unused %@", self, unused);
#endif
	currentThread = [NSThread currentThread];
	if (isCarbonApp && (osxVersion >= 0x1030)) {
		if (nsAppShadow && mainThread && [mainThread isEqual:currentThread]) {
			info = [PopupInfo getVisible];
			if (info && ([info getModel] == self)) {
				[nsAppShadow dismissJavaPopupMenu];
				return;
			}
		}
		[PopupInfo setVisible:self];
	}
	target.receiver = self;
	target.class = [cPopupMenuClassPoser superclass];
	objc_msgSendSuper(&target, sel, unused);
#ifdef DEBUG_EVENTS
	NSLog(@"CPopupMenu safeShowAtSpot after: self %@, unused %@", self, unused);
#endif
}

static void setComponent_CPM(id self, SEL sel, id aComponent)
{
	id parent = nil;
	NSView *view = nil;
	NSMenu *menu = nil;
	JEPController *controller = nil;
	struct objc_super target;
	target.receiver = self;
	target.class = [cPopupMenuClassPoser superclass];
	objc_msgSendSuper(&target, sel, aComponent);
	if (isCarbonApp && (osxVersion >= 0x1030) && aComponent &&
		[self respondsToSelector:@selector(safeShowAtSpot:)])
	{
		menu = [self menu];
		parent = aComponent;
		while (parent) {
			if ((view = [parent getView]) != nil)
				break;
			parent = [parent getParent];
		}
		controller = [JEPController controllerContainingNSView:view
			timeoutType:lockTimeoutNormal];
		[PopupInfo addInfo:[[PopupInfo alloc]
			initWithParams:self menu:menu controller:controller]];
	}
#ifdef DEBUG_EVENTS
	NSLog(@"CPopupMenu setComponent: self %@, menu %@, aComponent %@, parent %@, view %@, controller %@",
		self, menu, aComponent, parent, view, controller);
#endif
}

BOOL PoseAsCPopupMenu(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 2;
	instance_methods->method_list[0].method_name =
		sel_registerName("safeShowAtSpot:");
	instance_methods->method_list[0].method_types = "v0@4:8@12";
	instance_methods->method_list[0].method_imp =
		(IMP) safeShowAtSpot_CPM;
	instance_methods->method_list[1].method_name =
		sel_registerName("setComponent:");
	instance_methods->method_list[1].method_types = "v0@4:8@12";
	instance_methods->method_list[1].method_imp =
		(IMP) setComponent_CPM;

	retval = PoseAsUndocumentedClass("CPopupMenu", "MyCPopupMenu",
		&cPopupMenuClass, &cPopupMenuClassPoser, instance_methods, NULL);

	return retval;
}

/* Resolves a nasty (but rarely encountered) bug in Apple's JVMs:  Sometimes
 * you see the following error while pressing some odd key combination in a
 * Java applet -- 'Attempt to call non-applicable method "keyCode" on
 * SyntheticEvent!'.  Apparently you're not supposed to call the "keyCode"
 * method on a SyntheticEvent object, and Apple has therefore given this class
 * a booby-trapped "keyCode" method (it throws an exception).  But this method
 * does sometimes still get called, with predictably nasty results.  Using the
 * superclass's (NSEvent's) "keyCode" method gets around the problem.
 */
static unsigned short keyCode_SE(id self, SEL sel)
{
	int retval;
	struct objc_super target;
	target.receiver = self;
	target.class = [NSEvent class];
	retval = (int) objc_msgSendSuper(&target, sel);
	return (unsigned short) retval;
}

BOOL PoseAsSyntheticEvent(void)
{
	BOOL retval;
	struct objc_method_list *instance_methods;

	if ((instance_methods =
		calloc(10, sizeof(struct objc_method_list))) == nil)
		return FALSE;
	instance_methods->obsolete = nil;
	instance_methods->method_count = 1;
	instance_methods->method_list[0].method_name =
		sel_registerName("keyCode");
	instance_methods->method_list[0].method_types = "S0@4:8";
	instance_methods->method_list[0].method_imp =
		(IMP) keyCode_SE;

	retval = PoseAsUndocumentedClass("SyntheticEvent", "MySyntheticEvent",
		&syntheticEventClass, &syntheticEventClassPoser, instance_methods, NULL);

	return retval;
}

